/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2011 Google Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GOOGLE, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebCore {

enum EventInterface {
#if ENABLE(APPLE_PAY)
    ApplePayCancelEventInterfaceType = 1,
    ApplePayPaymentAuthorizedEventInterfaceType = 2,
    ApplePayPaymentMethodSelectedEventInterfaceType = 3,
    ApplePayShippingContactSelectedEventInterfaceType = 4,
    ApplePayShippingMethodSelectedEventInterfaceType = 5,
    ApplePayValidateMerchantEventInterfaceType = 6,
#endif
#if ENABLE(DEVICE_ORIENTATION)
    DeviceMotionEventInterfaceType = 7,
    DeviceOrientationEventInterfaceType = 8,
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    MediaEncryptedEventInterfaceType = 9,
    MediaKeyMessageEventInterfaceType = 10,
#endif
#if ENABLE(GAMEPAD)
    GamepadEventInterfaceType = 11,
#endif
#if ENABLE(INDEXED_DATABASE)
    IDBVersionChangeEventInterfaceType = 12,
#endif
#if ENABLE(IOS_GESTURE_EVENTS) || ENABLE(MAC_GESTURE_EVENTS)
    GestureEventInterfaceType = 13,
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    WebKitMediaKeyMessageEventInterfaceType = 14,
    WebKitMediaKeyNeededEventInterfaceType = 15,
#endif
#if ENABLE(MEDIA_STREAM)
    BlobEventInterfaceType = 16,
    MediaRecorderErrorEventInterfaceType = 17,
    MediaStreamTrackEventInterfaceType = 18,
    OverconstrainedErrorEventInterfaceType = 19,
#endif
#if ENABLE(ORIENTATION_EVENTS)
#endif
#if ENABLE(PAYMENT_REQUEST)
    MerchantValidationEventInterfaceType = 20,
    PaymentMethodChangeEventInterfaceType = 21,
    PaymentRequestUpdateEventInterfaceType = 22,
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
    EnterPictureInPictureEventInterfaceType = 23,
#endif
#if ENABLE(POINTER_EVENTS)
    PointerEventInterfaceType = 24,
#endif
#if ENABLE(SERVICE_WORKER)
    ExtendableEventInterfaceType = 25,
    ExtendableMessageEventInterfaceType = 26,
    FetchEventInterfaceType = 27,
#endif
#if ENABLE(SPEECH_SYNTHESIS)
    SpeechSynthesisEventInterfaceType = 28,
#endif
#if ENABLE(TOUCH_EVENTS)
    TouchEventInterfaceType = 29,
#endif
#if ENABLE(VIDEO_TRACK)
    TrackEventInterfaceType = 30,
#endif
#if ENABLE(WEBGL)
    WebGLContextEventInterfaceType = 31,
#endif
#if ENABLE(WEBGPU)
    GPUUncapturedErrorEventInterfaceType = 32,
#endif
#if ENABLE(WEB_AUDIO)
    AudioProcessingEventInterfaceType = 33,
    OfflineAudioCompletionEventInterfaceType = 34,
#endif
#if ENABLE(WEB_RTC)
    RTCDTMFToneChangeEventInterfaceType = 35,
    RTCDataChannelEventInterfaceType = 36,
    RTCPeerConnectionIceEventInterfaceType = 37,
    RTCTrackEventInterfaceType = 38,
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
    WebKitPlaybackTargetAvailabilityEventInterfaceType = 39,
#endif
    AnimationEventInterfaceType = 40,
    AnimationPlaybackEventInterfaceType = 41,
    BeforeLoadEventInterfaceType = 42,
    BeforeUnloadEventInterfaceType = 43,
    ClipboardEventInterfaceType = 44,
    CloseEventInterfaceType = 45,
    CompositionEventInterfaceType = 46,
    CustomEventInterfaceType = 47,
    DragEventInterfaceType = 48,
    ErrorEventInterfaceType = 49,
    EventInterfaceType = 50,
    FocusEventInterfaceType = 51,
    HashChangeEventInterfaceType = 52,
    InputEventInterfaceType = 53,
    KeyboardEventInterfaceType = 54,
    MessageEventInterfaceType = 55,
    MouseEventInterfaceType = 56,
    MutationEventInterfaceType = 57,
    OverflowEventInterfaceType = 58,
    PageTransitionEventInterfaceType = 59,
    PopStateEventInterfaceType = 60,
    ProgressEventInterfaceType = 61,
    PromiseRejectionEventInterfaceType = 62,
    SVGZoomEventInterfaceType = 63,
    SecurityPolicyViolationEventInterfaceType = 64,
    StorageEventInterfaceType = 65,
    TextEventInterfaceType = 66,
    TransitionEventInterfaceType = 67,
    UIEventInterfaceType = 68,
    WebKitAnimationEventInterfaceType = 69,
    WebKitTransitionEventInterfaceType = 70,
    WheelEventInterfaceType = 71,
    XMLHttpRequestProgressEventInterfaceType = 72,
};

} // namespace WebCore
