/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCompositeOperationOrAuto.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(CompositeOperationOrAuto enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("replace"),
        MAKE_STATIC_STRING_IMPL("add"),
        MAKE_STATIC_STRING_IMPL("accumulate"),
        MAKE_STATIC_STRING_IMPL("auto"),
    };
    static_assert(static_cast<size_t>(CompositeOperationOrAuto::Replace) == 0, "CompositeOperationOrAuto::Replace is not 0 as expected");
    static_assert(static_cast<size_t>(CompositeOperationOrAuto::Add) == 1, "CompositeOperationOrAuto::Add is not 1 as expected");
    static_assert(static_cast<size_t>(CompositeOperationOrAuto::Accumulate) == 2, "CompositeOperationOrAuto::Accumulate is not 2 as expected");
    static_assert(static_cast<size_t>(CompositeOperationOrAuto::Auto) == 3, "CompositeOperationOrAuto::Auto is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, CompositeOperationOrAuto enumerationValue)
{
    return jsStringWithCache(&lexicalGlobalObject, convertEnumerationToString(enumerationValue));
}

template<> Optional<CompositeOperationOrAuto> parseEnumeration<CompositeOperationOrAuto>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    auto stringValue = value.toWTFString(&lexicalGlobalObject);
    if (stringValue == "replace")
        return CompositeOperationOrAuto::Replace;
    if (stringValue == "add")
        return CompositeOperationOrAuto::Add;
    if (stringValue == "accumulate")
        return CompositeOperationOrAuto::Accumulate;
    if (stringValue == "auto")
        return CompositeOperationOrAuto::Auto;
    return WTF::nullopt;
}

template<> const char* expectedEnumerationValues<CompositeOperationOrAuto>()
{
    return "\"replace\", \"add\", \"accumulate\", \"auto\"";
}

} // namespace WebCore
