/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_AUDIO)

#include "JSAudioNode.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "WaveShaperNode.h"

namespace WebCore {

class JSWaveShaperNode : public JSAudioNode {
public:
    using Base = JSAudioNode;
    using DOMWrapped = WaveShaperNode;
    static JSWaveShaperNode* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<WaveShaperNode>&& impl)
    {
        JSWaveShaperNode* ptr = new (NotNull, JSC::allocateCell<JSWaveShaperNode>(globalObject->vm().heap)) JSWaveShaperNode(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    WaveShaperNode& wrapped() const
    {
        return static_cast<WaveShaperNode&>(Base::wrapped());
    }
protected:
    JSWaveShaperNode(JSC::Structure*, JSDOMGlobalObject&, Ref<WaveShaperNode>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, WaveShaperNode&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WaveShaperNode* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<WaveShaperNode>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<WaveShaperNode>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<WaveShaperNode> {
    using WrapperClass = JSWaveShaperNode;
    using ToWrappedReturnType = WaveShaperNode*;
};
String convertEnumerationToString(WaveShaperNode::OverSampleType);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, WaveShaperNode::OverSampleType);

template<> Optional<WaveShaperNode::OverSampleType> parseEnumeration<WaveShaperNode::OverSampleType>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<WaveShaperNode::OverSampleType>();


} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
