/*
 * Copyright (C) 2010-2019 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

#if ENABLE(NETSCAPE_PLUGIN_API)

#include "ShareableBitmap.h"
#include <wtf/Forward.h>
#include <wtf/text/WTFString.h>


namespace Messages {
namespace PluginControllerProxy {

using HandleWheelEventDelayedReply = CompletionHandler<void(bool handled)>;

using HandleMouseEnterEventDelayedReply = CompletionHandler<void(bool handled)>;

using HandleMouseLeaveEventDelayedReply = CompletionHandler<void(bool handled)>;

using HandleKeyboardEventDelayedReply = CompletionHandler<void(bool handled)>;

using HandleEditingCommandDelayedReply = CompletionHandler<void(bool handled)>;

using IsEditingCommandEnabledDelayedReply = CompletionHandler<void(bool enabled)>;

using HandlesPageScaleFactorDelayedReply = CompletionHandler<void(bool enabled)>;

using RequiresUnifiedScaleFactorDelayedReply = CompletionHandler<void(bool required)>;

using PaintEntirePluginDelayedReply = CompletionHandler<void()>;

using GetPluginScriptableNPObjectDelayedReply = CompletionHandler<void(uint64_t pluginScriptableNPObjectID)>;

using SupportsSnapshottingDelayedReply = CompletionHandler<void(bool isSupported)>;

using SnapshotDelayedReply = CompletionHandler<void(const WebKit::ShareableBitmap::Handle& backingStoreHandle)>;

using GetFormValueDelayedReply = CompletionHandler<void(bool returnValue, const String& formValue)>;

} // namespace PluginControllerProxy
} // namespace Messages

#endif // ENABLE(NETSCAPE_PLUGIN_API)
