/*
* THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
*
* Copyright (C) 2018 Apple Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
* 1. Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
* 2. Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
* THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesKeys.h"

namespace WebKit {

void WebPreferences::setAriaReflectionEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::ariaReflectionEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::ariaReflectionEnabledKey(), value);
}

bool WebPreferences::ariaReflectionEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::ariaReflectionEnabledKey());
}

void WebPreferences::setAllowViewportShrinkToFitContent(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::allowViewportShrinkToFitContentKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::allowViewportShrinkToFitContentKey(), value);
}

bool WebPreferences::allowViewportShrinkToFitContent() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::allowViewportShrinkToFitContentKey());
}

void WebPreferences::setApplePayRemoteUIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::applePayRemoteUIEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::applePayRemoteUIEnabledKey(), value);
}

bool WebPreferences::applePayRemoteUIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::applePayRemoteUIEnabledKey());
}

void WebPreferences::setAsyncFrameScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::asyncFrameScrollingEnabledKey(), value);
}

bool WebPreferences::asyncFrameScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncFrameScrollingEnabledKey());
}

void WebPreferences::setAsyncOverflowScrollingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::asyncOverflowScrollingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::asyncOverflowScrollingEnabledKey(), value);
}

bool WebPreferences::asyncOverflowScrollingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::asyncOverflowScrollingEnabledKey());
}

void WebPreferences::setBlockingOfSmallPluginsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::blockingOfSmallPluginsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::blockingOfSmallPluginsEnabledKey(), value);
}

bool WebPreferences::blockingOfSmallPluginsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::blockingOfSmallPluginsEnabledKey());
}

void WebPreferences::setCSSLogicalEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssLogicalEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::cssLogicalEnabledKey(), value);
}

bool WebPreferences::cssLogicalEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssLogicalEnabledKey());
}

void WebPreferences::setCSSOMViewScrollingAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), value);
}

bool WebPreferences::cssOMViewScrollingAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey());
}

void WebPreferences::setCaptureAudioInGPUProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::captureAudioInGPUProcessEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::captureAudioInGPUProcessEnabledKey(), value);
}

bool WebPreferences::captureAudioInGPUProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::captureAudioInGPUProcessEnabledKey());
}

void WebPreferences::setCaptureAudioInUIProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::captureAudioInUIProcessEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::captureAudioInUIProcessEnabledKey(), value);
}

bool WebPreferences::captureAudioInUIProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::captureAudioInUIProcessEnabledKey());
}

void WebPreferences::setCaptureVideoInGPUProcessEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::captureVideoInGPUProcessEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::captureVideoInGPUProcessEnabledKey(), value);
}

bool WebPreferences::captureVideoInGPUProcessEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::captureVideoInGPUProcessEnabledKey());
}

void WebPreferences::setInputTypeColorEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::inputTypeColorEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::inputTypeColorEnabledKey(), value);
}

bool WebPreferences::inputTypeColorEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::inputTypeColorEnabledKey());
}

void WebPreferences::setDOMPasteAccessRequestsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::domPasteAccessRequestsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::domPasteAccessRequestsEnabledKey(), value);
}

bool WebPreferences::domPasteAccessRequestsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::domPasteAccessRequestsEnabledKey());
}

void WebPreferences::setZoomOnDoubleTapWhenRoot(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::zoomOnDoubleTapWhenRootKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::zoomOnDoubleTapWhenRootKey(), value);
}

bool WebPreferences::zoomOnDoubleTapWhenRoot() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::zoomOnDoubleTapWhenRootKey());
}

void WebPreferences::setAlwaysZoomOnDoubleTap(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::alwaysZoomOnDoubleTapKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::alwaysZoomOnDoubleTapKey(), value);
}

bool WebPreferences::alwaysZoomOnDoubleTap() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::alwaysZoomOnDoubleTapKey());
}

void WebPreferences::setDataListElementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::dataListElementEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::dataListElementEnabledKey(), value);
}

bool WebPreferences::dataListElementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::dataListElementEnabledKey());
}

void WebPreferences::setEnterKeyHintEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::enterKeyHintEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::enterKeyHintEnabledKey(), value);
}

bool WebPreferences::enterKeyHintEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::enterKeyHintEnabledKey());
}

void WebPreferences::setPreferFasterClickOverDoubleTap(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::preferFasterClickOverDoubleTapKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::preferFasterClickOverDoubleTapKey(), value);
}

bool WebPreferences::preferFasterClickOverDoubleTap() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::preferFasterClickOverDoubleTapKey());
}

void WebPreferences::setFasterClicksEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fasterClicksEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fasterClicksEnabledKey(), value);
}

bool WebPreferences::fasterClicksEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fasterClicksEnabledKey());
}

void WebPreferences::setRestrictedHTTPResponseAccess(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::restrictedHTTPResponseAccessKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::restrictedHTTPResponseAccessKey(), value);
}

bool WebPreferences::restrictedHTTPResponseAccess() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::restrictedHTTPResponseAccessKey());
}

void WebPreferences::setFrameFlatteningEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::frameFlatteningEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::frameFlatteningEnabledKey(), value);
}

bool WebPreferences::frameFlatteningEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::frameFlatteningEnabledKey());
}

void WebPreferences::setLayoutFormattingContextEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::layoutFormattingContextEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::layoutFormattingContextEnabledKey(), value);
}

bool WebPreferences::layoutFormattingContextEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::layoutFormattingContextEnabledKey());
}

void WebPreferences::setFullScreenEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::fullScreenEnabledKey(), value);
}

bool WebPreferences::fullScreenEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::fullScreenEnabledKey());
}

void WebPreferences::setKeygenElementEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::keygenElementEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::keygenElementEnabledKey(), value);
}

bool WebPreferences::keygenElementEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::keygenElementEnabledKey());
}

void WebPreferences::setIsITPDatabaseEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isITPDatabaseEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isITPDatabaseEnabledKey(), value);
}

bool WebPreferences::isITPDatabaseEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isITPDatabaseEnabledKey());
}

void WebPreferences::setTextAutosizingUsesIdempotentMode(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::textAutosizingUsesIdempotentModeKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::textAutosizingUsesIdempotentModeKey(), value);
}

bool WebPreferences::textAutosizingUsesIdempotentMode() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::textAutosizingUsesIdempotentModeKey());
}

void WebPreferences::setIsInAppBrowserPrivacyEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isInAppBrowserPrivacyEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isInAppBrowserPrivacyEnabledKey(), value);
}

bool WebPreferences::isInAppBrowserPrivacyEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isInAppBrowserPrivacyEnabledKey());
}

void WebPreferences::setLegacyOverflowScrollingTouchEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey(), value);
}

bool WebPreferences::legacyOverflowScrollingTouchEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey());
}

void WebPreferences::setUseGPUProcessForMedia(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::useGPUProcessForMediaKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::useGPUProcessForMediaKey(), value);
}

bool WebPreferences::useGPUProcessForMedia() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::useGPUProcessForMediaKey());
}

void WebPreferences::setMouseEventsSimulationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::mouseEventsSimulationEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::mouseEventsSimulationEnabledKey(), value);
}

bool WebPreferences::mouseEventsSimulationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::mouseEventsSimulationEnabledKey());
}

void WebPreferences::setLayoutFormattingContextIntegrationEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::layoutFormattingContextIntegrationEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::layoutFormattingContextIntegrationEnabledKey(), value);
}

bool WebPreferences::layoutFormattingContextIntegrationEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::layoutFormattingContextIntegrationEnabledKey());
}

void WebPreferences::setOffscreenCanvasEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::offscreenCanvasEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::offscreenCanvasEnabledKey(), value);
}

bool WebPreferences::offscreenCanvasEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::offscreenCanvasEnabledKey());
}

void WebPreferences::setExperimentalPlugInSandboxProfilesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), value);
}

bool WebPreferences::experimentalPlugInSandboxProfilesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey());
}

void WebPreferences::setSecureContextChecksEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::secureContextChecksEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::secureContextChecksEnabledKey(), value);
}

bool WebPreferences::secureContextChecksEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::secureContextChecksEnabledKey());
}

void WebPreferences::setSelectionAcrossShadowBoundariesEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), value);
}

bool WebPreferences::selectionAcrossShadowBoundariesEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey());
}

void WebPreferences::setServiceWorkersEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::serviceWorkersEnabledKey(), value);
}

bool WebPreferences::serviceWorkersEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::serviceWorkersEnabledKey());
}

void WebPreferences::setSimpleLineLayoutEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::simpleLineLayoutEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::simpleLineLayoutEnabledKey(), value);
}

bool WebPreferences::simpleLineLayoutEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::simpleLineLayoutEnabledKey());
}

void WebPreferences::setUndoManagerAPIEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::undoManagerAPIEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::undoManagerAPIEnabledKey(), value);
}

bool WebPreferences::undoManagerAPIEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::undoManagerAPIEnabledKey());
}

void WebPreferences::setWebAPIStatisticsEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webAPIStatisticsEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webAPIStatisticsEnabledKey(), value);
}

bool WebPreferences::webAPIStatisticsEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webAPIStatisticsEnabledKey());
}

void WebPreferences::setWebRTCH264SimulcastEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), value);
}

bool WebPreferences::webRTCH264SimulcastEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCH264SimulcastEnabledKey());
}

void WebPreferences::setWebRTCVP8CodecEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::webRTCVP8CodecEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::webRTCVP8CodecEnabledKey(), value);
}

bool WebPreferences::webRTCVP8CodecEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::webRTCVP8CodecEnabledKey());
}

void WebPreferences::setIsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalLiveOnTestingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalLiveOnTestingEnabledKey(), value);
}

bool WebPreferences::isFirstPartyWebsiteDataRemovalLiveOnTestingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalLiveOnTestingEnabledKey());
}

void WebPreferences::setIsFirstPartyWebsiteDataRemovalReproTestingEnabled(const bool& value)
{
    if (!m_store.setBoolValueForKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalReproTestingEnabledKey(), value))
        return;
    updateBoolValueForInternalDebugFeatureKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalReproTestingEnabledKey(), value);
}

bool WebPreferences::isFirstPartyWebsiteDataRemovalReproTestingEnabled() const
{
    return m_store.getBoolValueForKey(WebPreferencesKey::isFirstPartyWebsiteDataRemovalReproTestingEnabledKey());
}

const Vector<RefPtr<API::Object>>& WebPreferences::internalDebugFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::InternalDebugFeature::create("ARIA Reflection", "AriaReflectionEnabled", "ARIA Reflection support", true, false),
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("Allow Viewport Shrink to Fit Content", "AllowViewportShrinkToFitContent", "Allow the viewport shrink to fit content heuristic when appropriate", true, false),
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        API::InternalDebugFeature::create("Apple Pay Remote UI", "ApplePayRemoteUIEnabled", "Enable Apple Pay Remote UI", true, false),
#endif
        API::InternalDebugFeature::create("Async Frame Scrolling", "AsyncFrameScrollingEnabled", "Perform frame scrolling off the main thread", DEFAULT_ASYNC_FRAME_SCROLLING_ENABLED, false),
        API::InternalDebugFeature::create("Async Overflow Scrolling", "AsyncOverflowScrollingEnabled", "Perform overflow scrolling off the main thread", DEFAULT_ASYNC_OVERFLOW_SCROLLING_ENABLED, false),
        API::InternalDebugFeature::create("Block small plugins", "BlockingOfSmallPluginsEnabled", "Stop plugins smaller than a certain threshold from loading.", true, false),
        API::InternalDebugFeature::create("CSS Logical Properties and Values", "CSSLogicalEnabled", "Enable CSS Logical Properties and Values", false, false),
        API::InternalDebugFeature::create("CSSOM View Scrolling API", "CSSOMViewScrollingAPIEnabled", "Implement standard behavior for scrollLeft, scrollTop, scrollWidth, scrollHeight, scrollTo, scrollBy and scrollingElement.", defaultCSSOMViewScrollingAPIEnabled(), false),
#if ENABLE(MEDIA_STREAM)
        API::InternalDebugFeature::create("Capture audio in GPUProcess", "CaptureAudioInGPUProcessEnabled", "Capture audio in GPUProcess", false, false),
#endif
#if ENABLE(MEDIA_STREAM)
        API::InternalDebugFeature::create("Capture audio in UIProcess", "CaptureAudioInUIProcessEnabled", "Enable audio capture in UIProcess", DEFAULT_CAPTURE_AUDIO_IN_UIPROCESS, false),
#endif
#if ENABLE(MEDIA_STREAM)
        API::InternalDebugFeature::create("Capture video in GPUProcess", "CaptureVideoInGPUProcessEnabled", "Enable video capture in GPUProcess", false, false),
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        API::InternalDebugFeature::create("Color Inputs", "InputTypeColorEnabled", "Enable input elements of type color", DEFAULT_INPUT_TYPE_COLOR_ENABLED, false),
#endif
        API::InternalDebugFeature::create("DOM Paste Access Requests", "DOMPasteAccessRequestsEnabled", "Enable DOM Paste Access Requests", DEFAULT_DOM_PASTE_ACCESS_REQUESTS_ENABLED, false),
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("DTTZ also when root", "ZoomOnDoubleTapWhenRoot", "Double taps zoom, even if we dispatched a click on the root nodes", false, false),
#endif
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("DTTZ always", "AlwaysZoomOnDoubleTap", "Double taps zoom, even if we dispatched a click anywhere", false, false),
#endif
#if ENABLE(DATALIST_ELEMENT)
        API::InternalDebugFeature::create("DataList Element", "DataListElementEnabled", "Enable datalist elements", DEFAULT_DATALIST_ELEMENT_ENABLED, false),
#endif
        API::InternalDebugFeature::create("Enter Key Hint", "EnterKeyHintEnabled", "Enable the enterKeyHint HTML attribute", DEFAULT_ENTER_KEY_HINT_ENABLED, false),
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("Fast clicks beat DTTZ", "PreferFasterClickOverDoubleTap", "Prefer a faster click over a double tap", DEFAULT_PREFER_FASTER_CLICK_OVER_DOUBLE_TAP, false),
#endif
#if PLATFORM(IOS_FAMILY)
        API::InternalDebugFeature::create("Fast clicks", "FasterClicksEnabled", "Support faster clicks on zoomable pages", true, false),
#endif
        API::InternalDebugFeature::create("Filter HTTP Response for WebProcesses", "RestrictedHTTPResponseAccess", "Enable HTTP Response filtering for WebProcesses", true, false),
        API::InternalDebugFeature::create("Frame flattening", "FrameFlatteningEnabled", "Enable frame flattening, which adjusts the height of an iframe to fit its contents", DEFAULT_FRAME_FLATTENING, false),
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        API::InternalDebugFeature::create("Full next-generation layout (LFC)", "LayoutFormattingContextEnabled", "Enable full next-generation layout (LFC)", false, false),
#endif
#if ENABLE(FULLSCREEN_API)
        API::InternalDebugFeature::create("Fullscreen API", "FullScreenEnabled", "Fullscreen API", false, EXPERIMENTAL_FULLSCREEN_API_HIDDEN),
#endif
        API::InternalDebugFeature::create("HTMLKeygenElement", "KeygenElementEnabled", "Enables the deprecated and disabled-by-default HTML keygen element.", false, false),
        API::InternalDebugFeature::create("ITP Database Backend", "IsITPDatabaseEnabled", "Enable Intelligent Tracking Prevention Database Backend", true, false),
#if ENABLE(TEXT_AUTOSIZING)
        API::InternalDebugFeature::create("Idempotent Text Autosizing", "TextAutosizingUsesIdempotentMode", "Use idempotent text autosizing mode", defaultTextAutosizingUsesIdempotentMode(), false),
#endif
        API::InternalDebugFeature::create("In-App Browser Privacy", "IsInAppBrowserPrivacyEnabled", "Enable In-App Browser Privacy", false, false),
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        API::InternalDebugFeature::create("Legacy -webkit-overflow-scrolling property", "LegacyOverflowScrollingTouchEnabled", "Support the legacy -webkit-overflow-scrolling CSS property", true, false),
#endif
#if ENABLE(GPU_PROCESS)
        API::InternalDebugFeature::create("Media in GPU process", "UseGPUProcessForMedia", "Do all media loading and playback in the GPU process", false, false),
#endif
#if ENABLE(TOUCH_EVENTS)
        API::InternalDebugFeature::create("Mouse events simulation", "MouseEventsSimulationEnabled", "Enable mouse events dispatch along with touch events on iOS", false, false),
#endif
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        API::InternalDebugFeature::create("Next-generation line layout integration (LFC)", "LayoutFormattingContextIntegrationEnabled", "Enable next-generation line layout integration (LFC)", true, false),
#endif
#if ENABLE(OFFSCREEN_CANVAS)
        API::InternalDebugFeature::create("OffscreenCanvas", "OffscreenCanvasEnabled", "Support for the OffscreenCanvas APIs", DEFAULT_OFFSCREEN_CANVAS_ENABLED, false),
#endif
        API::InternalDebugFeature::create("Sandbox Plug-Ins", "ExperimentalPlugInSandboxProfilesEnabled", "Enable Plug-In sandboxing", false, false),
        API::InternalDebugFeature::create("Secure Context Checks", "SecureContextChecksEnabled", "Allow access to HTTPS-only Web APIs over HTTP", true, false),
        API::InternalDebugFeature::create("Selection across shadow DOM", "SelectionAcrossShadowBoundariesEnabled", "Allow user-initiated selection across shadow DOM boundaries", true, false),
#if ENABLE(SERVICE_WORKER)
        API::InternalDebugFeature::create("Service Workers", "ServiceWorkersEnabled", "Enable Service Workers", DEFAULT_SERVICE_WORKERS_ENABLED, false),
#endif
        API::InternalDebugFeature::create("Simple line layout", "SimpleLineLayoutEnabled", "Enable simple line layout path (SLL)", true, false),
        API::InternalDebugFeature::create("UndoManager DOM API", "UndoManagerAPIEnabled", "Enable the UndoManager DOM API", false, false),
        API::InternalDebugFeature::create("Web API Statistics", "WebAPIStatisticsEnabled", "Enable Web API Statistics", false, false),
#if ENABLE(WEB_RTC)
        API::InternalDebugFeature::create("WebRTC H264 Simulcast", "WebRTCH264SimulcastEnabled", "Enable WebRTC H264 Simulcast", true, false),
#endif
#if ENABLE(WEB_RTC)
        API::InternalDebugFeature::create("WebRTC VP8 codec", "WebRTCVP8CodecEnabled", "Enable WebRTC VP8 codec", true, false),
#endif
        API::InternalDebugFeature::create("[ITP Live-On] 1 Hour Timeout For Non-Cookie Data Removal", "IsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled", "Remove all non-cookie website data after just one hour of no user interaction when Intelligent Tracking Prevention is enabled", false, false),
        API::InternalDebugFeature::create("[ITP Repro] 30 Second Timeout For Non-Cookie Data Removal", "IsFirstPartyWebsiteDataRemovalReproTestingEnabled", "Remove all non-cookie website data after just 30 seconds of no user interaction when Intelligent Tracking Prevention is enabled", false, false),
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::InternalDebugFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "AriaReflectionEnabled", &WebPreferences::ariaReflectionEnabled },
#if PLATFORM(IOS_FAMILY)
        { "AllowViewportShrinkToFitContent", &WebPreferences::allowViewportShrinkToFitContent },
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        { "ApplePayRemoteUIEnabled", &WebPreferences::applePayRemoteUIEnabled },
#endif
        { "AsyncFrameScrollingEnabled", &WebPreferences::asyncFrameScrollingEnabled },
        { "AsyncOverflowScrollingEnabled", &WebPreferences::asyncOverflowScrollingEnabled },
        { "BlockingOfSmallPluginsEnabled", &WebPreferences::blockingOfSmallPluginsEnabled },
        { "CSSLogicalEnabled", &WebPreferences::cssLogicalEnabled },
        { "CSSOMViewScrollingAPIEnabled", &WebPreferences::cssOMViewScrollingAPIEnabled },
#if ENABLE(MEDIA_STREAM)
        { "CaptureAudioInGPUProcessEnabled", &WebPreferences::captureAudioInGPUProcessEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "CaptureAudioInUIProcessEnabled", &WebPreferences::captureAudioInUIProcessEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "CaptureVideoInGPUProcessEnabled", &WebPreferences::captureVideoInGPUProcessEnabled },
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        { "InputTypeColorEnabled", &WebPreferences::inputTypeColorEnabled },
#endif
        { "DOMPasteAccessRequestsEnabled", &WebPreferences::domPasteAccessRequestsEnabled },
#if PLATFORM(IOS_FAMILY)
        { "ZoomOnDoubleTapWhenRoot", &WebPreferences::zoomOnDoubleTapWhenRoot },
#endif
#if PLATFORM(IOS_FAMILY)
        { "AlwaysZoomOnDoubleTap", &WebPreferences::alwaysZoomOnDoubleTap },
#endif
#if ENABLE(DATALIST_ELEMENT)
        { "DataListElementEnabled", &WebPreferences::dataListElementEnabled },
#endif
        { "EnterKeyHintEnabled", &WebPreferences::enterKeyHintEnabled },
#if PLATFORM(IOS_FAMILY)
        { "PreferFasterClickOverDoubleTap", &WebPreferences::preferFasterClickOverDoubleTap },
#endif
#if PLATFORM(IOS_FAMILY)
        { "FasterClicksEnabled", &WebPreferences::fasterClicksEnabled },
#endif
        { "RestrictedHTTPResponseAccess", &WebPreferences::restrictedHTTPResponseAccess },
        { "FrameFlatteningEnabled", &WebPreferences::frameFlatteningEnabled },
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        { "LayoutFormattingContextEnabled", &WebPreferences::layoutFormattingContextEnabled },
#endif
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::fullScreenEnabled },
#endif
        { "KeygenElementEnabled", &WebPreferences::keygenElementEnabled },
        { "IsITPDatabaseEnabled", &WebPreferences::isITPDatabaseEnabled },
#if ENABLE(TEXT_AUTOSIZING)
        { "TextAutosizingUsesIdempotentMode", &WebPreferences::textAutosizingUsesIdempotentMode },
#endif
        { "IsInAppBrowserPrivacyEnabled", &WebPreferences::isInAppBrowserPrivacyEnabled },
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        { "LegacyOverflowScrollingTouchEnabled", &WebPreferences::legacyOverflowScrollingTouchEnabled },
#endif
#if ENABLE(GPU_PROCESS)
        { "UseGPUProcessForMedia", &WebPreferences::useGPUProcessForMedia },
#endif
#if ENABLE(TOUCH_EVENTS)
        { "MouseEventsSimulationEnabled", &WebPreferences::mouseEventsSimulationEnabled },
#endif
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        { "LayoutFormattingContextIntegrationEnabled", &WebPreferences::layoutFormattingContextIntegrationEnabled },
#endif
#if ENABLE(OFFSCREEN_CANVAS)
        { "OffscreenCanvasEnabled", &WebPreferences::offscreenCanvasEnabled },
#endif
        { "ExperimentalPlugInSandboxProfilesEnabled", &WebPreferences::experimentalPlugInSandboxProfilesEnabled },
        { "SecureContextChecksEnabled", &WebPreferences::secureContextChecksEnabled },
        { "SelectionAcrossShadowBoundariesEnabled", &WebPreferences::selectionAcrossShadowBoundariesEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::serviceWorkersEnabled },
#endif
        { "SimpleLineLayoutEnabled", &WebPreferences::simpleLineLayoutEnabled },
        { "UndoManagerAPIEnabled", &WebPreferences::undoManagerAPIEnabled },
        { "WebAPIStatisticsEnabled", &WebPreferences::webAPIStatisticsEnabled },
#if ENABLE(WEB_RTC)
        { "WebRTCH264SimulcastEnabled", &WebPreferences::webRTCH264SimulcastEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP8CodecEnabled", &WebPreferences::webRTCVP8CodecEnabled },
#endif
        { "IsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled", &WebPreferences::isFirstPartyWebsiteDataRemovalLiveOnTestingEnabled },
        { "IsFirstPartyWebsiteDataRemovalReproTestingEnabled", &WebPreferences::isFirstPartyWebsiteDataRemovalReproTestingEnabled },
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::InternalDebugFeature& feature, bool value)
{
    setInternalDebugFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setInternalDebugFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "AriaReflectionEnabled", &WebPreferences::setAriaReflectionEnabled },
#if PLATFORM(IOS_FAMILY)
        { "AllowViewportShrinkToFitContent", &WebPreferences::setAllowViewportShrinkToFitContent },
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        { "ApplePayRemoteUIEnabled", &WebPreferences::setApplePayRemoteUIEnabled },
#endif
        { "AsyncFrameScrollingEnabled", &WebPreferences::setAsyncFrameScrollingEnabled },
        { "AsyncOverflowScrollingEnabled", &WebPreferences::setAsyncOverflowScrollingEnabled },
        { "BlockingOfSmallPluginsEnabled", &WebPreferences::setBlockingOfSmallPluginsEnabled },
        { "CSSLogicalEnabled", &WebPreferences::setCSSLogicalEnabled },
        { "CSSOMViewScrollingAPIEnabled", &WebPreferences::setCSSOMViewScrollingAPIEnabled },
#if ENABLE(MEDIA_STREAM)
        { "CaptureAudioInGPUProcessEnabled", &WebPreferences::setCaptureAudioInGPUProcessEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "CaptureAudioInUIProcessEnabled", &WebPreferences::setCaptureAudioInUIProcessEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "CaptureVideoInGPUProcessEnabled", &WebPreferences::setCaptureVideoInGPUProcessEnabled },
#endif
#if ENABLE(INPUT_TYPE_COLOR)
        { "InputTypeColorEnabled", &WebPreferences::setInputTypeColorEnabled },
#endif
        { "DOMPasteAccessRequestsEnabled", &WebPreferences::setDOMPasteAccessRequestsEnabled },
#if PLATFORM(IOS_FAMILY)
        { "ZoomOnDoubleTapWhenRoot", &WebPreferences::setZoomOnDoubleTapWhenRoot },
#endif
#if PLATFORM(IOS_FAMILY)
        { "AlwaysZoomOnDoubleTap", &WebPreferences::setAlwaysZoomOnDoubleTap },
#endif
#if ENABLE(DATALIST_ELEMENT)
        { "DataListElementEnabled", &WebPreferences::setDataListElementEnabled },
#endif
        { "EnterKeyHintEnabled", &WebPreferences::setEnterKeyHintEnabled },
#if PLATFORM(IOS_FAMILY)
        { "PreferFasterClickOverDoubleTap", &WebPreferences::setPreferFasterClickOverDoubleTap },
#endif
#if PLATFORM(IOS_FAMILY)
        { "FasterClicksEnabled", &WebPreferences::setFasterClicksEnabled },
#endif
        { "RestrictedHTTPResponseAccess", &WebPreferences::setRestrictedHTTPResponseAccess },
        { "FrameFlatteningEnabled", &WebPreferences::setFrameFlatteningEnabled },
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        { "LayoutFormattingContextEnabled", &WebPreferences::setLayoutFormattingContextEnabled },
#endif
#if ENABLE(FULLSCREEN_API)
        { "FullScreenEnabled", &WebPreferences::setFullScreenEnabled },
#endif
        { "KeygenElementEnabled", &WebPreferences::setKeygenElementEnabled },
        { "IsITPDatabaseEnabled", &WebPreferences::setIsITPDatabaseEnabled },
#if ENABLE(TEXT_AUTOSIZING)
        { "TextAutosizingUsesIdempotentMode", &WebPreferences::setTextAutosizingUsesIdempotentMode },
#endif
        { "IsInAppBrowserPrivacyEnabled", &WebPreferences::setIsInAppBrowserPrivacyEnabled },
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        { "LegacyOverflowScrollingTouchEnabled", &WebPreferences::setLegacyOverflowScrollingTouchEnabled },
#endif
#if ENABLE(GPU_PROCESS)
        { "UseGPUProcessForMedia", &WebPreferences::setUseGPUProcessForMedia },
#endif
#if ENABLE(TOUCH_EVENTS)
        { "MouseEventsSimulationEnabled", &WebPreferences::setMouseEventsSimulationEnabled },
#endif
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        { "LayoutFormattingContextIntegrationEnabled", &WebPreferences::setLayoutFormattingContextIntegrationEnabled },
#endif
#if ENABLE(OFFSCREEN_CANVAS)
        { "OffscreenCanvasEnabled", &WebPreferences::setOffscreenCanvasEnabled },
#endif
        { "ExperimentalPlugInSandboxProfilesEnabled", &WebPreferences::setExperimentalPlugInSandboxProfilesEnabled },
        { "SecureContextChecksEnabled", &WebPreferences::setSecureContextChecksEnabled },
        { "SelectionAcrossShadowBoundariesEnabled", &WebPreferences::setSelectionAcrossShadowBoundariesEnabled },
#if ENABLE(SERVICE_WORKER)
        { "ServiceWorkersEnabled", &WebPreferences::setServiceWorkersEnabled },
#endif
        { "SimpleLineLayoutEnabled", &WebPreferences::setSimpleLineLayoutEnabled },
        { "UndoManagerAPIEnabled", &WebPreferences::setUndoManagerAPIEnabled },
        { "WebAPIStatisticsEnabled", &WebPreferences::setWebAPIStatisticsEnabled },
#if ENABLE(WEB_RTC)
        { "WebRTCH264SimulcastEnabled", &WebPreferences::setWebRTCH264SimulcastEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP8CodecEnabled", &WebPreferences::setWebRTCVP8CodecEnabled },
#endif
        { "IsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled", &WebPreferences::setIsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled },
        { "IsFirstPartyWebsiteDataRemovalReproTestingEnabled", &WebPreferences::setIsFirstPartyWebsiteDataRemovalReproTestingEnabled },
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::resetAllInternalDebugFeatures()
{
    setAriaReflectionEnabled(true);
#if PLATFORM(IOS_FAMILY)
    setAllowViewportShrinkToFitContent(true);
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
    setApplePayRemoteUIEnabled(true);
#endif
    setAsyncFrameScrollingEnabled(DEFAULT_ASYNC_FRAME_SCROLLING_ENABLED);
    setAsyncOverflowScrollingEnabled(DEFAULT_ASYNC_OVERFLOW_SCROLLING_ENABLED);
    setBlockingOfSmallPluginsEnabled(true);
    setCSSLogicalEnabled(false);
    setCSSOMViewScrollingAPIEnabled(defaultCSSOMViewScrollingAPIEnabled());
#if ENABLE(MEDIA_STREAM)
    setCaptureAudioInGPUProcessEnabled(false);
#endif
#if ENABLE(MEDIA_STREAM)
    setCaptureAudioInUIProcessEnabled(DEFAULT_CAPTURE_AUDIO_IN_UIPROCESS);
#endif
#if ENABLE(MEDIA_STREAM)
    setCaptureVideoInGPUProcessEnabled(false);
#endif
#if ENABLE(INPUT_TYPE_COLOR)
    setInputTypeColorEnabled(DEFAULT_INPUT_TYPE_COLOR_ENABLED);
#endif
    setDOMPasteAccessRequestsEnabled(DEFAULT_DOM_PASTE_ACCESS_REQUESTS_ENABLED);
#if PLATFORM(IOS_FAMILY)
    setZoomOnDoubleTapWhenRoot(false);
#endif
#if PLATFORM(IOS_FAMILY)
    setAlwaysZoomOnDoubleTap(false);
#endif
#if ENABLE(DATALIST_ELEMENT)
    setDataListElementEnabled(DEFAULT_DATALIST_ELEMENT_ENABLED);
#endif
    setEnterKeyHintEnabled(DEFAULT_ENTER_KEY_HINT_ENABLED);
#if PLATFORM(IOS_FAMILY)
    setPreferFasterClickOverDoubleTap(DEFAULT_PREFER_FASTER_CLICK_OVER_DOUBLE_TAP);
#endif
#if PLATFORM(IOS_FAMILY)
    setFasterClicksEnabled(true);
#endif
    setRestrictedHTTPResponseAccess(true);
    setFrameFlatteningEnabled(DEFAULT_FRAME_FLATTENING);
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
    setLayoutFormattingContextEnabled(false);
#endif
#if ENABLE(FULLSCREEN_API)
    setFullScreenEnabled(false);
#endif
    setKeygenElementEnabled(false);
    setIsITPDatabaseEnabled(true);
#if ENABLE(TEXT_AUTOSIZING)
    setTextAutosizingUsesIdempotentMode(defaultTextAutosizingUsesIdempotentMode());
#endif
    setIsInAppBrowserPrivacyEnabled(false);
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
    setLegacyOverflowScrollingTouchEnabled(true);
#endif
#if ENABLE(GPU_PROCESS)
    setUseGPUProcessForMedia(false);
#endif
#if ENABLE(TOUCH_EVENTS)
    setMouseEventsSimulationEnabled(false);
#endif
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
    setLayoutFormattingContextIntegrationEnabled(true);
#endif
#if ENABLE(OFFSCREEN_CANVAS)
    setOffscreenCanvasEnabled(DEFAULT_OFFSCREEN_CANVAS_ENABLED);
#endif
    setExperimentalPlugInSandboxProfilesEnabled(false);
    setSecureContextChecksEnabled(true);
    setSelectionAcrossShadowBoundariesEnabled(true);
#if ENABLE(SERVICE_WORKER)
    setServiceWorkersEnabled(DEFAULT_SERVICE_WORKERS_ENABLED);
#endif
    setSimpleLineLayoutEnabled(true);
    setUndoManagerAPIEnabled(false);
    setWebAPIStatisticsEnabled(false);
#if ENABLE(WEB_RTC)
    setWebRTCH264SimulcastEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCVP8CodecEnabled(true);
#endif
    setIsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled(false);
    setIsFirstPartyWebsiteDataRemovalReproTestingEnabled(false);
}

}
