/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferencesKeys.h"

#include <wtf/NeverDestroyed.h>

namespace WebKit {
namespace WebPreferencesKey {

const String& isAVFoundationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AVFoundationEnabled"));
    return key;
}

const String& isAVFoundationNSURLSessionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AVFoundationNSURLSessionEnabled"));
    return key;
}

const String& accelerated2dCanvasEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("Accelerated2dCanvasEnabled"));
    return key;
}

const String& acceleratedCompositingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AcceleratedCompositingEnabled"));
    return key;
}

const String& acceleratedDrawingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AcceleratedDrawingEnabled"));
    return key;
}

const String& accessibilityObjectModelEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AccessibilityObjectModelEnabled"));
    return key;
}

const String& adClickAttributionDebugModeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AdClickAttributionDebugModeEnabled"));
    return key;
}

const String& adClickAttributionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AdClickAttributionEnabled"));
    return key;
}

const String& aggressiveTileRetentionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AggressiveTileRetentionEnabled"));
    return key;
}

const String& allowCrossOriginSubresourcesToAskForCredentialsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowCrossOriginSubresourcesToAskForCredentials"));
    return key;
}

const String& allowFileAccessFromFileURLsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowFileAccessFromFileURLs"));
    return key;
}

const String& allowMediaContentTypesRequiringHardwareSupportAsFallbackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowMediaContentTypesRequiringHardwareSupportAsFallback"));
    return key;
}

const String& allowMultiElementImplicitSubmissionKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowMultiElementImplicitSubmission"));
    return key;
}

const String& allowSettingAnyXHRHeaderFromFileURLsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowSettingAnyXHRHeaderFromFileURLs"));
    return key;
}

const String& allowTopNavigationToDataURLsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowTopNavigationToDataURLs"));
    return key;
}

const String& allowUniversalAccessFromFileURLsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowUniversalAccessFromFileURLs"));
    return key;
}

const String& allowViewportShrinkToFitContentKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowViewportShrinkToFitContent"));
    return key;
}

const String& allowsAirPlayForMediaPlaybackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowsAirPlayForMediaPlayback"));
    return key;
}

const String& allowsInlineMediaPlaybackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowsInlineMediaPlayback"));
    return key;
}

const String& allowsInlineMediaPlaybackAfterFullscreenKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowsInlineMediaPlaybackAfterFullscreen"));
    return key;
}

const String& allowsPictureInPictureMediaPlaybackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AllowsPictureInPictureMediaPlayback"));
    return key;
}

const String& alwaysUseAcceleratedOverflowScrollKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AlwaysUseAcceleratedOverflowScroll"));
    return key;
}

const String& alwaysZoomOnDoubleTapKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AlwaysZoomOnDoubleTap"));
    return key;
}

const String& animatedImageAsyncDecodingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AnimatedImageAsyncDecodingEnabled"));
    return key;
}

const String& applePayCapabilityDisclosureAllowedKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ApplePayCapabilityDisclosureAllowed"));
    return key;
}

const String& applePayEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ApplePayEnabled"));
    return key;
}

const String& applePayRemoteUIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ApplePayRemoteUIEnabled"));
    return key;
}

const String& ariaReflectionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AriaReflectionEnabled"));
    return key;
}

const String& artificialPluginInitializationDelayEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ArtificialPluginInitializationDelayEnabled"));
    return key;
}

const String& aspectRatioOfImgFromWidthAndHeightEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AspectRatioOfImgFromWidthAndHeightEnabled"));
    return key;
}

const String& asyncClipboardAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AsyncClipboardAPIEnabled"));
    return key;
}

const String& asyncFrameScrollingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AsyncFrameScrollingEnabled"));
    return key;
}

const String& asyncOverflowScrollingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AsyncOverflowScrollingEnabled"));
    return key;
}

const String& asynchronousPluginInitializationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AsynchronousPluginInitializationEnabled"));
    return key;
}

const String& asynchronousPluginInitializationEnabledForAllPluginsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AsynchronousPluginInitializationEnabledForAllPlugins"));
    return key;
}

const String& asynchronousSpellCheckingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AsynchronousSpellCheckingEnabled"));
    return key;
}

const String& attachmentElementEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AttachmentElementEnabled"));
    return key;
}

const String& authorAndUserStylesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AuthorAndUserStylesEnabled"));
    return key;
}

const String& autostartOriginPlugInSnapshottingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("AutostartOriginPlugInSnapshottingEnabled"));
    return key;
}

const String& backForwardCacheSupportsPluginsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("BackForwardCacheSupportsPlugins"));
    return key;
}

const String& backspaceKeyNavigationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("BackspaceKeyNavigationEnabled"));
    return key;
}

const String& beaconAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("BeaconAPIEnabled"));
    return key;
}

const String& blankAnchorTargetImpliesNoOpenerEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("BlankAnchorTargetImpliesNoOpenerEnabled"));
    return key;
}

const String& blockingOfSmallPluginsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("BlockingOfSmallPluginsEnabled"));
    return key;
}

const String& cssCustomPropertiesAndValuesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSCustomPropertiesAndValuesEnabled"));
    return key;
}

const String& cssLogicalEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSLogicalEnabled"));
    return key;
}

const String& cssOMViewScrollingAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSOMViewScrollingAPIEnabled"));
    return key;
}

const String& cssOMViewSmoothScrollingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSOMViewSmoothScrollingEnabled"));
    return key;
}

const String& cssPaintingAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSPaintingAPIEnabled"));
    return key;
}

const String& cssShadowPartsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSShadowPartsEnabled"));
    return key;
}

const String& cssTypedOMEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CSSTypedOMEnabled"));
    return key;
}

const String& cacheAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CacheAPIEnabled"));
    return key;
}

const String& canvasUsesAcceleratedDrawingKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CanvasUsesAcceleratedDrawing"));
    return key;
}

const String& captureAudioInGPUProcessEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CaptureAudioInGPUProcessEnabled"));
    return key;
}

const String& captureAudioInUIProcessEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CaptureAudioInUIProcessEnabled"));
    return key;
}

const String& captureVideoInGPUProcessEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CaptureVideoInGPUProcessEnabled"));
    return key;
}

const String& captureVideoInUIProcessEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CaptureVideoInUIProcessEnabled"));
    return key;
}

const String& caretBrowsingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CaretBrowsingEnabled"));
    return key;
}

const String& colorFilterEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ColorFilterEnabled"));
    return key;
}

const String& compositingBordersVisibleKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CompositingBordersVisible"));
    return key;
}

const String& compositingRepaintCountersVisibleKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CompositingRepaintCountersVisible"));
    return key;
}

const String& constantPropertiesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ConstantPropertiesEnabled"));
    return key;
}

const String& contentChangeObserverEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ContentChangeObserverEnabled"));
    return key;
}

const String& cookieEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CookieEnabled"));
    return key;
}

const String& coreMathMLEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CoreMathMLEnabled"));
    return key;
}

const String& crossOriginResourcePolicyEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CrossOriginResourcePolicyEnabled"));
    return key;
}

const String& cursiveFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CursiveFontFamily"));
    return key;
}

const String& customElementsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CustomElementsEnabled"));
    return key;
}

const String& customPasteboardDataEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("CustomPasteboardDataEnabled"));
    return key;
}

const String& dnsPrefetchingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DNSPrefetchingEnabled"));
    return key;
}

const String& domPasteAccessRequestsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DOMPasteAccessRequestsEnabled"));
    return key;
}

const String& domPasteAllowedKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DOMPasteAllowed"));
    return key;
}

const String& domTimersThrottlingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DOMTimersThrottlingEnabled"));
    return key;
}

const String& dataDetectorTypesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DataDetectorTypes"));
    return key;
}

const String& dataListElementEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DataListElementEnabled"));
    return key;
}

const String& dataTransferItemsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DataTransferItemsEnabled"));
    return key;
}

const String& databasesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DatabasesEnabled"));
    return key;
}

const String& defaultFixedFontSizeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DefaultFixedFontSize"));
    return key;
}

const String& defaultFontSizeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DefaultFontSize"));
    return key;
}

const String& defaultTextEncodingNameKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DefaultTextEncodingName"));
    return key;
}

const String& deferredCSSParserEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DeferredCSSParserEnabled"));
    return key;
}

const String& developerExtrasEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DeveloperExtrasEnabled"));
    return key;
}

const String& deviceHeightKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DeviceHeight"));
    return key;
}

const String& deviceOrientationEventEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DeviceOrientationEventEnabled"));
    return key;
}

const String& deviceOrientationPermissionAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DeviceOrientationPermissionAPIEnabled"));
    return key;
}

const String& deviceWidthKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DeviceWidth"));
    return key;
}

const String& diagnosticLoggingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DiagnosticLoggingEnabled"));
    return key;
}

const String& dialogElementEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DialogElementEnabled"));
    return key;
}

const String& directoryUploadEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DirectoryUploadEnabled"));
    return key;
}

const String& disableScreenSizeOverrideKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DisableScreenSizeOverride"));
    return key;
}

const String& disabledAdaptationsMetaTagEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DisabledAdaptationsMetaTagEnabled"));
    return key;
}

const String& disallowSyncXHRDuringPageDismissalEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DisallowSyncXHRDuringPageDismissalEnabled"));
    return key;
}

const String& displayListDrawingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DisplayListDrawingEnabled"));
    return key;
}

const String& downloadAttributeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("DownloadAttributeEnabled"));
    return key;
}

const String& editableImagesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("EditableImagesEnabled"));
    return key;
}

const String& editableLinkBehaviorKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("EditableLinkBehavior"));
    return key;
}

const String& enableInheritURIQueryComponentKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("EnableInheritURIQueryComponent"));
    return key;
}

const String& encryptedMediaAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("EncryptedMediaAPIEnabled"));
    return key;
}

const String& enterKeyHintEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("EnterKeyHintEnabled"));
    return key;
}

const String& enumeratingAllNetworkInterfacesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("EnumeratingAllNetworkInterfacesEnabled"));
    return key;
}

const String& experimentalPlugInSandboxProfilesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ExperimentalPlugInSandboxProfilesEnabled"));
    return key;
}

const String& ftpDirectoryTemplatePathKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FTPDirectoryTemplatePath"));
    return key;
}

const String& fantasyFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FantasyFontFamily"));
    return key;
}

const String& fasterClicksEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FasterClicksEnabled"));
    return key;
}

const String& fetchAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FetchAPIEnabled"));
    return key;
}

const String& fetchAPIKeepAliveEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FetchAPIKeepAliveEnabled"));
    return key;
}

const String& fixedFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FixedFontFamily"));
    return key;
}

const String& forceAlwaysUserScalableKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ForceAlwaysUserScalable"));
    return key;
}

const String& forceCompositingModeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ForceCompositingMode"));
    return key;
}

const String& forceFTPDirectoryListingsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ForceFTPDirectoryListings"));
    return key;
}

const String& forceUpdateScrollbarsOnMainThreadForPerformanceTestingKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ForceUpdateScrollbarsOnMainThreadForPerformanceTesting"));
    return key;
}

const String& frameFlatteningEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FrameFlatteningEnabled"));
    return key;
}

const String& fullScreenEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("FullScreenEnabled"));
    return key;
}

const String& isGStreamerEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("GStreamerEnabled"));
    return key;
}

const String& gamepadsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("GamepadsEnabled"));
    return key;
}

const String& genericCueAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("GenericCueAPIEnabled"));
    return key;
}

const String& googleAntiFlickerOptimizationQuirkEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("GoogleAntiFlickerOptimizationQuirkEnabled"));
    return key;
}

const String& hDRMediaCapabilitiesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HDRMediaCapabilitiesEnabled"));
    return key;
}

const String& httpEquivEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HTTPEquivEnabled"));
    return key;
}

const String& httpSUpgradeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HTTPSUpgradeEnabled"));
    return key;
}

const String& hiddenPageCSSAnimationSuspensionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HiddenPageCSSAnimationSuspensionEnabled"));
    return key;
}

const String& hiddenPageDOMTimerThrottlingAutoIncreasesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HiddenPageDOMTimerThrottlingAutoIncreases"));
    return key;
}

const String& hiddenPageDOMTimerThrottlingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HiddenPageDOMTimerThrottlingEnabled"));
    return key;
}

const String& highlightAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HighlightAPIEnabled"));
    return key;
}

const String& hyperlinkAuditingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("HyperlinkAuditingEnabled"));
    return key;
}

const String& iceCandidateFilteringEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ICECandidateFilteringEnabled"));
    return key;
}

const String& ignoreViewportScalingConstraintsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IgnoreViewportScalingConstraints"));
    return key;
}

const String& imageBitmapEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ImageBitmapEnabled"));
    return key;
}

const String& imageControlsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ImageControlsEnabled"));
    return key;
}

const String& inactiveMediaCaptureSteamRepromptIntervalInMinutesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InactiveMediaCaptureSteamRepromptIntervalInMinutes"));
    return key;
}

const String& incompleteImageBorderEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IncompleteImageBorderEnabled"));
    return key;
}

const String& incrementalRenderingSuppressionTimeoutKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IncrementalRenderingSuppressionTimeout"));
    return key;
}

const String& inlineMediaPlaybackRequiresPlaysInlineAttributeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InlineMediaPlaybackRequiresPlaysInlineAttribute"));
    return key;
}

const String& inputEventsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InputEventsEnabled"));
    return key;
}

const String& inputTypeColorEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InputTypeColorEnabled"));
    return key;
}

const String& inspectorAdditionsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InspectorAdditionsEnabled"));
    return key;
}

const String& inspectorAttachedHeightKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InspectorAttachedHeight"));
    return key;
}

const String& inspectorAttachedWidthKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InspectorAttachedWidth"));
    return key;
}

const String& inspectorAttachmentSideKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InspectorAttachmentSide"));
    return key;
}

const String& inspectorStartsAttachedKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InspectorStartsAttached"));
    return key;
}

const String& inspectorWindowFrameKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InspectorWindowFrame"));
    return key;
}

const String& interactiveFormValidationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InteractiveFormValidationEnabled"));
    return key;
}

const String& interruptAudioOnPageVisibilityChangeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InterruptAudioOnPageVisibilityChangeEnabled"));
    return key;
}

const String& intersectionObserverEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IntersectionObserverEnabled"));
    return key;
}

const String& invisibleAutoplayNotPermittedKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("InvisibleAutoplayNotPermitted"));
    return key;
}

const String& isAccessibilityIsolatedTreeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsAccessibilityIsolatedTreeEnabled"));
    return key;
}

const String& isFirstPartyWebsiteDataRemovalDisabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsFirstPartyWebsiteDataRemovalDisabled"));
    return key;
}

const String& isFirstPartyWebsiteDataRemovalLiveOnTestingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsFirstPartyWebsiteDataRemovalLiveOnTestingEnabled"));
    return key;
}

const String& isFirstPartyWebsiteDataRemovalReproTestingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsFirstPartyWebsiteDataRemovalReproTestingEnabled"));
    return key;
}

const String& isITPDatabaseEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsITPDatabaseEnabled"));
    return key;
}

const String& isInAppBrowserPrivacyEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsInAppBrowserPrivacyEnabled"));
    return key;
}

const String& isLoggedInAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsLoggedInAPIEnabled"));
    return key;
}

const String& isNSURLSessionWebSocketEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsNSURLSessionWebSocketEnabled"));
    return key;
}

const String& isSecureContextAttributeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsSecureContextAttributeEnabled"));
    return key;
}

const String& isThirdPartyCookieBlockingDisabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("IsThirdPartyCookieBlockingDisabled"));
    return key;
}

const String& itpDebugModeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ItpDebugModeEnabled"));
    return key;
}

const String& javaEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaEnabled"));
    return key;
}

const String& javaEnabledForLocalFilesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaEnabledForLocalFiles"));
    return key;
}

const String& javaScriptCanAccessClipboardKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaScriptCanAccessClipboard"));
    return key;
}

const String& javaScriptCanOpenWindowsAutomaticallyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaScriptCanOpenWindowsAutomatically"));
    return key;
}

const String& javaScriptEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaScriptEnabled"));
    return key;
}

const String& javaScriptMarkupEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaScriptMarkupEnabled"));
    return key;
}

const String& javaScriptRuntimeFlagsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("JavaScriptRuntimeFlags"));
    return key;
}

const String& keygenElementEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("KeygenElementEnabled"));
    return key;
}

const String& largeImageAsyncDecodingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LargeImageAsyncDecodingEnabled"));
    return key;
}

const String& layoutFallbackWidthKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LayoutFallbackWidth"));
    return key;
}

const String& layoutFormattingContextEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LayoutFormattingContextEnabled"));
    return key;
}

const String& layoutFormattingContextIntegrationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LayoutFormattingContextIntegrationEnabled"));
    return key;
}

const String& layoutIntervalKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LayoutInterval"));
    return key;
}

const String& layoutViewportHeightExpansionFactorKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LayoutViewportHeightExpansionFactor"));
    return key;
}

const String& lazyImageLoadingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LazyImageLoadingEnabled"));
    return key;
}

const String& legacyEncryptedMediaAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LegacyEncryptedMediaAPIEnabled"));
    return key;
}

const String& legacyOverflowScrollingTouchEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LegacyOverflowScrollingTouchEnabled"));
    return key;
}

const String& linkPreconnectKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LinkPreconnect"));
    return key;
}

const String& linkPrefetchEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LinkPrefetchEnabled"));
    return key;
}

const String& linkPreloadEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LinkPreloadEnabled"));
    return key;
}

const String& linkPreloadResponsiveImagesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LinkPreloadResponsiveImagesEnabled"));
    return key;
}

const String& loadsImagesAutomaticallyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LoadsImagesAutomatically"));
    return key;
}

const String& loadsSiteIconsIgnoringImageLoadingPreferenceKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LoadsSiteIconsIgnoringImageLoadingPreference"));
    return key;
}

const String& localFileContentSniffingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LocalFileContentSniffingEnabled"));
    return key;
}

const String& localStorageEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LocalStorageEnabled"));
    return key;
}

const String& logsPageMessagesToSystemConsoleEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LogsPageMessagesToSystemConsoleEnabled"));
    return key;
}

const String& longRunningMediaCaptureStreamRepromptIntervalInHoursKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LongRunningMediaCaptureStreamRepromptIntervalInHours"));
    return key;
}

const String& lowPowerVideoAudioBufferSizeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("LowPowerVideoAudioBufferSizeEnabled"));
    return key;
}

const String& mainContentUserGestureOverrideEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MainContentUserGestureOverrideEnabled"));
    return key;
}

const String& maxParseDurationKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MaxParseDuration"));
    return key;
}

const String& mediaCapabilitiesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaCapabilitiesEnabled"));
    return key;
}

const String& mediaCapabilitiesExtensionsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaCapabilitiesExtensionsEnabled"));
    return key;
}

const String& mediaCaptureRequiresSecureConnectionKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaCaptureRequiresSecureConnection"));
    return key;
}

const String& mediaContentTypesRequiringHardwareSupportKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaContentTypesRequiringHardwareSupport"));
    return key;
}

const String& mediaControlsScaleWithPageZoomKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaControlsScaleWithPageZoom"));
    return key;
}

const String& mediaDataLoadsAutomaticallyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaDataLoadsAutomatically"));
    return key;
}

const String& mediaDevicesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaDevicesEnabled"));
    return key;
}

const String& mediaEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaEnabled"));
    return key;
}

const String& mediaPreloadingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaPreloadingEnabled"));
    return key;
}

const String& mediaRecorderEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaRecorderEnabled"));
    return key;
}

const String& mediaSourceEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaSourceEnabled"));
    return key;
}

const String& mediaStreamEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaStreamEnabled"));
    return key;
}

const String& mediaUserGestureInheritsFromDocumentKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MediaUserGestureInheritsFromDocument"));
    return key;
}

const String& menuItemElementEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MenuItemElementEnabled"));
    return key;
}

const String& minimumFontSizeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MinimumFontSize"));
    return key;
}

const String& minimumLogicalFontSizeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MinimumLogicalFontSize"));
    return key;
}

const String& minimumZoomFontSizeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MinimumZoomFontSize"));
    return key;
}

const String& mockCaptureDevicesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MockCaptureDevicesEnabled"));
    return key;
}

const String& mockCaptureDevicesPromptEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MockCaptureDevicesPromptEnabled"));
    return key;
}

const String& mockScrollbarsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MockScrollbarsEnabled"));
    return key;
}

const String& modernMediaControlsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ModernMediaControlsEnabled"));
    return key;
}

const String& mouseEventsSimulationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("MouseEventsSimulationEnabled"));
    return key;
}

const String& needsSiteSpecificQuirksKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("NeedsSiteSpecificQuirks"));
    return key;
}

const String& needsStorageAccessFromFileURLsQuirkKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("NeedsStorageAccessFromFileURLsQuirk"));
    return key;
}

const String& notificationsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("NotificationsEnabled"));
    return key;
}

const String& offlineWebApplicationCacheEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("OfflineWebApplicationCacheEnabled"));
    return key;
}

const String& offscreenCanvasEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("OffscreenCanvasEnabled"));
    return key;
}

const String& pdfPluginEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PDFPluginEnabled"));
    return key;
}

const String& pageAtRuleSupportEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PageAtRuleSupportEnabled"));
    return key;
}

const String& pageVisibilityBasedProcessSuppressionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PageVisibilityBasedProcessSuppressionEnabled"));
    return key;
}

const String& paginateDuringLayoutEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PaginateDuringLayoutEnabled"));
    return key;
}

const String& passiveTouchListenersAsDefaultOnDocumentKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PassiveTouchListenersAsDefaultOnDocument"));
    return key;
}

const String& passwordEchoDurationKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PasswordEchoDuration"));
    return key;
}

const String& passwordEchoEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PasswordEchoEnabled"));
    return key;
}

const String& peerConnectionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PeerConnectionEnabled"));
    return key;
}

const String& pictographFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PictographFontFamily"));
    return key;
}

const String& pictureInPictureAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PictureInPictureAPIEnabled"));
    return key;
}

const String& plugInSnapshottingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PlugInSnapshottingEnabled"));
    return key;
}

const String& pluginsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PluginsEnabled"));
    return key;
}

const String& pointerEventsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PointerEventsEnabled"));
    return key;
}

const String& preferFasterClickOverDoubleTapKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PreferFasterClickOverDoubleTap"));
    return key;
}

const String& primaryPlugInSnapshotDetectionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PrimaryPlugInSnapshotDetectionEnabled"));
    return key;
}

const String& processSwapOnCrossSiteNavigationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ProcessSwapOnCrossSiteNavigationEnabled"));
    return key;
}

const String& punchOutWhiteBackgroundsInDarkModeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("PunchOutWhiteBackgroundsInDarkMode"));
    return key;
}

const String& referrerPolicyAttributeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ReferrerPolicyAttributeEnabled"));
    return key;
}

const String& remotePlaybackEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RemotePlaybackEnabled"));
    return key;
}

const String& requestAnimationFrameEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RequestAnimationFrameEnabled"));
    return key;
}

const String& requestIdleCallbackEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RequestIdleCallbackEnabled"));
    return key;
}

const String& requiresUserGestureForAudioPlaybackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RequiresUserGestureForAudioPlayback"));
    return key;
}

const String& requiresUserGestureForMediaPlaybackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RequiresUserGestureForMediaPlayback"));
    return key;
}

const String& requiresUserGestureForVideoPlaybackKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RequiresUserGestureForVideoPlayback"));
    return key;
}

const String& requiresUserGestureToLoadVideoKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RequiresUserGestureToLoadVideo"));
    return key;
}

const String& resizeObserverEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ResizeObserverEnabled"));
    return key;
}

const String& resourceTimingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ResourceTimingEnabled"));
    return key;
}

const String& resourceUsageOverlayVisibleKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ResourceUsageOverlayVisible"));
    return key;
}

const String& restrictedHTTPResponseAccessKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("RestrictedHTTPResponseAccess"));
    return key;
}

const String& safeBrowsingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SafeBrowsingEnabled"));
    return key;
}

const String& sansSerifFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SansSerifFontFamily"));
    return key;
}

const String& screenCaptureEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ScreenCaptureEnabled"));
    return key;
}

const String& scrollAnimatorEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ScrollAnimatorEnabled"));
    return key;
}

const String& scrollingPerformanceLoggingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ScrollingPerformanceLoggingEnabled"));
    return key;
}

const String& secureContextChecksEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SecureContextChecksEnabled"));
    return key;
}

const String& selectTrailingWhitespaceEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SelectTrailingWhitespaceEnabled"));
    return key;
}

const String& selectionAcrossShadowBoundariesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SelectionAcrossShadowBoundariesEnabled"));
    return key;
}

const String& selectionPaintingWithoutSelectionGapsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SelectionPaintingWithoutSelectionGapsEnabled"));
    return key;
}

const String& serifFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SerifFontFamily"));
    return key;
}

const String& serverTimingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ServerTimingEnabled"));
    return key;
}

const String& serviceControlsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ServiceControlsEnabled"));
    return key;
}

const String& serviceWorkersEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ServiceWorkersEnabled"));
    return key;
}

const String& shadowDOMEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShadowDOMEnabled"));
    return key;
}

const String& shouldAllowUserInstalledFontsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldAllowUserInstalledFonts"));
    return key;
}

const String& shouldConvertPositionStyleOnCopyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldConvertPositionStyleOnCopy"));
    return key;
}

const String& shouldDecidePolicyBeforeLoadingQuickLookPreviewKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldDecidePolicyBeforeLoadingQuickLookPreview"));
    return key;
}

const String& shouldDeferAsynchronousScriptsUntilAfterDocumentLoadKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldDeferAsynchronousScriptsUntilAfterDocumentLoad"));
    return key;
}

const String& shouldDisplayCaptionsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldDisplayCaptions"));
    return key;
}

const String& shouldDisplaySubtitlesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldDisplaySubtitles"));
    return key;
}

const String& shouldDisplayTextDescriptionsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldDisplayTextDescriptions"));
    return key;
}

const String& shouldEnableTextAutosizingBoostKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldEnableTextAutosizingBoost"));
    return key;
}

const String& shouldIgnoreMetaViewportKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldIgnoreMetaViewport"));
    return key;
}

const String& shouldPrintBackgroundsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldPrintBackgrounds"));
    return key;
}

const String& shouldRespectImageOrientationKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldRespectImageOrientation"));
    return key;
}

const String& shouldRestrictBaseURLSchemesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldRestrictBaseURLSchemes"));
    return key;
}

const String& shouldSuppressTextInputFromEditingDuringProvisionalNavigationKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldSuppressTextInputFromEditingDuringProvisionalNavigation"));
    return key;
}

const String& shouldUseServiceWorkerShortTimeoutKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShouldUseServiceWorkerShortTimeout"));
    return key;
}

const String& showsToolTipOverTruncatedTextKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShowsToolTipOverTruncatedText"));
    return key;
}

const String& showsURLsInToolTipsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ShowsURLsInToolTipsEnabled"));
    return key;
}

const String& simpleLineLayoutDebugBordersEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SimpleLineLayoutDebugBordersEnabled"));
    return key;
}

const String& simpleLineLayoutEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SimpleLineLayoutEnabled"));
    return key;
}

const String& smartInsertDeleteEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SmartInsertDeleteEnabled"));
    return key;
}

const String& snapshotAllPlugInsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SnapshotAllPlugIns"));
    return key;
}

const String& sourceBufferChangeTypeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SourceBufferChangeTypeEnabled"));
    return key;
}

const String& spatialNavigationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SpatialNavigationEnabled"));
    return key;
}

const String& springTimingFunctionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SpringTimingFunctionEnabled"));
    return key;
}

const String& standaloneKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("Standalone"));
    return key;
}

const String& standardFontFamilyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("StandardFontFamily"));
    return key;
}

const String& storageAccessAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("StorageAccessAPIEnabled"));
    return key;
}

const String& storageBlockingPolicyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("StorageBlockingPolicy"));
    return key;
}

const String& subpixelAntialiasedLayerTextEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SubpixelAntialiasedLayerTextEnabled"));
    return key;
}

const String& subpixelCSSOMElementMetricsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SubpixelCSSOMElementMetricsEnabled"));
    return key;
}

const String& subresourceIntegrityEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SubresourceIntegrityEnabled"));
    return key;
}

const String& suppressesIncrementalRenderingKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SuppressesIncrementalRendering"));
    return key;
}

const String& syntheticEditingCommandsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SyntheticEditingCommandsEnabled"));
    return key;
}

const String& systemLayoutDirectionKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SystemLayoutDirection"));
    return key;
}

const String& systemPreviewEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("SystemPreviewEnabled"));
    return key;
}

const String& tabToLinksEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TabToLinksEnabled"));
    return key;
}

const String& tabsToLinksKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TabsToLinks"));
    return key;
}

const String& telephoneNumberParsingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TelephoneNumberParsingEnabled"));
    return key;
}

const String& temporaryTileCohortRetentionEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TemporaryTileCohortRetentionEnabled"));
    return key;
}

const String& textAreasAreResizableKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TextAreasAreResizable"));
    return key;
}

const String& textAutosizingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TextAutosizingEnabled"));
    return key;
}

const String& textAutosizingUsesIdempotentModeKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TextAutosizingUsesIdempotentMode"));
    return key;
}

const String& thirdPartyIframeRedirectBlockingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ThirdPartyIframeRedirectBlockingEnabled"));
    return key;
}

const String& threadedScrollingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ThreadedScrollingEnabled"));
    return key;
}

const String& tiledScrollingIndicatorVisibleKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("TiledScrollingIndicatorVisible"));
    return key;
}

const String& undoManagerAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UndoManagerAPIEnabled"));
    return key;
}

const String& useGPUProcessForMediaKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UseGPUProcessForMedia"));
    return key;
}

const String& useGiantTilesKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UseGiantTiles"));
    return key;
}

const String& useLegacyTextAlignPositionedElementBehaviorKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UseLegacyTextAlignPositionedElementBehavior"));
    return key;
}

const String& userInterfaceDirectionPolicyKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UserInterfaceDirectionPolicy"));
    return key;
}

const String& userTimingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UserTimingEnabled"));
    return key;
}

const String& usesBackForwardCacheKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UsesBackForwardCache"));
    return key;
}

const String& usesEncodingDetectorKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("UsesEncodingDetector"));
    return key;
}

const String& videoQualityIncludesDisplayCompositingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("VideoQualityIncludesDisplayCompositingEnabled"));
    return key;
}

const String& viewGestureDebuggingEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ViewGestureDebuggingEnabled"));
    return key;
}

const String& viewportFitEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ViewportFitEnabled"));
    return key;
}

const String& visibleDebugOverlayRegionsKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("VisibleDebugOverlayRegions"));
    return key;
}

const String& visualViewportAPIEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("VisualViewportAPIEnabled"));
    return key;
}

const String& wantsBalancedSetDefersLoadingBehaviorKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WantsBalancedSetDefersLoadingBehavior"));
    return key;
}

const String& webAPIStatisticsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAPIStatisticsEnabled"));
    return key;
}

const String& webAnimationsCSSIntegrationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAnimationsCSSIntegrationEnabled"));
    return key;
}

const String& webAnimationsCompositeOperationsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAnimationsCompositeOperationsEnabled"));
    return key;
}

const String& webAnimationsEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAnimationsEnabled"));
    return key;
}

const String& webAnimationsMutableTimelinesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAnimationsMutableTimelinesEnabled"));
    return key;
}

const String& webArchiveDebugModeEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebArchiveDebugModeEnabled"));
    return key;
}

const String& webAudioEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAudioEnabled"));
    return key;
}

const String& webAuthenticationEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAuthenticationEnabled"));
    return key;
}

const String& webAuthenticationLocalAuthenticatorEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebAuthenticationLocalAuthenticatorEnabled"));
    return key;
}

const String& webGL2EnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebGL2Enabled"));
    return key;
}

const String& webGLEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebGLEnabled"));
    return key;
}

const String& webGPUEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebGPUEnabled"));
    return key;
}

const String& webRTCDTMFEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebRTCDTMFEnabled"));
    return key;
}

const String& webRTCH264SimulcastEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebRTCH264SimulcastEnabled"));
    return key;
}

const String& webRTCMDNSICECandidatesEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebRTCMDNSICECandidatesEnabled"));
    return key;
}

const String& webRTCVP8CodecEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebRTCVP8CodecEnabled"));
    return key;
}

const String& webSQLDisabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebSQLDisabled"));
    return key;
}

const String& webSecurityEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebSecurityEnabled"));
    return key;
}

const String& webShareEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("WebShareEnabled"));
    return key;
}

const String& xssAuditorEnabledKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("XSSAuditorEnabled"));
    return key;
}

const String& zoomOnDoubleTapWhenRootKey()
{
    static NeverDestroyed<String> key(MAKE_STATIC_STRING_IMPL("ZoomOnDoubleTapWhenRoot"));
    return key;
}


} // namespace WebPreferencesKey
} // namespace WebKit
