/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferencesStore.h"

#include "WebPreferencesDefaultValues.h"
#include "WebPreferencesKeys.h"
#include <wtf/NeverDestroyed.h>
#include <wtf/Variant.h>

// FIXME: These should added via options in WebPreferences.yaml, rather than hardcoded.
#include <WebCore/DeprecatedGlobalSettings.h>
#include <WebCore/LibWebRTCProvider.h>
#include <WebCore/RealtimeMediaSourceCenter.h>
#include <WebCore/SecurityOrigin.h>
#include <WebCore/Settings.h>
#include <WebCore/TextEncodingRegistry.h>

namespace WebKit {
using namespace WebCore;

WebPreferencesStore::ValueMap& WebPreferencesStore::defaults()
{
    static NeverDestroyed<ValueMap> defaults;
    if (defaults.get().isEmpty()) {
#if USE(AVFOUNDATION)
        defaults.get().set(WebPreferencesKey::isAVFoundationEnabledKey(), Value(bool(DEFAULT_AVFOUNDATION_ENABLED)));
#endif
#if USE(AVFOUNDATION)
        defaults.get().set(WebPreferencesKey::isAVFoundationNSURLSessionEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::accelerated2dCanvasEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::acceleratedCompositingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::acceleratedDrawingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::accessibilityObjectModelEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::adClickAttributionDebugModeEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::adClickAttributionEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::aggressiveTileRetentionEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::allowCrossOriginSubresourcesToAskForCredentialsKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::allowFileAccessFromFileURLsKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::allowMediaContentTypesRequiringHardwareSupportAsFallbackKey(), Value(bool(DEFAULT_ALLOW_MEDIA_CONTENT_TYPES_REQUIRING_HARDWARE_SUPPORT_AS_FALLBACK)));
        defaults.get().set(WebPreferencesKey::allowMultiElementImplicitSubmissionKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::allowSettingAnyXHRHeaderFromFileURLsKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::allowTopNavigationToDataURLsKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::allowUniversalAccessFromFileURLsKey(), Value(bool(false)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::allowViewportShrinkToFitContentKey(), Value(bool(true)));
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        defaults.get().set(WebPreferencesKey::allowsAirPlayForMediaPlaybackKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::allowsInlineMediaPlaybackKey(), Value(bool(DEFAULT_ALLOWS_INLINE_MEDIA_PLAYBACK)));
        defaults.get().set(WebPreferencesKey::allowsInlineMediaPlaybackAfterFullscreenKey(), Value(bool(DEFAULT_ALLOWS_INLINE_MEDIA_PLAYBACK_AFTER_FULLSCREEN)));
        defaults.get().set(WebPreferencesKey::allowsPictureInPictureMediaPlaybackKey(), Value(bool(DEFAULT_ALLOWS_PICTURE_IN_PICTURE_MEDIA_PLAYBACK)));
        defaults.get().set(WebPreferencesKey::alwaysUseAcceleratedOverflowScrollKey(), Value(bool(false)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::alwaysZoomOnDoubleTapKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::animatedImageAsyncDecodingEnabledKey(), Value(bool(true)));
#if ENABLE(APPLE_PAY)
        defaults.get().set(WebPreferencesKey::applePayCapabilityDisclosureAllowedKey(), Value(bool(true)));
#endif
#if ENABLE(APPLE_PAY)
        defaults.get().set(WebPreferencesKey::applePayEnabledKey(), Value(bool(DEFAULT_APPLE_PAY_ENABLED)));
#endif
#if ENABLE(APPLE_PAY_REMOTE_UI)
        defaults.get().set(WebPreferencesKey::applePayRemoteUIEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::ariaReflectionEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::artificialPluginInitializationDelayEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::aspectRatioOfImgFromWidthAndHeightEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::asyncClipboardAPIEnabledKey(), Value(bool(DEFAULT_ASYNC_CLIPBOARD_API_ENABLED)));
        defaults.get().set(WebPreferencesKey::asyncFrameScrollingEnabledKey(), Value(bool(DEFAULT_ASYNC_FRAME_SCROLLING_ENABLED)));
        defaults.get().set(WebPreferencesKey::asyncOverflowScrollingEnabledKey(), Value(bool(DEFAULT_ASYNC_OVERFLOW_SCROLLING_ENABLED)));
        defaults.get().set(WebPreferencesKey::asynchronousPluginInitializationEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::asynchronousPluginInitializationEnabledForAllPluginsKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::asynchronousSpellCheckingEnabledKey(), Value(bool(false)));
#if ENABLE(ATTACHMENT_ELEMENT)
        defaults.get().set(WebPreferencesKey::attachmentElementEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::authorAndUserStylesEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::autostartOriginPlugInSnapshottingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::backForwardCacheSupportsPluginsKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::backspaceKeyNavigationEnabledKey(), Value(bool(DEFAULT_BACKSPACE_KEY_NAVIGATION_ENABLED)));
        defaults.get().set(WebPreferencesKey::beaconAPIEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::blankAnchorTargetImpliesNoOpenerEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::blockingOfSmallPluginsEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::cssCustomPropertiesAndValuesEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::cssLogicalEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::cssOMViewScrollingAPIEnabledKey(), Value(bool(defaultCSSOMViewScrollingAPIEnabled())));
        defaults.get().set(WebPreferencesKey::cssOMViewSmoothScrollingEnabledKey(), Value(bool(false)));
#if ENABLE(CSS_PAINTING_API)
        defaults.get().set(WebPreferencesKey::cssPaintingAPIEnabledKey(), Value(bool(DEFAULT_CSS_PAINTING_API_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::cssShadowPartsEnabledKey(), Value(bool(true)));
#if ENABLE(CSS_TYPED_OM)
        defaults.get().set(WebPreferencesKey::cssTypedOMEnabledKey(), Value(bool(DEFAULT_CSS_TYPED_OM_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::cacheAPIEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::canvasUsesAcceleratedDrawingKey(), Value(bool(true)));
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::captureAudioInGPUProcessEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::captureAudioInUIProcessEnabledKey(), Value(bool(DEFAULT_CAPTURE_AUDIO_IN_UIPROCESS)));
#endif
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::captureVideoInGPUProcessEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::captureVideoInUIProcessEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::caretBrowsingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::colorFilterEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::compositingBordersVisibleKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::compositingRepaintCountersVisibleKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::constantPropertiesEnabledKey(), Value(bool(true)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::contentChangeObserverEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::cookieEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::coreMathMLEnabledKey(), Value(bool(DEFAULT_CORE_MATHML_ENABLED)));
        defaults.get().set(WebPreferencesKey::crossOriginResourcePolicyEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::cursiveFontFamilyKey(), Value(String(DEFAULT_CURSIVE_FONT_FAMILY)));
        defaults.get().set(WebPreferencesKey::customElementsEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::customPasteboardDataEnabledKey(), Value(bool(DEFAULT_CUSTOM_PASTEBOARD_DATA_ENABLED)));
        defaults.get().set(WebPreferencesKey::dnsPrefetchingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::domPasteAccessRequestsEnabledKey(), Value(bool(DEFAULT_DOM_PASTE_ACCESS_REQUESTS_ENABLED)));
        defaults.get().set(WebPreferencesKey::domPasteAllowedKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::domTimersThrottlingEnabledKey(), Value(bool(true)));
#if ENABLE(DATA_DETECTION)
        defaults.get().set(WebPreferencesKey::dataDetectorTypesKey(), Value(uint32_t(0)));
#endif
#if ENABLE(DATALIST_ELEMENT)
        defaults.get().set(WebPreferencesKey::dataListElementEnabledKey(), Value(bool(DEFAULT_DATALIST_ELEMENT_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::dataTransferItemsEnabledKey(), Value(bool(DEFAULT_DATA_TRANSFER_ITEMS_ENABLED)));
        defaults.get().set(WebPreferencesKey::databasesEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::defaultFixedFontSizeKey(), Value(double(13)));
        defaults.get().set(WebPreferencesKey::defaultFontSizeKey(), Value(double(16)));
        defaults.get().set(WebPreferencesKey::defaultTextEncodingNameKey(), Value(String(defaultTextEncodingNameForSystemLanguage())));
        defaults.get().set(WebPreferencesKey::deferredCSSParserEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::developerExtrasEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::deviceHeightKey(), Value(uint32_t(0)));
#if ENABLE(DEVICE_ORIENTATION)
        defaults.get().set(WebPreferencesKey::deviceOrientationEventEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(DEVICE_ORIENTATION)
        defaults.get().set(WebPreferencesKey::deviceOrientationPermissionAPIEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::deviceWidthKey(), Value(uint32_t(0)));
        defaults.get().set(WebPreferencesKey::diagnosticLoggingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::dialogElementEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::directoryUploadEnabledKey(), Value(bool(DEFAULT_DIRECTORY_UPLOAD_ENABLED)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::disableScreenSizeOverrideKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::disabledAdaptationsMetaTagEnabledKey(), Value(bool(DISABLED_ADAPTATIONS_META_TAG_ENABLED)));
        defaults.get().set(WebPreferencesKey::disallowSyncXHRDuringPageDismissalEnabledKey(), Value(bool(defaultDisallowSyncXHRDuringPageDismissalEnabled())));
        defaults.get().set(WebPreferencesKey::displayListDrawingEnabledKey(), Value(bool(false)));
#if ENABLE(DOWNLOAD_ATTRIBUTE)
        defaults.get().set(WebPreferencesKey::downloadAttributeEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::editableImagesEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::editableLinkBehaviorKey(), Value(uint32_t(WebCore::EditableLinkNeverLive)));
        defaults.get().set(WebPreferencesKey::enableInheritURIQueryComponentKey(), Value(bool(false)));
#if ENABLE(ENCRYPTED_MEDIA)
        defaults.get().set(WebPreferencesKey::encryptedMediaAPIEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::enterKeyHintEnabledKey(), Value(bool(DEFAULT_ENTER_KEY_HINT_ENABLED)));
        defaults.get().set(WebPreferencesKey::enumeratingAllNetworkInterfacesEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::experimentalPlugInSandboxProfilesEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::ftpDirectoryTemplatePathKey(), Value(String("")));
        defaults.get().set(WebPreferencesKey::fantasyFontFamilyKey(), Value(String(DEFAULT_FANTASY_FONT_FAMILY)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::fasterClicksEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::fetchAPIEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::fetchAPIKeepAliveEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::fixedFontFamilyKey(), Value(String(DEFAULT_FIXED_FONT_FAMILY)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::forceAlwaysUserScalableKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::forceCompositingModeKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::forceFTPDirectoryListingsKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::forceUpdateScrollbarsOnMainThreadForPerformanceTestingKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::frameFlatteningEnabledKey(), Value(bool(DEFAULT_FRAME_FLATTENING)));
#if ENABLE(FULLSCREEN_API)
        defaults.get().set(WebPreferencesKey::fullScreenEnabledKey(), Value(bool(false)));
#endif
#if USE(GSTREAMER)
        defaults.get().set(WebPreferencesKey::isGStreamerEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(GAMEPAD)
        defaults.get().set(WebPreferencesKey::gamepadsEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(VIDEO_TRACK)
        defaults.get().set(WebPreferencesKey::genericCueAPIEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::googleAntiFlickerOptimizationQuirkEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::hDRMediaCapabilitiesEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::httpEquivEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::httpSUpgradeEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::hiddenPageCSSAnimationSuspensionEnabledKey(), Value(bool(DEFAULT_HIDDEN_PAGE_CSS_ANIMATION_SUSPENSION_ENABLED)));
        defaults.get().set(WebPreferencesKey::hiddenPageDOMTimerThrottlingAutoIncreasesKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::hiddenPageDOMTimerThrottlingEnabledKey(), Value(bool(DEFAULT_HIDDEN_PAGE_DOM_TIMER_THROTTLING_ENABLED)));
        defaults.get().set(WebPreferencesKey::highlightAPIEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::hyperlinkAuditingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::iceCandidateFilteringEnabledKey(), Value(bool(true)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::ignoreViewportScalingConstraintsKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::imageBitmapEnabledKey(), Value(bool(DEFAULT_EXPERIMENTAL_FEATURES_ENABLED)));
#if ENABLE(SERVICE_CONTROLS)
        defaults.get().set(WebPreferencesKey::imageControlsEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::inactiveMediaCaptureSteamRepromptIntervalInMinutesKey(), Value(double(DEFAULT_INTERACTIVE_MEDIA_CAPTURE_STREAM_REPROMPT_INTERVAL_IN_MINUTES)));
        defaults.get().set(WebPreferencesKey::incompleteImageBorderEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::incrementalRenderingSuppressionTimeoutKey(), Value(double(5)));
        defaults.get().set(WebPreferencesKey::inlineMediaPlaybackRequiresPlaysInlineAttributeKey(), Value(bool(DEFAULT_INLINE_MEDIA_PLAYBACK_REQUIRES_PLAYS_INLINE_ATTRIBUTE)));
        defaults.get().set(WebPreferencesKey::inputEventsEnabledKey(), Value(bool(true)));
#if ENABLE(INPUT_TYPE_COLOR)
        defaults.get().set(WebPreferencesKey::inputTypeColorEnabledKey(), Value(bool(DEFAULT_INPUT_TYPE_COLOR_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::inspectorAdditionsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::inspectorAttachedHeightKey(), Value(uint32_t(500)));
        defaults.get().set(WebPreferencesKey::inspectorAttachedWidthKey(), Value(uint32_t(750)));
        defaults.get().set(WebPreferencesKey::inspectorAttachmentSideKey(), Value(uint32_t(0)));
        defaults.get().set(WebPreferencesKey::inspectorStartsAttachedKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::inspectorWindowFrameKey(), Value(String("")));
        defaults.get().set(WebPreferencesKey::interactiveFormValidationEnabledKey(), Value(bool(true)));
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::interruptAudioOnPageVisibilityChangeEnabledKey(), Value(bool(WebCore::RealtimeMediaSourceCenter::shouldInterruptAudioOnPageVisibilityChange())));
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        defaults.get().set(WebPreferencesKey::intersectionObserverEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::invisibleAutoplayNotPermittedKey(), Value(bool(DEFAULT_INVISIBLE_AUTOPLAY_NOT_PERMITTED)));
#if ENABLE(ACCESSIBILITY_ISOLATED_TREE)
        defaults.get().set(WebPreferencesKey::isAccessibilityIsolatedTreeEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::isFirstPartyWebsiteDataRemovalDisabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::isFirstPartyWebsiteDataRemovalLiveOnTestingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::isFirstPartyWebsiteDataRemovalReproTestingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::isITPDatabaseEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::isInAppBrowserPrivacyEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::isLoggedInAPIEnabledKey(), Value(bool(false)));
#if HAVE(NSURLSESSION_WEBSOCKET)
        defaults.get().set(WebPreferencesKey::isNSURLSessionWebSocketEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::isSecureContextAttributeEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::isThirdPartyCookieBlockingDisabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::itpDebugModeEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::javaEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::javaEnabledForLocalFilesKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::javaScriptCanAccessClipboardKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::javaScriptCanOpenWindowsAutomaticallyKey(), Value(bool(DEFAULT_JAVASCRIPT_CAN_OPEN_WINDOWS_AUTOMATICALLY)));
        defaults.get().set(WebPreferencesKey::javaScriptEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::javaScriptMarkupEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::javaScriptRuntimeFlagsKey(), Value(uint32_t(0)));
        defaults.get().set(WebPreferencesKey::keygenElementEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::largeImageAsyncDecodingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::layoutFallbackWidthKey(), Value(uint32_t(980)));
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        defaults.get().set(WebPreferencesKey::layoutFormattingContextEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(LAYOUT_FORMATTING_CONTEXT)
        defaults.get().set(WebPreferencesKey::layoutFormattingContextIntegrationEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::layoutIntervalKey(), Value(double(-1)));
        defaults.get().set(WebPreferencesKey::layoutViewportHeightExpansionFactorKey(), Value(double(DEFAULT_VISUAL_VIEWPORT_HEIGHT_EXPANSION_FACTOR)));
        defaults.get().set(WebPreferencesKey::lazyImageLoadingEnabledKey(), Value(bool(false)));
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
        defaults.get().set(WebPreferencesKey::legacyEncryptedMediaAPIEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(OVERFLOW_SCROLLING_TOUCH)
        defaults.get().set(WebPreferencesKey::legacyOverflowScrollingTouchEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::linkPreconnectKey(), Value(bool(DEFAULT_LINK_PRECONNECT_ENABLED)));
        defaults.get().set(WebPreferencesKey::linkPrefetchEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::linkPreloadEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::linkPreloadResponsiveImagesEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::loadsImagesAutomaticallyKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::loadsSiteIconsIgnoringImageLoadingPreferenceKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::localFileContentSniffingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::localStorageEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::logsPageMessagesToSystemConsoleEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::longRunningMediaCaptureStreamRepromptIntervalInHoursKey(), Value(double(24)));
        defaults.get().set(WebPreferencesKey::lowPowerVideoAudioBufferSizeEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::mainContentUserGestureOverrideEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::maxParseDurationKey(), Value(double(-1)));
        defaults.get().set(WebPreferencesKey::mediaCapabilitiesEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::mediaCapabilitiesExtensionsEnabledKey(), Value(bool(true)));
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::mediaCaptureRequiresSecureConnectionKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::mediaContentTypesRequiringHardwareSupportKey(), Value(String(WebCore::Settings::defaultMediaContentTypesRequiringHardwareSupport())));
        defaults.get().set(WebPreferencesKey::mediaControlsScaleWithPageZoomKey(), Value(bool(DEFAULT_MEDIA_CONTROLS_SCALE_WITH_PAGE_ZOOM)));
        defaults.get().set(WebPreferencesKey::mediaDataLoadsAutomaticallyKey(), Value(bool(DEFAULT_MEDIA_DATA_LOADS_AUTOMATICALLY)));
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::mediaDevicesEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(VIDEO)
        defaults.get().set(WebPreferencesKey::mediaEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::mediaPreloadingEnabledKey(), Value(bool(false)));
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::mediaRecorderEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(MEDIA_SOURCE)
        defaults.get().set(WebPreferencesKey::mediaSourceEnabledKey(), Value(bool(WebCore::Settings::platformDefaultMediaSourceEnabled())));
#endif
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::mediaStreamEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::mediaUserGestureInheritsFromDocumentKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::menuItemElementEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::minimumFontSizeKey(), Value(double(0)));
        defaults.get().set(WebPreferencesKey::minimumLogicalFontSizeKey(), Value(double(9)));
#if ENABLE(TEXT_AUTOSIZING)
        defaults.get().set(WebPreferencesKey::minimumZoomFontSizeKey(), Value(double(WebCore::Settings::defaultMinimumZoomFontSize())));
#endif
#if ENABLE(MEDIA_STREAM)
        defaults.get().set(WebPreferencesKey::mockCaptureDevicesEnabledKey(), Value(bool(DEFAULT_MOCK_CAPTURE_DEVICES_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::mockCaptureDevicesPromptEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::mockScrollbarsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::modernMediaControlsEnabledKey(), Value(bool(DEFAULT_MODERN_MEDIA_CONTROLS_ENABLED)));
#if ENABLE(TOUCH_EVENTS)
        defaults.get().set(WebPreferencesKey::mouseEventsSimulationEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::needsSiteSpecificQuirksKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::needsStorageAccessFromFileURLsQuirkKey(), Value(bool(true)));
#if ENABLE(NOTIFICATIONS)
        defaults.get().set(WebPreferencesKey::notificationsEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::offlineWebApplicationCacheEnabledKey(), Value(bool(true)));
#if ENABLE(OFFSCREEN_CANVAS)
        defaults.get().set(WebPreferencesKey::offscreenCanvasEnabledKey(), Value(bool(DEFAULT_OFFSCREEN_CANVAS_ENABLED)));
#endif
#if PLATFORM(COCOA)
        defaults.get().set(WebPreferencesKey::pdfPluginEnabledKey(), Value(bool(DEFAULT_PDFPLUGIN_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::pageAtRuleSupportEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::pageVisibilityBasedProcessSuppressionEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::paginateDuringLayoutEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::passiveTouchListenersAsDefaultOnDocumentKey(), Value(bool(defaultPassiveTouchListenersAsDefaultOnDocument())));
        defaults.get().set(WebPreferencesKey::passwordEchoDurationKey(), Value(double(2)));
        defaults.get().set(WebPreferencesKey::passwordEchoEnabledKey(), Value(bool(DEFAULT_PASSWORD_ECHO_ENABLED)));
#if ENABLE(WEB_RTC)
        defaults.get().set(WebPreferencesKey::peerConnectionEnabledKey(), Value(bool(WebCore::LibWebRTCProvider::webRTCAvailable())));
#endif
        defaults.get().set(WebPreferencesKey::pictographFontFamilyKey(), Value(String(DEFAULT_PICTOGRAPH_FONT_FAMILY)));
#if ENABLE(PICTURE_IN_PICTURE_API)
        defaults.get().set(WebPreferencesKey::pictureInPictureAPIEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::plugInSnapshottingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::pluginsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::pointerEventsEnabledKey(), Value(bool(true)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::preferFasterClickOverDoubleTapKey(), Value(bool(DEFAULT_PREFER_FASTER_CLICK_OVER_DOUBLE_TAP)));
#endif
        defaults.get().set(WebPreferencesKey::primaryPlugInSnapshotDetectionEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::processSwapOnCrossSiteNavigationEnabledKey(), Value(bool(DEFAULT_PROCESS_SWAP_ON_CROSS_SITE_NAVIGATION_ENABLED)));
        defaults.get().set(WebPreferencesKey::punchOutWhiteBackgroundsInDarkModeKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::referrerPolicyAttributeEnabledKey(), Value(bool(false)));
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        defaults.get().set(WebPreferencesKey::remotePlaybackEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::requestAnimationFrameEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::requestIdleCallbackEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::requiresUserGestureForAudioPlaybackKey(), Value(bool(DEFAULT_REQUIRES_USER_GESTURE_FOR_AUDIO_PLAYBACK)));
        defaults.get().set(WebPreferencesKey::requiresUserGestureForMediaPlaybackKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::requiresUserGestureForVideoPlaybackKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::requiresUserGestureToLoadVideoKey(), Value(bool(false)));
#if ENABLE(RESIZE_OBSERVER)
        defaults.get().set(WebPreferencesKey::resizeObserverEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::resourceTimingEnabledKey(), Value(bool(true)));
#if ENABLE(RESOURCE_USAGE)
        defaults.get().set(WebPreferencesKey::resourceUsageOverlayVisibleKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::restrictedHTTPResponseAccessKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::safeBrowsingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::sansSerifFontFamilyKey(), Value(String(DEFAULT_SANS_SERIF_FONT_FAMILY)));
#if ENABLE(MEDIA_STREAM) && PLATFORM(MAC)
        defaults.get().set(WebPreferencesKey::screenCaptureEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(SMOOTH_SCROLLING)
        defaults.get().set(WebPreferencesKey::scrollAnimatorEnabledKey(), Value(bool(DEFAULT_WEBKIT_SCROLL_ANIMATOR_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::scrollingPerformanceLoggingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::secureContextChecksEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::selectTrailingWhitespaceEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::selectionAcrossShadowBoundariesEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::selectionPaintingWithoutSelectionGapsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::serifFontFamilyKey(), Value(String(DEFAULT_SERIF_FONT_FAMILY)));
        defaults.get().set(WebPreferencesKey::serverTimingEnabledKey(), Value(bool(DEFAULT_SERVER_TIMING_ENABLED)));
#if ENABLE(SERVICE_CONTROLS)
        defaults.get().set(WebPreferencesKey::serviceControlsEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(SERVICE_WORKER)
        defaults.get().set(WebPreferencesKey::serviceWorkersEnabledKey(), Value(bool(DEFAULT_SERVICE_WORKERS_ENABLED)));
#endif
        defaults.get().set(WebPreferencesKey::shadowDOMEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::shouldAllowUserInstalledFontsKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::shouldConvertPositionStyleOnCopyKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::shouldDecidePolicyBeforeLoadingQuickLookPreviewKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadKey(), Value(bool(false)));
#if ENABLE(VIDEO_TRACK)
        defaults.get().set(WebPreferencesKey::shouldDisplayCaptionsKey(), Value(bool(false)));
#endif
#if ENABLE(VIDEO_TRACK)
        defaults.get().set(WebPreferencesKey::shouldDisplaySubtitlesKey(), Value(bool(false)));
#endif
#if ENABLE(VIDEO_TRACK)
        defaults.get().set(WebPreferencesKey::shouldDisplayTextDescriptionsKey(), Value(bool(false)));
#endif
#if ENABLE(TEXT_AUTOSIZING)
        defaults.get().set(WebPreferencesKey::shouldEnableTextAutosizingBoostKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::shouldIgnoreMetaViewportKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::shouldPrintBackgroundsKey(), Value(bool(DEFAULT_SHOULD_PRINT_BACKGROUNDS)));
        defaults.get().set(WebPreferencesKey::shouldRespectImageOrientationKey(), Value(bool(DEFAULT_SHOULD_RESPECT_IMAGE_ORIENTATION)));
        defaults.get().set(WebPreferencesKey::shouldRestrictBaseURLSchemesKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::shouldSuppressTextInputFromEditingDuringProvisionalNavigationKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::shouldUseServiceWorkerShortTimeoutKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::showsToolTipOverTruncatedTextKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::showsURLsInToolTipsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::simpleLineLayoutDebugBordersEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::simpleLineLayoutEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::smartInsertDeleteEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::snapshotAllPlugInsKey(), Value(bool(false)));
#if ENABLE(MEDIA_SOURCE)
        defaults.get().set(WebPreferencesKey::sourceBufferChangeTypeEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::spatialNavigationEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::springTimingFunctionEnabledKey(), Value(bool(DEFAULT_EXPERIMENTAL_FEATURES_ENABLED)));
        defaults.get().set(WebPreferencesKey::standaloneKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::standardFontFamilyKey(), Value(String(DEFAULT_STANDARD_FONT_FAMILY)));
        defaults.get().set(WebPreferencesKey::storageAccessAPIEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::storageBlockingPolicyKey(), Value(uint32_t(WebCore::SecurityOrigin::BlockThirdPartyStorage)));
        defaults.get().set(WebPreferencesKey::subpixelAntialiasedLayerTextEnabledKey(), Value(bool(DEFAULT_SUBPIXEL_ANTIALIASED_LAYER_TEXT_ENABLED)));
        defaults.get().set(WebPreferencesKey::subpixelCSSOMElementMetricsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::subresourceIntegrityEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::suppressesIncrementalRenderingKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::syntheticEditingCommandsEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::systemLayoutDirectionKey(), Value(uint32_t(0)));
#if USE(SYSTEM_PREVIEW)
        defaults.get().set(WebPreferencesKey::systemPreviewEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::tabToLinksEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::tabsToLinksKey(), Value(bool(DEFAULT_WEBKIT_TABSTOLINKS_ENABLED)));
        defaults.get().set(WebPreferencesKey::telephoneNumberParsingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::temporaryTileCohortRetentionEnabledKey(), Value(bool(DEFAULT_TEMPORARY_TILE_COHORT_RETENTION_ENABLED)));
        defaults.get().set(WebPreferencesKey::textAreasAreResizableKey(), Value(bool(DEFAULT_TEXT_AREAS_ARE_RESIZABLE)));
#if ENABLE(TEXT_AUTOSIZING)
        defaults.get().set(WebPreferencesKey::textAutosizingEnabledKey(), Value(bool(WebCore::Settings::defaultTextAutosizingEnabled())));
#endif
#if ENABLE(TEXT_AUTOSIZING)
        defaults.get().set(WebPreferencesKey::textAutosizingUsesIdempotentModeKey(), Value(bool(defaultTextAutosizingUsesIdempotentMode())));
#endif
        defaults.get().set(WebPreferencesKey::thirdPartyIframeRedirectBlockingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::threadedScrollingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::tiledScrollingIndicatorVisibleKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::undoManagerAPIEnabledKey(), Value(bool(false)));
#if ENABLE(GPU_PROCESS)
        defaults.get().set(WebPreferencesKey::useGPUProcessForMediaKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::useGiantTilesKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::useLegacyTextAlignPositionedElementBehaviorKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::userInterfaceDirectionPolicyKey(), Value(uint32_t(0)));
        defaults.get().set(WebPreferencesKey::userTimingEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::usesBackForwardCacheKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::usesEncodingDetectorKey(), Value(bool(false)));
#if ENABLE(VIDEO)
        defaults.get().set(WebPreferencesKey::videoQualityIncludesDisplayCompositingEnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::viewGestureDebuggingEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::viewportFitEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::visibleDebugOverlayRegionsKey(), Value(uint32_t(0)));
        defaults.get().set(WebPreferencesKey::visualViewportAPIEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::wantsBalancedSetDefersLoadingBehaviorKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::webAPIStatisticsEnabledKey(), Value(bool(false)));
        defaults.get().set(WebPreferencesKey::webAnimationsCSSIntegrationEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::webAnimationsCompositeOperationsEnabledKey(), Value(bool(DEFAULT_EXPERIMENTAL_FEATURES_ENABLED)));
        defaults.get().set(WebPreferencesKey::webAnimationsEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::webAnimationsMutableTimelinesEnabledKey(), Value(bool(DEFAULT_EXPERIMENTAL_FEATURES_ENABLED)));
#if ENABLE(WEB_ARCHIVE)
        defaults.get().set(WebPreferencesKey::webArchiveDebugModeEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(WEB_AUDIO)
        defaults.get().set(WebPreferencesKey::webAudioEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(WEB_AUTHN)
        defaults.get().set(WebPreferencesKey::webAuthenticationEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(WEB_AUTHN)
        defaults.get().set(WebPreferencesKey::webAuthenticationLocalAuthenticatorEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(WEBGL2)
        defaults.get().set(WebPreferencesKey::webGL2EnabledKey(), Value(bool(false)));
#endif
        defaults.get().set(WebPreferencesKey::webGLEnabledKey(), Value(bool(true)));
#if ENABLE(WEBGPU)
        defaults.get().set(WebPreferencesKey::webGPUEnabledKey(), Value(bool(false)));
#endif
#if ENABLE(WEB_RTC)
        defaults.get().set(WebPreferencesKey::webRTCDTMFEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(WEB_RTC)
        defaults.get().set(WebPreferencesKey::webRTCH264SimulcastEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(WEB_RTC)
        defaults.get().set(WebPreferencesKey::webRTCMDNSICECandidatesEnabledKey(), Value(bool(true)));
#endif
#if ENABLE(WEB_RTC)
        defaults.get().set(WebPreferencesKey::webRTCVP8CodecEnabledKey(), Value(bool(true)));
#endif
        defaults.get().set(WebPreferencesKey::webSQLDisabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::webSecurityEnabledKey(), Value(bool(true)));
        defaults.get().set(WebPreferencesKey::webShareEnabledKey(), Value(bool(DEFAULT_WEB_SHARE_ENABLED)));
        defaults.get().set(WebPreferencesKey::xssAuditorEnabledKey(), Value(bool(true)));
#if PLATFORM(IOS_FAMILY)
        defaults.get().set(WebPreferencesKey::zoomOnDoubleTapWhenRootKey(), Value(bool(false)));
#endif
    }

    return defaults;
}

} // namespace WebKit
