/*
 * Copyright (c) 2014, 2015, 2016, 2019 Apple Inc. All rights reserved.
 * Copyright (c) 2014, 2017 -2017 Apple Inc. All rights reserved.
 * Copyright (c) 2015 Andy VanWagoner <andy@vanwagoner.family>.
 * Copyright (c) 2015 Jordan Harband. All rights reserved.
 * Copyright (c) 2015, 2016 -2016 Apple Inc. All rights reserved.
 * Copyright (c) 2015, 2016 -2016 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2015, 2016, 2017 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2016 Caitlin Potter <caitp@igalia.com>.
 * Copyright (c) 2016 Yusuke Suzuki <utatane.tea@gmail.com>
 * Copyright (c) 2016, 2017 -2017 Yusuke Suzuki <utatane.tea@gmail.com>.
 * Copyright (c) 2016, 2017, 2018 Oleksandr Skachkov <gskachkov@gmail.com>.
 * Copyright (c) 2016, 2018 -2018 Apple Inc. All rights reserved.
 * Copyright (c) 2016, 2019 -2019 Apple Inc. All rights reserved.
 * Copyright (c) 2017 Caio Lima <ticaiolima@gmail.com>.
 * Copyright (c) 2018 Yusuke Suzuki <yusukesuzuki@slowstart.org>.
 * Copyright (c) 2019 Alexey Shvayka <shvaikalesh@gmail.com>.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

// DO NOT EDIT THIS FILE. It is automatically generated from JavaScript files for
// builtins by the script: Source/JavaScriptCore/Scripts/generate-js-builtins.py

#include "config.h"
#include "JSCBuiltins.h"

#include "BuiltinExecutables.h"
#include "HeapInlines.h"
#include "IdentifierInlines.h"
#include "Intrinsic.h"
#include "JSCellInlines.h"
#include "UnlinkedFunctionExecutable.h"
#include "VM.h"

namespace JSC {

const char s_JSCCombinedCode[] = { 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 44, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 34, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 101, 120, 101, 99, 117, 116, 111, 114, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 116, 97, 107, 101, 115, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 44, 32, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 111, 114, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 77, 97, 112, 40, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 34, 44, 32, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 75, 105, 110, 100, 34, 44, 32, 107, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 109, 97, 112, 66, 117, 99, 107, 101, 116, 34, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 101, 99, 117, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 101, 120, 101, 99, 117, 116, 111, 114, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 116, 97, 107, 101, 115, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 44, 32, 32, 102, 97, 108, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 120, 101, 99, 117, 116, 111, 114, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 69, 120, 112, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 103, 108, 111, 98, 97, 108, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 82, 101, 103, 69, 120, 112, 34, 44, 32, 114, 101, 103, 69, 120, 112, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 83, 116, 114, 105, 110, 103, 34, 44, 32, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 71, 108, 111, 98, 97, 108, 34, 44, 32, 103, 108, 111, 98, 97, 108, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 85, 110, 105, 99, 111, 100, 101, 34, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 102, 97, 108, 115, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 83, 101, 116, 40, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 34, 44, 32, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 75, 105, 110, 100, 34, 44, 32, 107, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 101, 116, 66, 117, 99, 107, 101, 116, 34, 44, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 105, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 105, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 117, 110, 105, 99, 111, 100, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 43, 32, 49, 32, 62, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 114, 115, 116, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 32, 60, 32, 48, 120, 68, 56, 48, 48, 32, 124, 124, 32, 102, 105, 114, 115, 116, 32, 62, 32, 48, 120, 68, 66, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 99, 111, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 110, 100, 101, 120, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 99, 111, 110, 100, 32, 60, 32, 48, 120, 68, 67, 48, 48, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 32, 62, 32, 48, 120, 68, 70, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 100, 101, 120, 32, 43, 32, 50, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 115, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 91, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 117, 115, 58, 32, 34, 102, 117, 108, 102, 105, 108, 108, 101, 100, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 111, 98, 106, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 117, 115, 58, 32, 34, 114, 101, 106, 101, 99, 116, 101, 100, 34, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 97, 115, 111, 110, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 111, 98, 106, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 91, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 93, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 82, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 115, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 106, 101, 99, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 70, 108, 111, 97, 116, 51, 50, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 70, 108, 111, 97, 116, 54, 52, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 73, 110, 116, 49, 54, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 32, 32, 32, 32, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 73, 110, 116, 51, 50, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 32, 32, 32, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 73, 110, 116, 56, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 85, 105, 110, 116, 49, 54, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 32, 32, 32, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 85, 105, 110, 116, 51, 50, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 85, 105, 110, 116, 56, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 32, 32, 32, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 108, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 85, 105, 110, 116, 56, 67, 108, 97, 109, 112, 101, 100, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 117, 114, 108, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 97, 34, 44, 32, 34, 110, 97, 109, 101, 34, 44, 32, 117, 114, 108, 41, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 116, 97, 114, 103, 101, 116, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 97, 112, 112, 108, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 97, 112, 112, 108, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 116, 104, 105, 114, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 76, 105, 115, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 62, 62, 62, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 105, 110, 100, 101, 120, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 105, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 45, 49, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 61, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 32, 123, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 40, 99, 97, 112, 116, 117, 114, 101, 100, 71, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 97, 115, 121, 110, 99, 70, 117, 110, 99, 116, 105, 111, 110, 82, 101, 115, 117, 109, 101, 40, 99, 97, 112, 116, 117, 114, 101, 100, 71, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 110, 32, 97, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 69, 110, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 123, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 58, 32, 110, 117, 108, 108, 125, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 69, 120, 101, 99, 117, 116, 105, 111, 110, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 33, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 115, 69, 109, 112, 116, 121, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 116, 97, 116, 111, 114, 39, 115, 32, 81, 117, 101, 117, 101, 32, 105, 115, 32, 97, 110, 32, 101, 109, 112, 116, 121, 32, 76, 105, 115, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 114, 101, 115, 117, 108, 116, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 44, 32, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 117, 112, 100, 97, 116, 101, 100, 70, 105, 114, 115, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 105, 116, 101, 109, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 105, 116, 101, 109, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 108, 97, 115, 116, 44, 32, 34, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 116, 101, 109, 78, 101, 120, 116, 34, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 76, 97, 115, 116, 44, 32, 105, 116, 101, 109, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 32, 61, 61, 61, 32, 110, 117, 108, 108, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 68, 101, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 68, 101, 113, 117, 101, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 46, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 78, 101, 120, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 116, 97, 116, 101, 32, 33, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 115, 104, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 105, 110, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 32, 115, 116, 97, 116, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 65, 119, 97, 105, 116, 105, 110, 103, 82, 101, 116, 117, 114, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 81, 117, 101, 117, 101, 73, 115, 69, 109, 112, 116, 121, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 81, 117, 101, 117, 101, 70, 105, 114, 115, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 33, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 83, 116, 97, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 65, 119, 97, 105, 116, 105, 110, 103, 82, 101, 116, 117, 114, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 109, 111, 100, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 41, 59, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 83, 116, 97, 114, 116, 32, 124, 124, 32, 64, 105, 115, 83, 117, 115, 112, 101, 110, 100, 89, 105, 101, 108, 100, 83, 116, 97, 116, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 44, 32, 34, 65, 115, 121, 110, 99, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 32, 104, 97, 115, 32, 119, 114, 111, 110, 103, 32, 115, 116, 97, 116, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 46, 118, 97, 108, 117, 101, 44, 32, 110, 101, 120, 116, 46, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 65, 119, 97, 105, 116, 101, 100, 40, 114, 101, 115, 117, 108, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 102, 97, 108, 115, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 65, 119, 97, 105, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 32, 125, 59, 10, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 105, 103, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 105, 103, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 86, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 116, 104, 105, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 116, 97, 114, 103, 101, 116, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 110, 115, 105, 100, 101, 32, 70, 117, 110, 99, 116, 105, 111, 110, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 105, 110, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 111, 117, 110, 100, 65, 114, 103, 115, 32, 61, 32, 64, 99, 114, 101, 97, 116, 101, 65, 114, 103, 117, 109, 101, 110, 116, 115, 66, 117, 116, 116, 101, 114, 102, 108, 121, 40, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 104, 97, 115, 79, 119, 110, 76, 101, 110, 103, 116, 104, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 97, 114, 103, 101, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 61, 32, 116, 97, 114, 103, 101, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 61, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 124, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 62, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 108, 101, 110, 103, 116, 104, 86, 97, 108, 117, 101, 32, 45, 32, 110, 117, 109, 66, 111, 117, 110, 100, 65, 114, 103, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 32, 61, 32, 116, 97, 114, 103, 101, 116, 46, 110, 97, 109, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 110, 97, 109, 101, 32, 33, 61, 61, 32, 34, 115, 116, 114, 105, 110, 103, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 32, 61, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 107, 101, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 104, 105, 115, 86, 97, 108, 117, 101, 44, 32, 98, 111, 117, 110, 100, 65, 114, 103, 115, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 110, 97, 109, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 108, 105, 110, 107, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 98, 111, 108, 100, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 98, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 44, 32, 105, 45, 49, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 64, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 65, 114, 103, 117, 109, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 86, 97, 108, 117, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 116, 104, 101, 110, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 80, 114, 111, 109, 105, 115, 101, 46, 64, 114, 101, 115, 111, 108, 118, 101, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 46, 64, 116, 104, 101, 110, 40, 64, 119, 101, 98, 65, 115, 115, 101, 109, 98, 108, 121, 67, 111, 109, 112, 105, 108, 101, 83, 116, 114, 101, 97, 109, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 105, 114, 115, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 49, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 116, 104, 105, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 104, 105, 115, 46, 64, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 83, 121, 109, 98, 111, 108, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 102, 105, 114, 115, 116, 41, 32, 124, 124, 32, 40, 33, 64, 105, 115, 80, 114, 111, 120, 121, 79, 98, 106, 101, 99, 116, 40, 102, 105, 114, 115, 116, 41, 32, 38, 38, 32, 102, 105, 114, 115, 116, 46, 64, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 83, 121, 109, 98, 111, 108, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 41, 41, 32, 123, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 99, 111, 110, 99, 97, 116, 77, 101, 109, 99, 112, 121, 40, 116, 104, 105, 115, 44, 32, 102, 105, 114, 115, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 99, 111, 110, 99, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 110, 99, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 97, 105, 108, 67, 97, 108, 108, 70, 111, 114, 119, 97, 114, 100, 65, 114, 103, 117, 109, 101, 110, 116, 115, 40, 64, 115, 116, 114, 105, 110, 103, 67, 111, 110, 99, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 110, 99, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 67, 111, 117, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 73, 115, 65, 114, 114, 97, 121, 32, 61, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 32, 61, 32, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 32, 38, 38, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 46, 64, 105, 115, 67, 111, 110, 99, 97, 116, 83, 112, 114, 101, 97, 100, 97, 98, 108, 101, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 32, 64, 105, 115, 65, 114, 114, 97, 121, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 32, 124, 124, 32, 115, 112, 114, 101, 97, 100, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 32, 64, 77, 65, 88, 95, 65, 82, 82, 65, 89, 95, 73, 78, 68, 69, 88, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 73, 115, 65, 114, 114, 97, 121, 32, 38, 38, 32, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 112, 112, 101, 110, 100, 77, 101, 109, 99, 112, 121, 40, 114, 101, 115, 117, 108, 116, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 65, 82, 82, 65, 89, 95, 73, 78, 68, 69, 88, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 76, 101, 110, 103, 116, 104, 32, 101, 120, 99, 101, 101, 100, 101, 100, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 114, 114, 97, 121, 32, 108, 101, 110, 103, 116, 104, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 43, 43, 44, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 97, 114, 103, 73, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 97, 114, 103, 73, 110, 100, 101, 120, 43, 43, 32, 60, 32, 97, 114, 103, 67, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 115, 117, 108, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 101, 120, 99, 108, 117, 100, 101, 100, 83, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 116, 97, 114, 103, 101, 116, 32, 110, 101, 101, 100, 115, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 111, 117, 114, 99, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 64, 111, 119, 110, 75, 101, 121, 115, 40, 102, 114, 111, 109, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 76, 101, 110, 103, 116, 104, 32, 61, 32, 107, 101, 121, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 107, 101, 121, 115, 76, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 75, 101, 121, 32, 61, 32, 107, 101, 121, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 120, 99, 108, 117, 100, 101, 100, 83, 101, 116, 46, 64, 104, 97, 115, 40, 110, 101, 120, 116, 75, 101, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 112, 114, 111, 112, 101, 114, 116, 121, 73, 115, 69, 110, 117, 109, 101, 114, 97, 98, 108, 101, 40, 102, 114, 111, 109, 44, 32, 110, 101, 120, 116, 75, 101, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 112, 86, 97, 108, 117, 101, 32, 61, 32, 102, 114, 111, 109, 91, 110, 101, 120, 116, 75, 101, 121, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 100, 101, 102, 105, 110, 101, 69, 110, 117, 109, 101, 114, 97, 98, 108, 101, 87, 114, 105, 116, 97, 98, 108, 101, 67, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 68, 97, 116, 97, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 110, 101, 120, 116, 75, 101, 121, 44, 32, 112, 114, 111, 112, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 116, 97, 114, 103, 101, 116, 32, 110, 101, 101, 100, 115, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 111, 117, 114, 99, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 32, 61, 32, 64, 111, 119, 110, 75, 101, 121, 115, 40, 102, 114, 111, 109, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 115, 76, 101, 110, 103, 116, 104, 32, 61, 32, 107, 101, 121, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 107, 101, 121, 115, 76, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 75, 101, 121, 32, 61, 32, 107, 101, 121, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 112, 114, 111, 112, 101, 114, 116, 121, 73, 115, 69, 110, 117, 109, 101, 114, 97, 98, 108, 101, 40, 102, 114, 111, 109, 44, 32, 110, 101, 120, 116, 75, 101, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 112, 86, 97, 108, 117, 101, 32, 61, 32, 102, 114, 111, 109, 91, 110, 101, 120, 116, 75, 101, 121, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 100, 101, 102, 105, 110, 101, 69, 110, 117, 109, 101, 114, 97, 98, 108, 101, 87, 114, 105, 116, 97, 98, 108, 101, 67, 111, 110, 102, 105, 103, 117, 114, 97, 98, 108, 101, 68, 97, 116, 97, 80, 114, 111, 112, 101, 114, 116, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 110, 101, 120, 116, 75, 101, 121, 44, 32, 112, 114, 111, 112, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 116, 97, 114, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 97, 44, 32, 98, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 97, 32, 60, 32, 98, 41, 32, 63, 32, 98, 32, 58, 32, 97, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 44, 32, 112, 111, 115, 105, 116, 105, 118, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 32, 60, 32, 112, 111, 115, 105, 116, 105, 118, 101, 41, 32, 63, 32, 109, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 32, 58, 32, 112, 111, 115, 105, 116, 105, 118, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 99, 111, 112, 121, 87, 105, 116, 104, 105, 110, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 116, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 111, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 32, 60, 32, 48, 41, 32, 63, 32, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 44, 32, 48, 41, 32, 58, 32, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 84, 97, 114, 103, 101, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 32, 63, 32, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 48, 41, 32, 58, 32, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 101, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 61, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 60, 32, 48, 41, 32, 63, 32, 109, 97, 120, 87, 105, 116, 104, 80, 111, 115, 105, 116, 105, 118, 101, 115, 40, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 44, 32, 48, 41, 32, 58, 32, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 117, 110, 116, 32, 61, 32, 109, 105, 110, 87, 105, 116, 104, 77, 97, 121, 98, 101, 78, 101, 103, 97, 116, 105, 118, 101, 90, 101, 114, 111, 65, 110, 100, 80, 111, 115, 105, 116, 105, 118, 101, 40, 102, 105, 110, 97, 108, 86, 97, 108, 117, 101, 32, 45, 32, 102, 114, 111, 109, 44, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 116, 111, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 60, 32, 116, 111, 32, 38, 38, 32, 116, 111, 32, 60, 32, 102, 114, 111, 109, 32, 43, 32, 99, 111, 117, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 32, 61, 32, 45, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 114, 111, 109, 32, 61, 32, 102, 114, 111, 109, 32, 43, 32, 99, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 111, 32, 61, 32, 116, 111, 32, 43, 32, 99, 111, 117, 110, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 99, 111, 117, 110, 116, 59, 32, 43, 43, 105, 44, 32, 102, 114, 111, 109, 32, 43, 61, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 44, 32, 116, 111, 32, 43, 61, 32, 100, 105, 114, 101, 99, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 116, 111, 93, 32, 61, 32, 97, 114, 114, 97, 121, 91, 102, 114, 111, 109, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 97, 114, 114, 97, 121, 91, 116, 111, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 79, 110, 108, 121, 32, 111, 98, 106, 101, 99, 116, 115, 32, 99, 97, 110, 32, 98, 101, 32, 119, 114, 97, 112, 112, 101, 100, 32, 98, 121, 32, 97, 115, 121, 110, 99, 45, 102, 114, 111, 109, 45, 115, 121, 110, 99, 32, 119, 114, 97, 112, 112, 101, 114, 39, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 65, 115, 121, 110, 99, 70, 114, 111, 109, 83, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 102, 117, 110, 99, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 116, 97, 103, 44, 32, 97, 116, 116, 114, 105, 98, 117, 116, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 116, 114, 105, 110, 103, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 96, 36, 123, 102, 117, 110, 99, 125, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 96, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 83, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 49, 32, 61, 32, 34, 60, 34, 32, 43, 32, 116, 97, 103, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 86, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 115, 99, 97, 112, 101, 100, 86, 32, 61, 32, 86, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 47, 34, 47, 103, 44, 32, 39, 38, 113, 117, 111, 116, 59, 39, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 49, 32, 61, 32, 112, 49, 32, 43, 32, 34, 32, 34, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 116, 116, 114, 105, 98, 117, 116, 101, 41, 32, 43, 32, 39, 61, 34, 39, 32, 43, 32, 101, 115, 99, 97, 112, 101, 100, 86, 32, 43, 32, 39, 34, 39, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 50, 32, 61, 32, 112, 49, 32, 43, 32, 34, 62, 34, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 51, 32, 61, 32, 112, 50, 32, 43, 32, 83, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 52, 32, 61, 32, 112, 51, 32, 43, 32, 34, 60, 47, 34, 32, 43, 32, 116, 97, 103, 32, 43, 32, 34, 62, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 52, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 106, 101, 99, 116, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 64, 114, 101, 106, 101, 99, 116, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 106, 101, 99, 116, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 82, 101, 115, 111, 108, 118, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 64, 114, 101, 106, 101, 99, 116, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 100, 101, 108, 101, 116, 101, 80, 114, 111, 112, 101, 114, 116, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 108, 101, 116, 101, 32, 116, 97, 114, 103, 101, 116, 91, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 93, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 32, 124, 124, 32, 33, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 64, 65, 114, 114, 97, 121, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 46, 107, 101, 121, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 114, 101, 115, 117, 109, 101, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 106, 101, 99, 116, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 115, 111, 110, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 100, 111, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 66, 111, 100, 121, 67, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 114, 101, 115, 117, 108, 116, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 119, 97, 105, 116, 86, 97, 108, 117, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 89, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 44, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 111, 108, 118, 101, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 103, 101, 116, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 32, 61, 32, 64, 110, 101, 119, 82, 101, 103, 105, 115, 116, 114, 121, 69, 110, 116, 114, 121, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 114, 101, 103, 105, 115, 116, 114, 121, 46, 64, 115, 101, 116, 40, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 110, 116, 114, 105, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 77, 97, 112, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 98, 106, 101, 99, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 34, 79, 98, 106, 101, 99, 116, 46, 101, 110, 116, 114, 105, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 105, 110, 112, 117, 116, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 40, 111, 98, 106, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 110, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 32, 61, 32, 110, 97, 109, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 112, 114, 111, 112, 101, 114, 116, 121, 73, 115, 69, 110, 117, 109, 101, 114, 97, 98, 108, 101, 40, 111, 98, 106, 44, 32, 110, 97, 109, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 46, 64, 112, 117, 115, 104, 40, 91, 110, 97, 109, 101, 44, 32, 111, 98, 106, 91, 110, 97, 109, 101, 93, 93, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 110, 116, 114, 105, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 83, 101, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 101, 118, 101, 114, 121, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 83, 116, 97, 114, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 101, 110, 100, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 97, 108, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 110, 97, 108, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 114, 101, 108, 97, 116, 105, 118, 101, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 110, 97, 108, 32, 62, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 97, 108, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 102, 105, 110, 97, 108, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 114, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 10, 32, 32, 32, 32, 115, 116, 97, 114, 116, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 108, 97, 109, 112, 65, 114, 103, 117, 109, 101, 110, 116, 84, 111, 83, 116, 97, 114, 116, 79, 114, 69, 110, 100, 40, 115, 116, 97, 114, 116, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 101, 110, 100, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 67, 108, 97, 109, 112, 65, 114, 103, 117, 109, 101, 110, 116, 84, 111, 83, 116, 97, 114, 116, 79, 114, 69, 110, 100, 40, 101, 110, 100, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 115, 116, 97, 114, 116, 59, 32, 105, 32, 60, 32, 101, 110, 100, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 91, 105, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 48, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 99, 117, 114, 114, 101, 110, 116, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 110, 101, 120, 116, 73, 110, 100, 101, 120, 44, 32, 99, 117, 114, 114, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 110, 101, 120, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 108, 116, 101, 114, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 112, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 101, 112, 116, 46, 64, 112, 117, 115, 104, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 107, 101, 112, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 40, 114, 101, 115, 117, 108, 116, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 115, 112, 101, 99, 105, 101, 115, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 40, 114, 101, 115, 117, 108, 116, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 115, 117, 108, 116, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 107, 101, 112, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 107, 101, 112, 116, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 64, 103, 101, 116, 84, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 32, 61, 32, 64, 103, 101, 116, 67, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 116, 104, 101, 110, 40, 116, 104, 101, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 97, 116, 99, 104, 70, 105, 110, 97, 108, 108, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 86, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 107, 86, 97, 108, 117, 101, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 107, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 32, 61, 32, 116, 104, 105, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 101, 108, 101, 109, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 108, 101, 109, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 110, 100, 73, 110, 100, 101, 120, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 105, 120, 101, 100, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 116, 116, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 116, 104, 78, 117, 109, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 116, 104, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 116, 104, 78, 117, 109, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 100, 101, 112, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 48, 41, 59, 10, 10, 32, 32, 32, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 114, 101, 115, 117, 108, 116, 44, 32, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 44, 32, 100, 101, 112, 116, 104, 78, 117, 109, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 100, 101, 112, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 60, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 105, 110, 32, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 115, 111, 117, 114, 99, 101, 91, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 100, 101, 112, 116, 104, 32, 62, 32, 48, 32, 38, 38, 32, 64, 105, 115, 65, 114, 114, 97, 121, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 101, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 100, 101, 112, 116, 104, 32, 45, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 102, 108, 97, 116, 116, 101, 110, 32, 97, 114, 114, 97, 121, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 101, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 115, 111, 117, 114, 99, 101, 44, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 60, 32, 115, 111, 117, 114, 99, 101, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 32, 105, 110, 32, 115, 111, 117, 114, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 108, 101, 109, 101, 110, 116, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 115, 111, 117, 114, 99, 101, 91, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 93, 44, 32, 115, 111, 117, 114, 99, 101, 73, 110, 100, 101, 120, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 65, 114, 114, 97, 121, 40, 101, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 40, 116, 97, 114, 103, 101, 116, 44, 32, 101, 108, 101, 109, 101, 110, 116, 44, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 101, 108, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 41, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 32, 62, 61, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 102, 108, 97, 116, 116, 101, 110, 32, 97, 114, 114, 97, 121, 32, 101, 120, 99, 101, 101, 100, 115, 32, 50, 42, 42, 53, 51, 32, 45, 32, 49, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 44, 32, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 44, 32, 101, 108, 101, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 116, 97, 114, 103, 101, 116, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 77, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 108, 97, 116, 77, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 48, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 108, 97, 116, 73, 110, 116, 111, 65, 114, 114, 97, 121, 87, 105, 116, 104, 67, 97, 108, 108, 98, 97, 99, 107, 40, 114, 101, 115, 117, 108, 116, 44, 32, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 48, 44, 32, 99, 97, 108, 108, 98, 97, 99, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 108, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 110, 116, 99, 111, 108, 111, 114, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 102, 111, 110, 116, 34, 44, 32, 34, 99, 111, 108, 111, 114, 34, 44, 32, 99, 111, 108, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 105, 122, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 110, 116, 115, 105, 122, 101, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 102, 111, 110, 116, 34, 44, 32, 34, 115, 105, 122, 101, 34, 44, 32, 115, 105, 122, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 77, 97, 112, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 39, 102, 117, 110, 99, 116, 105, 111, 110, 39, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 77, 97, 112, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 86, 97, 108, 117, 101, 40, 98, 117, 99, 107, 101, 116, 41, 44, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 108, 108, 101, 100, 32, 111, 110, 32, 110, 111, 110, 45, 83, 101, 116, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 39, 102, 117, 110, 99, 116, 105, 111, 110, 39, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 72, 101, 97, 100, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 100, 111, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 107, 101, 121, 44, 32, 107, 101, 121, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 102, 111, 114, 69, 97, 99, 104, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 79, 98, 106, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 109, 115, 46, 64, 105, 116, 101, 114, 97, 116, 111, 114, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 79, 98, 106, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 79, 98, 106, 40, 41, 32, 58, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 109, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 105, 116, 101, 114, 97, 116, 111, 114, 83, 121, 109, 98, 111, 108, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 79, 98, 106, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 79, 98, 106, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 109, 115, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 70, 110, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 109, 97, 112, 70, 110, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 115, 101, 99, 111, 110, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 119, 104, 101, 110, 32, 112, 114, 111, 118, 105, 100, 101, 100, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 50, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 115, 44, 32, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 110, 32, 97, 114, 114, 97, 121, 45, 108, 105, 107, 101, 32, 111, 98, 106, 101, 99, 116, 32, 45, 32, 110, 111, 116, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 61, 32, 105, 116, 101, 109, 115, 46, 64, 105, 116, 101, 114, 97, 116, 111, 114, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 44, 32, 105, 116, 101, 109, 115, 91, 83, 121, 109, 98, 111, 108, 46, 105, 116, 101, 114, 97, 116, 111, 114, 93, 44, 32, 119, 104, 101, 110, 32, 101, 120, 105, 115, 116, 115, 44, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 109, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 119, 114, 97, 112, 112, 101, 114, 32, 61, 32, 123, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 114, 97, 112, 112, 101, 114, 46, 64, 105, 116, 101, 114, 97, 116, 111, 114, 83, 121, 109, 98, 111, 108, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 105, 116, 101, 114, 97, 116, 111, 114, 59, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 119, 114, 97, 112, 112, 101, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 44, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 97, 108, 108, 111, 99, 97, 116, 101, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 102, 114, 111, 109, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 105, 116, 115, 32, 116, 104, 105, 115, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 115, 117, 98, 99, 108, 97, 115, 115, 32, 97, 32, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 40, 107, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 107, 59, 32, 105, 43, 43, 41, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 91, 105, 93, 59, 10, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 97, 108, 108, 111, 99, 97, 116, 101, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 116, 104, 105, 115, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 115, 117, 98, 99, 108, 97, 115, 115, 32, 97, 32, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 40, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 76, 105, 107, 101, 91, 107, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 112, 70, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 63, 32, 109, 97, 112, 70, 110, 40, 118, 97, 108, 117, 101, 44, 32, 107, 41, 32, 58, 32, 109, 97, 112, 70, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 118, 97, 108, 117, 101, 44, 32, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 107, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 43, 43, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 123, 125, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 101, 110, 116, 114, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 79, 98, 106, 101, 99, 116, 46, 102, 114, 111, 109, 69, 110, 116, 114, 105, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 105, 116, 101, 114, 97, 98, 108, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 121, 105, 101, 108, 100, 115, 32, 111, 98, 106, 101, 99, 116, 115, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 101, 110, 116, 114, 121, 91, 48, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 101, 110, 116, 114, 121, 91, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 111, 98, 106, 101, 99, 116, 44, 32, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 115, 111, 117, 114, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 102, 111, 114, 99, 101, 70, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 64, 73, 110, 115, 112, 101, 99, 116, 111, 114, 73, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 46, 112, 114, 111, 109, 105, 115, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 41, 59, 10, 10, 32, 32, 32, 32, 64, 116, 114, 105, 103, 103, 101, 114, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 84, 104, 105, 115, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 78, 101, 120, 116, 41, 46, 64, 99, 97, 108, 108, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 84, 104, 105, 115, 44, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 115, 116, 97, 116, 101, 44, 32, 115, 101, 110, 116, 86, 97, 108, 117, 101, 44, 32, 114, 101, 115, 117, 109, 101, 77, 111, 100, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 70, 114, 97, 109, 101, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 114, 101, 97, 115, 111, 110, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 116, 121, 112, 101, 111, 102, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 114, 101, 115, 117, 108, 116, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 101, 114, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 116, 104, 114, 111, 119, 32, 114, 101, 97, 115, 111, 110, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 116, 104, 114, 111, 119, 101, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 105, 110, 97, 108, 108, 121, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 40, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 116, 121, 112, 101, 111, 102, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 111, 110, 70, 105, 110, 97, 108, 108, 121, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 114, 101, 115, 117, 108, 116, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 84, 104, 117, 110, 107, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 118, 97, 108, 117, 101, 84, 104, 117, 110, 107, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 44, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 97, 114, 103, 101, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 102, 108, 101, 99, 116, 46, 104, 97, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 98, 101, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 112, 101, 114, 116, 121, 75, 101, 121, 32, 105, 110, 32, 116, 97, 114, 103, 101, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 70, 108, 97, 103, 115, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 102, 108, 97, 103, 115, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 70, 108, 97, 103, 115, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 70, 108, 97, 103, 115, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 105, 103, 110, 111, 114, 101, 67, 97, 115, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 73, 103, 110, 111, 114, 101, 67, 97, 115, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 77, 117, 108, 116, 105, 108, 105, 110, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 109, 117, 108, 116, 105, 108, 105, 110, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 77, 117, 108, 116, 105, 108, 105, 110, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 77, 117, 108, 116, 105, 108, 105, 110, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 116, 105, 99, 107, 121, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 115, 116, 105, 99, 107, 121, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 116, 105, 99, 107, 121, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 83, 116, 105, 99, 107, 121, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 83, 111, 117, 114, 99, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 115, 111, 117, 114, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 83, 111, 117, 114, 99, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 83, 111, 117, 114, 99, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 108, 97, 99, 101, 114, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 116, 121, 112, 101, 83, 121, 109, 98, 111, 108, 82, 101, 112, 108, 97, 99, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 69, 120, 101, 99, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 103, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 71, 108, 111, 98, 97, 108, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 71, 108, 111, 98, 97, 108, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 117, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 85, 110, 105, 99, 111, 100, 101, 32, 33, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 80, 114, 111, 116, 111, 85, 110, 105, 99, 111, 100, 101, 71, 101, 116, 116, 101, 114, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 110, 99, 108, 117, 100, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 114, 111, 109, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 102, 114, 111, 109, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 114, 111, 109, 73, 110, 100, 101, 120, 32, 62, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 43, 32, 102, 114, 111, 109, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 61, 61, 61, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 124, 124, 32, 40, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 33, 61, 61, 32, 115, 101, 97, 114, 99, 104, 69, 108, 101, 109, 101, 110, 116, 32, 38, 38, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 32, 33, 61, 61, 32, 99, 117, 114, 114, 101, 110, 116, 69, 108, 101, 109, 101, 110, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 80, 114, 111, 109, 105, 115, 101, 46, 64, 114, 101, 115, 111, 108, 118, 101, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 46, 64, 116, 104, 101, 110, 40, 64, 119, 101, 98, 65, 115, 115, 101, 109, 98, 108, 121, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 83, 116, 114, 101, 97, 109, 105, 110, 103, 73, 110, 116, 101, 114, 110, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 108, 114, 101, 97, 100, 121, 67, 97, 108, 108, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 45, 45, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 118, 97, 108, 117, 101, 115, 44, 32, 105, 110, 100, 101, 120, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 32, 61, 32, 110, 101, 119, 82, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 40, 105, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 114, 101, 109, 97, 105, 110, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 114, 101, 115, 111, 108, 118, 101, 69, 108, 101, 109, 101, 110, 116, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 114, 97, 121, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 74, 83, 65, 114, 114, 97, 121, 40, 97, 114, 114, 97, 121, 41, 32, 124, 124, 32, 64, 105, 115, 68, 101, 114, 105, 118, 101, 100, 65, 114, 114, 97, 121, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 120, 121, 79, 98, 106, 101, 99, 116, 40, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 115, 65, 114, 114, 97, 121, 83, 108, 111, 119, 40, 97, 114, 114, 97, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 98, 106, 101, 99, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 98, 106, 101, 99, 116, 32, 61, 61, 32, 110, 117, 108, 108, 32, 124, 124, 32, 116, 121, 112, 101, 111, 102, 32, 111, 98, 106, 101, 99, 116, 32, 61, 61, 61, 32, 34, 111, 98, 106, 101, 99, 116, 34, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 115, 111, 110, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 115, 116, 97, 116, 101, 32, 62, 32, 48, 32, 38, 38, 32, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 78, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 114, 101, 97, 115, 111, 110, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 65, 119, 97, 105, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 32, 38, 38, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 118, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 32, 38, 38, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 45, 64, 73, 110, 102, 105, 110, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 64, 116, 111, 78, 117, 109, 98, 101, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 32, 33, 61, 61, 32, 118, 97, 108, 117, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 40, 115, 116, 97, 116, 101, 32, 62, 32, 48, 32, 38, 38, 32, 64, 103, 101, 116, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 103, 101, 110, 101, 114, 97, 116, 111, 114, 44, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 41, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 117, 115, 112, 101, 110, 100, 82, 101, 97, 115, 111, 110, 89, 105, 101, 108, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 124, 124, 32, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 65, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 83, 117, 115, 112, 101, 110, 100, 101, 100, 89, 105, 101, 108, 100, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 105, 116, 97, 108, 105, 99, 115, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 105, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 107, 101, 121, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 77, 97, 112, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 69, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 77, 111, 100, 117, 108, 101, 82, 101, 97, 100, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 82, 101, 97, 100, 121, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 68, 101, 99, 108, 97, 114, 97, 116, 105, 111, 110, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 108, 105, 110, 107, 69, 114, 114, 111, 114, 32, 61, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 114, 114, 111, 114, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 117, 114, 108, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 108, 105, 110, 107, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 97, 34, 44, 32, 34, 104, 114, 101, 102, 34, 44, 32, 117, 114, 108, 41, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 60, 32, 64, 77, 111, 100, 117, 108, 101, 76, 105, 110, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 113, 117, 101, 115, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 105, 115, 32, 110, 111, 116, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 100, 32, 121, 101, 116, 46, 34, 41, 59, 10, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 111, 97, 100, 77, 111, 100, 117, 108, 101, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 65, 110, 100, 69, 118, 97, 108, 117, 97, 116, 101, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 40, 109, 111, 100, 117, 108, 101, 78, 97, 109, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 110, 101, 119, 32, 64, 83, 101, 116, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 97, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 114, 101, 97, 116, 101, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 105, 44, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 112, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 115, 112, 101, 99, 105, 101, 115, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 40, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 110, 101, 119, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 109, 97, 112, 112, 101, 100, 86, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 109, 97, 112, 66, 117, 99, 107, 101, 116, 34, 44, 32, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 77, 97, 112, 66, 117, 99, 107, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 109, 97, 112, 66, 117, 99, 107, 101, 116, 86, 97, 108, 117, 101, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 32, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 32, 93, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 75, 101, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 107, 101, 121, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 109, 97, 116, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 77, 97, 116, 99, 104, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 77, 97, 116, 99, 104, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 116, 99, 104, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 115, 116, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 64, 109, 97, 116, 99, 104, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 101, 114, 32, 33, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 109, 97, 116, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 46, 64, 109, 97, 116, 99, 104, 83, 121, 109, 98, 111, 108, 40, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 69, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 109, 97, 116, 99, 104, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 77, 97, 116, 99, 104, 101, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 69, 120, 112, 44, 32, 64, 82, 101, 103, 69, 120, 112, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 103, 69, 120, 112, 46, 102, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 110, 101, 119, 32, 77, 97, 116, 99, 104, 101, 114, 40, 114, 101, 103, 69, 120, 112, 44, 32, 102, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 116, 99, 104, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 103, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 117, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 40, 109, 97, 116, 99, 104, 101, 114, 44, 32, 115, 116, 114, 105, 110, 103, 44, 32, 103, 108, 111, 98, 97, 108, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 116, 111, 32, 98, 101, 32, 110, 117, 108, 108, 32, 110, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 97, 114, 103, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 40, 97, 114, 103, 41, 32, 38, 38, 32, 33, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 46, 102, 108, 97, 103, 115, 41, 44, 32, 34, 103, 34, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 109, 97, 116, 99, 104, 65, 108, 108, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 97, 32, 110, 111, 110, 45, 103, 108, 111, 98, 97, 108, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 114, 32, 61, 32, 97, 114, 103, 46, 64, 109, 97, 116, 99, 104, 65, 108, 108, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 109, 97, 116, 99, 104, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 109, 97, 116, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 97, 114, 103, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 97, 114, 103, 44, 32, 34, 103, 34, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 103, 69, 120, 112, 46, 64, 109, 97, 116, 99, 104, 65, 108, 108, 83, 121, 109, 98, 111, 108, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 103, 101, 120, 112, 46, 103, 108, 111, 98, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 117, 110, 105, 99, 111, 100, 101, 59, 10, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 120, 105, 109, 117, 109, 82, 101, 97, 115, 111, 110, 97, 98, 108, 101, 77, 97, 116, 99, 104, 83, 105, 122, 101, 32, 61, 32, 49, 48, 48, 48, 48, 48, 48, 48, 48, 59, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 109, 97, 120, 105, 109, 117, 109, 82, 101, 97, 115, 111, 110, 97, 98, 108, 101, 77, 97, 116, 99, 104, 83, 105, 122, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 64, 112, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 101, 118, 97, 108, 117, 97, 116, 101, 100, 32, 61, 32, 116, 114, 117, 101, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 105, 115, 46, 109, 111, 100, 117, 108, 101, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 101, 118, 97, 108, 117, 97, 116, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 64, 114, 101, 106, 101, 99, 116, 40, 114, 101, 97, 115, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 99, 97, 112, 116, 117, 114, 101, 100, 80, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 64, 114, 101, 106, 101, 99, 116, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 58, 32, 112, 114, 111, 109, 105, 115, 101, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 125, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 112, 114, 111, 109, 105, 115, 101, 32, 99, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 110, 101, 119, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 106, 101, 99, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 115, 101, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 106, 101, 99, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 115, 101, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 32, 61, 32, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 32, 61, 32, 114, 101, 106, 101, 99, 116, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 101, 120, 101, 99, 117, 116, 111, 114, 32, 100, 105, 100, 32, 110, 111, 116, 32, 116, 97, 107, 101, 32, 97, 32, 114, 101, 115, 111, 108, 118, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 101, 120, 101, 99, 117, 116, 111, 114, 32, 100, 105, 100, 32, 110, 111, 116, 32, 116, 97, 107, 101, 32, 97, 32, 114, 101, 106, 101, 99, 116, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 58, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 58, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 58, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 110, 101, 120, 116, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 101, 121, 58, 32, 107, 101, 121, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 116, 101, 58, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 101, 116, 99, 104, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 97, 116, 105, 115, 102, 121, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 58, 32, 91, 93, 44, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 111, 100, 117, 108, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 105, 110, 107, 69, 114, 114, 111, 114, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 108, 105, 110, 107, 83, 117, 99, 99, 101, 101, 100, 101, 100, 58, 32, 116, 114, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 118, 97, 108, 117, 97, 116, 101, 100, 58, 32, 102, 97, 108, 115, 101, 44, 10, 32, 32, 32, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 65, 114, 114, 97, 121, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 116, 101, 114, 97, 116, 101, 100, 79, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 107, 105, 110, 100, 32, 61, 32, 64, 103, 101, 116, 65, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 75, 105, 110, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 114, 114, 97, 121, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 72, 101, 108, 112, 101, 114, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 97, 114, 114, 97, 121, 44, 32, 107, 105, 110, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 110, 101, 120, 116, 77, 101, 116, 104, 111, 100, 34, 41, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 68, 111, 110, 101, 32, 61, 32, 33, 33, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 86, 97, 108, 117, 101, 32, 61, 32, 110, 101, 120, 116, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 110, 101, 120, 116, 86, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 110, 101, 120, 116, 68, 111, 110, 101, 32, 125, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 78, 111, 114, 109, 97, 108, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 109, 97, 112, 66, 117, 99, 107, 101, 116, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 77, 97, 112, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 109, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 75, 105, 110, 100, 34, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 111, 110, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 82, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 116, 111, 32, 98, 101, 32, 97, 110, 32, 82, 101, 103, 69, 120, 112, 32, 83, 116, 114, 105, 110, 103, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 100, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 69, 120, 112, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 82, 101, 103, 69, 120, 112, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 83, 116, 114, 105, 110, 103, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 71, 108, 111, 98, 97, 108, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 85, 110, 105, 99, 111, 100, 101, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 69, 120, 112, 44, 32, 115, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 116, 114, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 103, 108, 111, 98, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 109, 97, 116, 99, 104, 91, 48, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 61, 61, 32, 34, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 69, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 105, 110, 103, 44, 32, 116, 104, 105, 115, 73, 110, 100, 101, 120, 44, 32, 102, 117, 108, 108, 85, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 114, 101, 103, 69, 120, 112, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 68, 111, 110, 101, 34, 44, 32, 116, 114, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 109, 97, 116, 99, 104, 44, 32, 100, 111, 110, 101, 58, 32, 102, 97, 108, 115, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 101, 116, 66, 117, 99, 107, 101, 116, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 101, 116, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 78, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 75, 105, 110, 100, 34, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 37, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 80, 114, 111, 116, 111, 116, 121, 112, 101, 37, 46, 110, 101, 120, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 32, 83, 116, 114, 105, 110, 103, 32, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 110, 115, 116, 97, 110, 99, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 103, 101, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 103, 101, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 116, 101, 114, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 62, 62, 62, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 45, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 114, 115, 116, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 114, 115, 116, 32, 60, 32, 48, 120, 68, 56, 48, 48, 32, 124, 124, 32, 102, 105, 114, 115, 116, 32, 62, 32, 48, 120, 68, 66, 70, 70, 32, 124, 124, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 32, 61, 61, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 99, 111, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 99, 111, 110, 100, 32, 60, 32, 48, 120, 68, 67, 48, 48, 32, 124, 124, 32, 115, 101, 99, 111, 110, 100, 32, 62, 32, 48, 120, 68, 70, 70, 70, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 93, 32, 43, 32, 115, 116, 114, 105, 110, 103, 91, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 83, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 115, 116, 114, 105, 110, 103, 73, 116, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 73, 110, 100, 101, 120, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 118, 97, 108, 117, 101, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 32, 63, 32, 110, 101, 119, 32, 116, 104, 105, 115, 40, 108, 101, 110, 103, 116, 104, 41, 32, 58, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 107, 32, 61, 32, 48, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 107, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 107, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 107, 93, 41, 59, 10, 32, 32, 32, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 97, 108, 108, 111, 99, 97, 116, 101, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 34, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 111, 102, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 105, 116, 115, 32, 116, 104, 105, 115, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 116, 111, 32, 115, 117, 98, 99, 108, 97, 115, 115, 32, 97, 32, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 70, 117, 110, 99, 116, 105, 111, 110, 40, 108, 101, 110, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 91, 105, 93, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 112, 97, 100, 69, 110, 100, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 60, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 34, 32, 34, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 83, 108, 111, 119, 80, 97, 116, 104, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 32, 43, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 112, 97, 100, 83, 116, 97, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 60, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 101, 114, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 34, 32, 34, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 108, 108, 101, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 102, 105, 108, 108, 83, 116, 114, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 120, 76, 101, 110, 103, 116, 104, 32, 45, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 105, 108, 108, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 61, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 83, 108, 111, 119, 80, 97, 116, 104, 40, 102, 105, 108, 108, 101, 114, 44, 32, 102, 105, 108, 108, 76, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 110, 99, 97, 116, 101, 100, 83, 116, 114, 105, 110, 103, 70, 105, 108, 108, 101, 114, 32, 43, 32, 115, 116, 114, 105, 110, 103, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 105, 116, 101, 114, 97, 98, 108, 101, 46, 64, 105, 116, 101, 114, 97, 116, 111, 114, 83, 121, 109, 98, 111, 108, 40, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 105, 116, 101, 114, 97, 116, 111, 114, 46, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 116, 101, 109, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 116, 101, 109, 32, 61, 32, 110, 101, 120, 116, 46, 64, 99, 97, 108, 108, 40, 105, 116, 101, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 105, 116, 101, 109, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 116, 101, 109, 46, 100, 111, 110, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 105, 110, 100, 101, 120, 43, 43, 44, 32, 105, 116, 101, 109, 46, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 105, 115, 69, 110, 97, 98, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 33, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 104, 97, 110, 100, 108, 101, 114, 32, 61, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 70, 117, 108, 102, 105, 108, 108, 101, 100, 41, 32, 63, 32, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 58, 32, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 115, 117, 108, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 104, 97, 110, 100, 108, 101, 114, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 104, 97, 110, 100, 108, 101, 114, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 116, 104, 105, 115, 46, 105, 115, 69, 110, 97, 98, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 33, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 116, 104, 101, 110, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 101, 110, 46, 64, 99, 97, 108, 108, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 112, 114, 111, 109, 105, 115, 101, 84, 111, 82, 101, 115, 111, 108, 118, 101, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 110, 101, 120, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 32, 38, 38, 32, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 101, 110, 97, 98, 108, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 110, 101, 120, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 117, 108, 116, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 117, 108, 116, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 101, 110, 97, 98, 108, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 62, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 113, 117, 101, 115, 116, 101, 100, 32, 109, 111, 100, 117, 108, 101, 32, 105, 115, 32, 97, 108, 114, 101, 97, 100, 121, 32, 102, 101, 116, 99, 104, 101, 100, 46, 34, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 102, 117, 108, 102, 105, 108, 108, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 105, 116, 101, 114, 97, 98, 108, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 80, 114, 111, 109, 105, 115, 101, 32, 114, 101, 115, 111, 108, 118, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 105, 116, 101, 114, 97, 98, 108, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 80, 114, 111, 109, 105, 115, 101, 46, 116, 104, 101, 110, 40, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 115, 111, 108, 118, 101, 44, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 114, 101, 106, 101, 99, 116, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 101, 109, 112, 108, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 111, 107, 101, 100, 83, 101, 103, 109, 101, 110, 116, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 101, 109, 112, 108, 97, 116, 101, 44, 32, 34, 83, 116, 114, 105, 110, 103, 46, 114, 97, 119, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 101, 109, 112, 108, 97, 116, 101, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 99, 111, 111, 107, 101, 100, 83, 101, 103, 109, 101, 110, 116, 115, 46, 114, 97, 119, 44, 32, 34, 83, 116, 114, 105, 110, 103, 46, 114, 97, 119, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 101, 109, 112, 108, 97, 116, 101, 46, 114, 97, 119, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 79, 102, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 115, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 39, 39, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 61, 32, 39, 39, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 103, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 97, 119, 83, 101, 103, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 43, 61, 32, 115, 101, 103, 109, 101, 110, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 105, 32, 43, 32, 49, 41, 32, 61, 61, 61, 32, 115, 101, 103, 109, 101, 110, 116, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 32, 60, 32, 110, 117, 109, 98, 101, 114, 79, 102, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 73, 110, 100, 101, 120, 73, 110, 65, 114, 103, 117, 109, 101, 110, 116, 115, 32, 61, 32, 105, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 115, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 73, 110, 100, 101, 120, 73, 110, 65, 114, 103, 117, 109, 101, 110, 116, 115, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 69, 108, 101, 109, 101, 110, 116, 115, 32, 43, 61, 32, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 32, 38, 38, 32, 33, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 62, 61, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 97, 114, 114, 97, 121, 91, 107, 43, 43, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 43, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 91, 107, 43, 43, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 107, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 91, 107, 93, 44, 32, 107, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 62, 61, 32, 48, 32, 38, 38, 32, 33, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 45, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 97, 114, 114, 97, 121, 91, 107, 45, 45, 93, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 107, 32, 62, 61, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 97, 114, 114, 97, 121, 91, 107, 93, 44, 32, 107, 44, 32, 97, 114, 114, 97, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 107, 32, 45, 61, 32, 49, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 40, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 32, 38, 38, 32, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 100, 117, 99, 101, 82, 105, 103, 104, 116, 32, 111, 102, 32, 101, 109, 112, 116, 121, 32, 97, 114, 114, 97, 121, 32, 119, 105, 116, 104, 32, 110, 111, 32, 105, 110, 105, 116, 105, 97, 108, 32, 118, 97, 108, 117, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 107, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 67, 111, 117, 110, 116, 32, 62, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 116, 104, 105, 115, 91, 107, 45, 45, 93, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 107, 32, 62, 61, 32, 48, 59, 32, 107, 45, 45, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 32, 61, 32, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 91, 107, 93, 44, 32, 107, 44, 32, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 120, 101, 99, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 101, 120, 101, 99, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 120, 101, 99, 32, 33, 61, 61, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 101, 120, 101, 99, 32, 61, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 101, 120, 101, 99, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 33, 61, 61, 32, 110, 117, 108, 108, 32, 38, 38, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 104, 101, 32, 114, 101, 115, 117, 108, 116, 32, 111, 102, 32, 97, 32, 82, 101, 103, 69, 120, 112, 32, 101, 120, 101, 99, 32, 109, 117, 115, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 98, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 40, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 41, 32, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 64, 73, 110, 115, 112, 101, 99, 116, 111, 114, 73, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 46, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 101, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 82, 101, 106, 101, 99, 116, 41, 59, 10, 10, 32, 32, 32, 32, 64, 116, 114, 105, 103, 103, 101, 114, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 115, 40, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 97, 115, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 44, 32, 114, 101, 97, 115, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 101, 97, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 99, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 60, 32, 48, 32, 124, 124, 32, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 64, 73, 110, 102, 105, 110, 105, 116, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 82, 97, 110, 103, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 101, 97, 116, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 103, 114, 101, 97, 116, 101, 114, 32, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 48, 32, 97, 110, 100, 32, 110, 111, 116, 32, 98, 101, 32, 73, 110, 102, 105, 110, 105, 116, 121, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 112, 101, 97, 116, 67, 104, 97, 114, 97, 99, 116, 101, 114, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 112, 101, 97, 116, 83, 108, 111, 119, 80, 97, 116, 104, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 61, 32, 40, 99, 111, 117, 110, 116, 32, 47, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 41, 32, 124, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 32, 61, 32, 99, 111, 117, 110, 116, 32, 45, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 42, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 101, 114, 97, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 38, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 32, 62, 62, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 114, 101, 112, 101, 97, 116, 67, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 101, 114, 97, 110, 100, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 105, 110, 103, 44, 32, 48, 44, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 67, 104, 97, 114, 97, 99, 116, 101, 114, 115, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 99, 111, 117, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 48, 32, 124, 124, 32, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 61, 61, 61, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 42, 32, 99, 111, 117, 110, 116, 32, 62, 32, 64, 77, 65, 88, 95, 83, 84, 82, 73, 78, 71, 95, 76, 69, 78, 71, 84, 72, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 79, 117, 116, 79, 102, 77, 101, 109, 111, 114, 121, 69, 114, 114, 111, 114, 40, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 101, 114, 97, 110, 100, 32, 61, 32, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 116, 114, 117, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 117, 110, 116, 32, 38, 32, 49, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 117, 110, 116, 32, 62, 62, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 99, 111, 117, 110, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 101, 114, 97, 110, 100, 32, 43, 61, 32, 111, 112, 101, 114, 97, 110, 100, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 103, 101, 116, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 40, 109, 97, 116, 99, 104, 101, 100, 44, 32, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 116, 99, 104, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 105, 108, 80, 111, 115, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 32, 61, 32, 99, 97, 112, 116, 117, 114, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 116, 97, 114, 116, 32, 61, 32, 48, 59, 32, 115, 116, 97, 114, 116, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 105, 110, 100, 101, 120, 79, 102, 40, 34, 36, 34, 44, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 41, 44, 32, 115, 116, 97, 114, 116, 32, 33, 61, 61, 32, 45, 49, 59, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 61, 32, 115, 116, 97, 114, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 45, 32, 108, 97, 115, 116, 83, 116, 97, 114, 116, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 108, 97, 115, 116, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 104, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 99, 104, 97, 114, 65, 116, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 104, 32, 61, 61, 61, 32, 34, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 119, 105, 116, 99, 104, 32, 40, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 36, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 38, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 109, 97, 116, 99, 104, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 96, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 115, 116, 114, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 48, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 39, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 116, 97, 105, 108, 80, 111, 115, 32, 60, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 115, 116, 114, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 116, 97, 105, 108, 80, 111, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 115, 101, 32, 34, 60, 34, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 32, 61, 32, 115, 116, 97, 114, 116, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 105, 110, 100, 101, 120, 79, 102, 40, 34, 62, 34, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 45, 49, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 103, 114, 111, 117, 112, 78, 97, 109, 101, 83, 116, 97, 114, 116, 73, 110, 100, 101, 120, 44, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 32, 61, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 91, 103, 114, 111, 117, 112, 78, 97, 109, 101, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 116, 117, 114, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 97, 112, 116, 117, 114, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 32, 61, 32, 103, 114, 111, 117, 112, 78, 97, 109, 101, 69, 110, 100, 73, 110, 100, 101, 120, 32, 43, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 60, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 102, 97, 117, 108, 116, 58, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 104, 67, 111, 100, 101, 32, 61, 32, 99, 104, 46, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 104, 67, 111, 100, 101, 32, 62, 61, 32, 48, 120, 51, 48, 32, 38, 38, 32, 99, 104, 67, 111, 100, 101, 32, 60, 61, 32, 48, 120, 51, 57, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 32, 61, 32, 115, 116, 97, 114, 116, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 32, 61, 32, 99, 104, 67, 111, 100, 101, 32, 45, 32, 48, 120, 51, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 32, 62, 32, 109, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 114, 116, 32, 60, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 76, 101, 110, 103, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 62, 61, 32, 48, 120, 51, 48, 32, 38, 38, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 60, 61, 32, 48, 120, 51, 57, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 110, 32, 61, 32, 49, 48, 32, 42, 32, 110, 32, 43, 32, 110, 101, 120, 116, 67, 104, 67, 111, 100, 101, 32, 45, 32, 48, 120, 51, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 110, 32, 60, 61, 32, 109, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 32, 61, 32, 110, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 97, 114, 116, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 32, 61, 61, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 111, 114, 105, 103, 105, 110, 97, 108, 83, 116, 97, 114, 116, 44, 32, 115, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 32, 61, 32, 99, 97, 112, 116, 117, 114, 101, 115, 91, 110, 32, 45, 32, 49, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 116, 117, 114, 101, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 99, 97, 112, 116, 117, 114, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 34, 36, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 114, 101, 97, 107, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 108, 97, 115, 116, 83, 116, 97, 114, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 114, 101, 112, 108, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 32, 61, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 112, 108, 97, 99, 101, 32, 61, 61, 61, 32, 39, 102, 117, 110, 99, 116, 105, 111, 110, 39, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 103, 108, 111, 98, 97, 108, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 103, 108, 111, 98, 97, 108, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 103, 108, 111, 98, 97, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 117, 110, 105, 99, 111, 100, 101, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 117, 110, 105, 99, 111, 100, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 102, 97, 108, 115, 101, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 64, 112, 117, 115, 104, 40, 114, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 103, 108, 111, 98, 97, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 111, 110, 101, 32, 61, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 83, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 109, 97, 116, 99, 104, 83, 116, 114, 46, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 44, 32, 117, 110, 105, 99, 111, 100, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 61, 32, 34, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 97, 115, 116, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 76, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 76, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 115, 117, 108, 116, 76, 105, 115, 116, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 60, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 100, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 115, 117, 108, 116, 91, 48, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 32, 61, 32, 109, 97, 116, 99, 104, 101, 100, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 105, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 32, 63, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 32, 58, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 60, 32, 48, 41, 32, 63, 32, 48, 32, 58, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 91, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 110, 32, 61, 32, 49, 59, 32, 110, 32, 60, 61, 32, 110, 67, 97, 112, 116, 117, 114, 101, 115, 59, 32, 110, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 97, 112, 78, 32, 61, 32, 114, 101, 115, 117, 108, 116, 91, 110, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 112, 78, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 112, 78, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 99, 97, 112, 78, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 97, 112, 116, 117, 114, 101, 115, 46, 64, 112, 117, 115, 104, 40, 99, 97, 112, 78, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 114, 101, 115, 117, 108, 116, 46, 103, 114, 111, 117, 112, 115, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 82, 101, 112, 108, 97, 99, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 32, 61, 32, 91, 32, 109, 97, 116, 99, 104, 101, 100, 32, 93, 46, 99, 111, 110, 99, 97, 116, 40, 99, 97, 112, 116, 117, 114, 101, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 46, 64, 112, 117, 115, 104, 40, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 46, 64, 112, 117, 115, 104, 40, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 46, 64, 112, 117, 115, 104, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 86, 97, 108, 117, 101, 32, 61, 32, 114, 101, 112, 108, 97, 99, 101, 46, 64, 97, 112, 112, 108, 121, 40, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 65, 114, 103, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 112, 108, 86, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 91, 83, 121, 109, 98, 111, 108, 46, 114, 101, 112, 108, 97, 99, 101, 93, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 39, 103, 114, 111, 117, 112, 115, 39, 32, 112, 114, 111, 112, 101, 114, 116, 121, 32, 111, 102, 32, 97, 32, 109, 97, 116, 99, 104, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 61, 32, 103, 101, 116, 83, 117, 98, 115, 116, 105, 116, 117, 116, 105, 111, 110, 40, 109, 97, 116, 99, 104, 101, 100, 44, 32, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 99, 97, 112, 116, 117, 114, 101, 115, 44, 32, 110, 97, 109, 101, 100, 67, 97, 112, 116, 117, 114, 101, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 38, 38, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 108, 97, 115, 116, 80, 111, 115, 105, 116, 105, 111, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 61, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 43, 32, 115, 116, 114, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 32, 43, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 43, 32, 109, 97, 116, 99, 104, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 108, 97, 115, 116, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 32, 62, 61, 32, 115, 116, 114, 105, 110, 103, 76, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 99, 99, 117, 109, 117, 108, 97, 116, 101, 100, 82, 101, 115, 117, 108, 116, 32, 43, 32, 115, 116, 114, 46, 115, 117, 98, 115, 116, 114, 105, 110, 103, 40, 110, 101, 120, 116, 83, 111, 117, 114, 99, 101, 80, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 97, 114, 99, 104, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 32, 61, 32, 115, 101, 97, 114, 99, 104, 46, 64, 114, 101, 112, 108, 97, 99, 101, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 108, 97, 99, 101, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 83, 116, 114, 105, 110, 103, 82, 101, 112, 108, 97, 99, 101, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 112, 108, 97, 99, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 97, 114, 99, 104, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 83, 116, 114, 105, 110, 103, 83, 101, 97, 114, 99, 104, 40, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 116, 111, 32, 98, 101, 32, 110, 117, 108, 108, 32, 110, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 97, 114, 99, 104, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 41, 32, 38, 38, 32, 33, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 46, 102, 108, 97, 103, 115, 41, 44, 32, 34, 103, 34, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 32, 97, 114, 103, 117, 109, 101, 110, 116, 32, 109, 117, 115, 116, 32, 110, 111, 116, 32, 98, 101, 32, 97, 32, 110, 111, 110, 45, 103, 108, 111, 98, 97, 108, 32, 114, 101, 103, 117, 108, 97, 114, 32, 101, 120, 112, 114, 101, 115, 115, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 112, 108, 97, 99, 101, 114, 32, 61, 32, 115, 101, 97, 114, 99, 104, 46, 64, 114, 101, 112, 108, 97, 99, 101, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 112, 108, 97, 99, 101, 114, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 83, 116, 114, 105, 110, 103, 82, 101, 112, 108, 97, 99, 101, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 46, 64, 114, 101, 112, 108, 97, 99, 101, 85, 115, 105, 110, 103, 82, 101, 103, 69, 120, 112, 40, 115, 101, 97, 114, 99, 104, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 112, 108, 97, 99, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 97, 114, 99, 104, 44, 32, 116, 104, 105, 115, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 101, 97, 114, 99, 104, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 46, 64, 114, 101, 112, 108, 97, 99, 101, 65, 108, 108, 85, 115, 105, 110, 103, 83, 116, 114, 105, 110, 103, 83, 101, 97, 114, 99, 104, 40, 115, 101, 97, 114, 99, 104, 83, 116, 114, 105, 110, 103, 44, 32, 114, 101, 112, 108, 97, 99, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 32, 61, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 33, 61, 61, 32, 64, 77, 111, 100, 117, 108, 101, 70, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 46, 99, 97, 116, 99, 104, 40, 40, 101, 114, 114, 111, 114, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 117, 114, 114, 101, 110, 116, 65, 116, 116, 101, 109, 112, 116, 32, 61, 61, 61, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 102, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 46, 116, 104, 101, 110, 40, 40, 115, 111, 117, 114, 99, 101, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 111, 117, 114, 99, 101, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 102, 101, 116, 99, 104, 32, 61, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 101, 116, 99, 104, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 97, 115, 121, 110, 99, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 107, 101, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 107, 101, 121, 41, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 110, 101, 119, 32, 64, 83, 101, 116, 41, 59, 10, 32, 32, 32, 32, 116, 104, 105, 115, 46, 108, 105, 110, 107, 65, 110, 100, 69, 118, 97, 108, 117, 97, 116, 101, 77, 111, 100, 117, 108, 101, 40, 101, 110, 116, 114, 121, 46, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 46, 103, 101, 116, 77, 111, 100, 117, 108, 101, 78, 97, 109, 101, 115, 112, 97, 99, 101, 79, 98, 106, 101, 99, 116, 40, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 40, 97, 115, 121, 110, 99, 32, 40, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 117, 114, 99, 101, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 70, 101, 116, 99, 104, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 119, 97, 105, 116, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 32, 61, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 107, 101, 121, 32, 61, 32, 101, 110, 116, 114, 121, 46, 107, 101, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 32, 61, 32, 97, 119, 97, 105, 116, 32, 116, 104, 105, 115, 46, 112, 97, 114, 115, 101, 77, 111, 100, 117, 108, 101, 40, 107, 101, 121, 44, 32, 115, 111, 117, 114, 99, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 32, 61, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 40, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 78, 97, 109, 101, 32, 61, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 77, 111, 100, 117, 108, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 75, 101, 121, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 115, 111, 108, 118, 101, 83, 121, 110, 99, 40, 100, 101, 112, 78, 97, 109, 101, 44, 32, 107, 101, 121, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 69, 110, 116, 114, 121, 32, 61, 32, 116, 104, 105, 115, 46, 101, 110, 115, 117, 114, 101, 82, 101, 103, 105, 115, 116, 101, 114, 101, 100, 40, 100, 101, 112, 75, 101, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 44, 32, 105, 44, 32, 100, 101, 112, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 77, 97, 112, 46, 64, 115, 101, 116, 40, 100, 101, 112, 78, 97, 109, 101, 44, 32, 100, 101, 112, 69, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 32, 61, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 109, 111, 100, 117, 108, 101, 32, 61, 32, 109, 111, 100, 117, 108, 101, 82, 101, 99, 111, 114, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 83, 97, 116, 105, 115, 102, 121, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 125, 41, 40, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 59, 10, 10, 32, 32, 32, 32, 118, 105, 115, 105, 116, 101, 100, 46, 64, 97, 100, 100, 40, 101, 110, 116, 114, 121, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 40, 101, 110, 116, 114, 121, 44, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 46, 116, 104, 101, 110, 40, 40, 101, 110, 116, 114, 121, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 76, 111, 97, 100, 115, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 101, 112, 69, 110, 116, 114, 121, 32, 61, 32, 101, 110, 116, 114, 121, 46, 100, 101, 112, 101, 110, 100, 101, 110, 99, 105, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 105, 115, 105, 116, 101, 100, 46, 64, 104, 97, 115, 40, 100, 101, 112, 69, 110, 116, 114, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 73, 110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 40, 100, 101, 112, 69, 110, 116, 114, 121, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 116, 104, 105, 115, 46, 114, 101, 113, 117, 101, 115, 116, 83, 97, 116, 105, 115, 102, 121, 40, 100, 101, 112, 69, 110, 116, 114, 121, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 102, 101, 116, 99, 104, 101, 114, 44, 32, 118, 105, 115, 105, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 100, 101, 112, 76, 111, 97, 100, 115, 44, 32, 105, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 73, 110, 116, 101, 114, 110, 97, 108, 80, 114, 111, 109, 105, 115, 101, 46, 105, 110, 116, 101, 114, 110, 97, 108, 65, 108, 108, 40, 100, 101, 112, 76, 111, 97, 100, 115, 41, 46, 116, 104, 101, 110, 40, 40, 101, 110, 116, 114, 105, 101, 115, 41, 32, 61, 62, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 115, 101, 116, 83, 116, 97, 116, 101, 84, 111, 77, 97, 120, 40, 101, 110, 116, 114, 121, 44, 32, 64, 77, 111, 100, 117, 108, 101, 76, 105, 110, 107, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 115, 97, 116, 105, 115, 102, 121, 32, 61, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 97, 116, 105, 115, 102, 121, 80, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 118, 97, 108, 117, 101, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 116, 104, 105, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 105, 115, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 83, 108, 111, 119, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 32, 61, 61, 61, 32, 112, 114, 111, 109, 105, 115, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 111, 108, 118, 101, 32, 97, 32, 112, 114, 111, 109, 105, 115, 101, 32, 119, 105, 116, 104, 32, 105, 116, 115, 101, 108, 102, 34, 41, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 70, 97, 115, 116, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 112, 114, 111, 109, 105, 115, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 116, 104, 101, 110, 32, 33, 61, 61, 32, 39, 102, 117, 110, 99, 116, 105, 111, 110, 39, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 102, 117, 108, 102, 105, 108, 108, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 59, 10, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 116, 104, 101, 110, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 64, 97, 115, 115, 101, 114, 116, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 102, 108, 97, 103, 115, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 101, 110, 32, 61, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 46, 116, 104, 101, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 101, 114, 114, 111, 114, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 41, 32, 38, 38, 32, 116, 104, 101, 110, 32, 61, 61, 61, 32, 64, 100, 101, 102, 97, 117, 108, 116, 80, 114, 111, 109, 105, 115, 101, 84, 104, 101, 110, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 70, 97, 115, 116, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 116, 104, 101, 110, 32, 33, 61, 61, 32, 39, 102, 117, 110, 99, 116, 105, 111, 110, 39, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 102, 117, 108, 102, 105, 108, 108, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 115, 111, 108, 118, 101, 84, 104, 101, 110, 97, 98, 108, 101, 74, 111, 98, 44, 32, 114, 101, 115, 111, 108, 117, 116, 105, 111, 110, 44, 32, 116, 104, 101, 110, 44, 32, 64, 99, 114, 101, 97, 116, 101, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 115, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 32, 61, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 114, 101, 116, 117, 114, 110, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 58, 32, 116, 114, 117, 101, 32, 125, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 32, 61, 32, 114, 101, 116, 117, 114, 110, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 68, 111, 110, 101, 32, 61, 32, 33, 33, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 86, 97, 108, 117, 101, 32, 61, 32, 114, 101, 116, 117, 114, 110, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 114, 101, 115, 117, 108, 116, 86, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 114, 101, 115, 117, 108, 116, 68, 111, 110, 101, 32, 125, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 82, 101, 116, 117, 114, 110, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 32, 61, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 101, 97, 114, 99, 104, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 115, 101, 97, 114, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 33, 61, 61, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 112, 114, 101, 118, 105, 111, 117, 115, 76, 97, 115, 116, 73, 110, 100, 101, 120, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 45, 49, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 46, 105, 110, 100, 101, 120, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 103, 101, 120, 112, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 101, 97, 114, 99, 104, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 103, 101, 120, 112, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 97, 114, 99, 104, 101, 114, 32, 61, 32, 114, 101, 103, 101, 120, 112, 46, 64, 115, 101, 97, 114, 99, 104, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 97, 114, 99, 104, 101, 114, 32, 33, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 101, 97, 114, 99, 104, 101, 114, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 67, 114, 101, 97, 116, 101, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 114, 101, 97, 116, 101, 100, 82, 101, 103, 69, 120, 112, 46, 64, 115, 101, 97, 114, 99, 104, 83, 121, 109, 98, 111, 108, 40, 116, 104, 105, 115, 83, 116, 114, 105, 110, 103, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 117, 99, 107, 101, 116, 44, 32, 107, 105, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 78, 101, 120, 116, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 101, 116, 66, 117, 99, 107, 101, 116, 34, 44, 32, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 100, 111, 110, 101, 32, 61, 32, 98, 117, 99, 107, 101, 116, 32, 61, 61, 61, 32, 64, 115, 101, 110, 116, 105, 110, 101, 108, 83, 101, 116, 66, 117, 99, 107, 101, 116, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 100, 111, 110, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 115, 101, 116, 66, 117, 99, 107, 101, 116, 75, 101, 121, 40, 98, 117, 99, 107, 101, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 107, 105, 110, 100, 32, 61, 61, 61, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 69, 110, 116, 114, 105, 101, 115, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 108, 117, 101, 32, 61, 32, 91, 32, 118, 97, 108, 117, 101, 44, 32, 118, 97, 108, 117, 101, 32, 93, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 123, 32, 118, 97, 108, 117, 101, 44, 32, 100, 111, 110, 101, 32, 125, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 110, 116, 114, 121, 44, 32, 110, 101, 119, 83, 116, 97, 116, 101, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 60, 32, 110, 101, 119, 83, 116, 97, 116, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 116, 114, 121, 46, 115, 116, 97, 116, 101, 32, 61, 32, 110, 101, 119, 83, 116, 97, 116, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 109, 97, 108, 108, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 109, 97, 108, 108, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 105, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 97, 114, 114, 97, 121, 91, 105, 93, 44, 32, 105, 44, 32, 97, 114, 114, 97, 121, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 32, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 105, 115, 65, 114, 103, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 109, 101, 32, 99, 97, 108, 108, 98, 97, 99, 107, 32, 109, 117, 115, 116, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 59, 10, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 99, 97, 108, 108, 98, 97, 99, 107, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 65, 114, 103, 44, 32, 116, 104, 105, 115, 91, 105, 93, 44, 32, 105, 44, 32, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 105, 110, 40, 97, 44, 32, 98, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 32, 60, 32, 98, 32, 63, 32, 97, 32, 58, 32, 98, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 115, 116, 114, 105, 110, 103, 67, 111, 109, 112, 97, 114, 97, 116, 111, 114, 40, 97, 44, 32, 98, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 83, 116, 114, 105, 110, 103, 32, 61, 32, 97, 46, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 83, 116, 114, 105, 110, 103, 32, 61, 32, 98, 46, 115, 116, 114, 105, 110, 103, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 76, 101, 110, 103, 116, 104, 32, 61, 32, 97, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 76, 101, 110, 103, 116, 104, 32, 61, 32, 98, 83, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 109, 105, 110, 40, 97, 76, 101, 110, 103, 116, 104, 44, 32, 98, 76, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 97, 67, 104, 97, 114, 67, 111, 100, 101, 32, 61, 32, 97, 83, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 67, 104, 97, 114, 67, 111, 100, 101, 32, 61, 32, 98, 83, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 105, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 67, 104, 97, 114, 67, 111, 100, 101, 32, 61, 61, 32, 98, 67, 104, 97, 114, 67, 111, 100, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 67, 104, 97, 114, 67, 111, 100, 101, 32, 45, 32, 98, 67, 104, 97, 114, 67, 111, 100, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 76, 101, 110, 103, 116, 104, 32, 45, 32, 98, 76, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 111, 109, 112, 97, 99, 116, 83, 112, 97, 114, 115, 101, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 115, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 101, 101, 110, 32, 61, 32, 123, 32, 125, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 100, 115, 116, 59, 32, 105, 32, 60, 32, 115, 114, 99, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 97, 114, 114, 97, 121, 59, 32, 111, 98, 106, 101, 99, 116, 59, 32, 111, 98, 106, 101, 99, 116, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 80, 114, 111, 116, 111, 116, 121, 112, 101, 79, 102, 40, 111, 98, 106, 101, 99, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 103, 101, 116, 79, 119, 110, 80, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 40, 111, 98, 106, 101, 99, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 100, 101, 120, 32, 61, 32, 112, 114, 111, 112, 101, 114, 116, 121, 78, 97, 109, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 100, 101, 120, 32, 60, 32, 108, 101, 110, 103, 116, 104, 41, 32, 123, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 101, 110, 91, 105, 110, 100, 101, 120, 93, 41, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 101, 101, 110, 91, 105, 110, 100, 101, 120, 93, 32, 61, 32, 49, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 97, 114, 114, 97, 121, 91, 105, 110, 100, 101, 120, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 43, 43, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 105, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 105, 93, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 111, 109, 112, 97, 99, 116, 83, 108, 111, 119, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 104, 111, 108, 101, 67, 111, 117, 110, 116, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 115, 116, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 114, 99, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 59, 32, 115, 114, 99, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 115, 114, 99, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 40, 115, 114, 99, 32, 105, 110, 32, 97, 114, 114, 97, 121, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 43, 43, 104, 111, 108, 101, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 104, 111, 108, 101, 67, 111, 117, 110, 116, 32, 60, 32, 50, 53, 54, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 109, 112, 97, 99, 116, 83, 112, 97, 114, 115, 101, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 97, 114, 114, 97, 121, 91, 115, 114, 99, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 100, 115, 116, 43, 43, 93, 32, 61, 32, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 61, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 32, 61, 32, 108, 101, 110, 103, 116, 104, 32, 45, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 45, 32, 104, 111, 108, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 105, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 105, 93, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 43, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 67, 111, 117, 110, 116, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 101, 108, 101, 116, 101, 32, 97, 114, 114, 97, 121, 91, 105, 93, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 111, 109, 112, 97, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 97, 114, 114, 97, 121, 91, 105, 93, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 109, 112, 97, 99, 116, 83, 108, 111, 119, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 101, 114, 103, 101, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 69, 110, 100, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 32, 61, 32, 115, 114, 99, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 69, 110, 100, 32, 61, 32, 109, 105, 110, 40, 108, 101, 102, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 32, 61, 32, 108, 101, 102, 116, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 69, 110, 100, 32, 61, 32, 109, 105, 110, 40, 114, 105, 103, 104, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 102, 116, 59, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 59, 32, 43, 43, 100, 115, 116, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 105, 103, 104, 116, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 102, 116, 32, 62, 61, 32, 108, 101, 102, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 61, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 40, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 40, 116, 121, 112, 101, 111, 102, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 61, 61, 61, 32, 34, 98, 111, 111, 108, 101, 97, 110, 34, 32, 38, 38, 32, 33, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 41, 32, 124, 124, 32, 99, 111, 109, 112, 97, 114, 105, 115, 111, 110, 82, 101, 115, 117, 108, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 108, 101, 102, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 101, 114, 103, 101, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 102, 102, 101, 114, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 102, 102, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 115, 116, 32, 61, 32, 98, 117, 102, 102, 101, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 114, 99, 32, 61, 32, 97, 114, 114, 97, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 119, 105, 100, 116, 104, 32, 61, 32, 49, 59, 32, 119, 105, 100, 116, 104, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 119, 105, 100, 116, 104, 32, 42, 61, 32, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 43, 61, 32, 50, 32, 42, 32, 119, 105, 100, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 101, 114, 103, 101, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 109, 112, 32, 61, 32, 115, 114, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 114, 99, 32, 61, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 116, 109, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 114, 99, 32, 33, 61, 32, 97, 114, 114, 97, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 105, 93, 32, 61, 32, 115, 114, 99, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 98, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 98, 117, 99, 107, 101, 116, 44, 32, 100, 101, 112, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 32, 60, 32, 51, 50, 32, 124, 124, 32, 100, 101, 112, 116, 104, 32, 62, 32, 51, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 101, 114, 103, 101, 83, 111, 114, 116, 40, 98, 117, 99, 107, 101, 116, 44, 32, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 44, 32, 115, 116, 114, 105, 110, 103, 67, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 100, 115, 116, 43, 43, 93, 32, 61, 32, 98, 117, 99, 107, 101, 116, 91, 105, 93, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 99, 107, 101, 116, 115, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 116, 114, 121, 32, 61, 32, 98, 117, 99, 107, 101, 116, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 101, 110, 116, 114, 121, 46, 115, 116, 114, 105, 110, 103, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 114, 105, 110, 103, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 100, 101, 112, 116, 104, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 100, 115, 116, 43, 43, 93, 32, 61, 32, 101, 110, 116, 114, 121, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 99, 32, 61, 32, 115, 116, 114, 105, 110, 103, 46, 64, 99, 104, 97, 114, 67, 111, 100, 101, 65, 116, 40, 100, 101, 112, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 98, 117, 99, 107, 101, 116, 115, 91, 99, 93, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 115, 91, 99, 93, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 115, 91, 99, 93, 91, 98, 117, 99, 107, 101, 116, 115, 91, 99, 93, 46, 108, 101, 110, 103, 116, 104, 93, 32, 61, 32, 101, 110, 116, 114, 121, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 98, 117, 99, 107, 101, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 98, 117, 99, 107, 101, 116, 115, 91, 105, 93, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 98, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 100, 115, 116, 44, 32, 98, 117, 99, 107, 101, 116, 115, 91, 105, 93, 44, 32, 100, 101, 112, 116, 104, 32, 43, 32, 49, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 61, 32, 99, 111, 109, 112, 97, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 101, 114, 103, 101, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 115, 116, 114, 105, 110, 103, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 32, 61, 32, 99, 111, 109, 112, 97, 99, 116, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 115, 32, 61, 32, 64, 110, 101, 119, 65, 114, 114, 97, 121, 87, 105, 116, 104, 83, 105, 122, 101, 40, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 115, 91, 105, 93, 32, 61, 32, 123, 32, 115, 116, 114, 105, 110, 103, 58, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 114, 97, 121, 91, 105, 93, 41, 44, 32, 118, 97, 108, 117, 101, 58, 32, 97, 114, 114, 97, 121, 91, 105, 93, 32, 125, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 99, 107, 101, 116, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 48, 44, 32, 115, 116, 114, 105, 110, 103, 115, 44, 32, 48, 41, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 111, 114, 116, 70, 117, 110, 99, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 111, 114, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 83, 111, 114, 116, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 111, 114, 116, 70, 117, 110, 99, 116, 105, 111, 110, 32, 61, 32, 115, 116, 114, 105, 110, 103, 83, 111, 114, 116, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 99, 111, 109, 112, 97, 114, 115, 105, 111, 110, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 98, 101, 32, 97, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 97, 114, 114, 97, 121, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 44, 32, 34, 65, 114, 114, 97, 121, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 111, 114, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 97, 114, 114, 97, 121, 46, 108, 101, 110, 103, 116, 104, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 10, 32, 32, 32, 32, 115, 111, 114, 116, 70, 117, 110, 99, 116, 105, 111, 110, 40, 97, 114, 114, 97, 121, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 114, 97, 121, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 105, 110, 40, 97, 44, 32, 98, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 97, 32, 60, 32, 98, 32, 63, 32, 97, 32, 58, 32, 98, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 101, 114, 103, 101, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 115, 114, 99, 69, 110, 100, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 32, 61, 32, 115, 114, 99, 73, 110, 100, 101, 120, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 102, 116, 69, 110, 100, 32, 61, 32, 109, 105, 110, 40, 108, 101, 102, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 32, 61, 32, 108, 101, 102, 116, 69, 110, 100, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 114, 105, 103, 104, 116, 69, 110, 100, 32, 61, 32, 109, 105, 110, 40, 114, 105, 103, 104, 116, 32, 43, 32, 119, 105, 100, 116, 104, 44, 32, 115, 114, 99, 69, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 108, 101, 102, 116, 59, 32, 100, 115, 116, 73, 110, 100, 101, 120, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 59, 32, 43, 43, 100, 115, 116, 73, 110, 100, 101, 120, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 105, 103, 104, 116, 32, 60, 32, 114, 105, 103, 104, 116, 69, 110, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 102, 116, 32, 62, 61, 32, 108, 101, 102, 116, 69, 110, 100, 32, 124, 124, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 40, 115, 114, 99, 91, 114, 105, 103, 104, 116, 93, 44, 32, 115, 114, 99, 91, 108, 101, 102, 116, 93, 41, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 114, 105, 103, 104, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 99, 111, 110, 116, 105, 110, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 91, 100, 115, 116, 73, 110, 100, 101, 120, 93, 32, 61, 32, 115, 114, 99, 91, 108, 101, 102, 116, 43, 43, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 109, 101, 114, 103, 101, 83, 111, 114, 116, 40, 97, 114, 114, 97, 121, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 98, 117, 102, 102, 101, 114, 32, 61, 32, 91, 32, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 98, 117, 102, 102, 101, 114, 46, 108, 101, 110, 103, 116, 104, 32, 61, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 100, 115, 116, 32, 61, 32, 98, 117, 102, 102, 101, 114, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 114, 99, 32, 61, 32, 97, 114, 114, 97, 121, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 119, 105, 100, 116, 104, 32, 61, 32, 49, 59, 32, 119, 105, 100, 116, 104, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 119, 105, 100, 116, 104, 32, 42, 61, 32, 50, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 61, 32, 48, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 115, 114, 99, 73, 110, 100, 101, 120, 32, 43, 61, 32, 50, 32, 42, 32, 119, 105, 100, 116, 104, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 101, 114, 103, 101, 40, 100, 115, 116, 44, 32, 115, 114, 99, 44, 32, 115, 114, 99, 73, 110, 100, 101, 120, 44, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 44, 32, 119, 105, 100, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 109, 112, 32, 61, 32, 115, 114, 99, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 115, 114, 99, 32, 61, 32, 100, 115, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 100, 115, 116, 32, 61, 32, 116, 109, 112, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 114, 99, 32, 33, 61, 32, 97, 114, 114, 97, 121, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 111, 114, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 59, 32, 105, 32, 60, 32, 118, 97, 108, 117, 101, 67, 111, 117, 110, 116, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 97, 114, 114, 97, 121, 91, 105, 93, 32, 61, 32, 115, 114, 99, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 60, 32, 50, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 32, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 109, 101, 114, 103, 101, 83, 111, 114, 116, 40, 116, 104, 105, 115, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 99, 111, 109, 112, 97, 114, 97, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 111, 114, 116, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 98, 106, 44, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 111, 98, 106, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 115, 112, 101, 99, 105, 101, 115, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 100, 101, 102, 97, 117, 108, 116, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 91, 83, 121, 109, 98, 111, 108, 46, 115, 112, 101, 99, 105, 101, 115, 93, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 105, 110, 103, 44, 32, 108, 105, 109, 105, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 64, 64, 115, 112, 108, 105, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 105, 110, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 101, 120, 112, 44, 32, 64, 82, 101, 103, 69, 120, 112, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 82, 101, 103, 69, 120, 112, 32, 38, 38, 32, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 114, 101, 103, 101, 120, 112, 46, 102, 108, 97, 103, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 117, 34, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 119, 70, 108, 97, 103, 115, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 73, 110, 99, 108, 117, 100, 101, 115, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 102, 108, 97, 103, 115, 44, 32, 34, 121, 34, 41, 32, 63, 32, 102, 108, 97, 103, 115, 32, 58, 32, 102, 108, 97, 103, 115, 32, 43, 32, 34, 121, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 108, 105, 116, 116, 101, 114, 32, 61, 32, 110, 101, 119, 32, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 114, 101, 103, 101, 120, 112, 44, 32, 110, 101, 119, 70, 108, 97, 103, 115, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 104, 97, 115, 79, 98, 115, 101, 114, 118, 97, 98, 108, 101, 83, 105, 100, 101, 69, 102, 102, 101, 99, 116, 115, 70, 111, 114, 82, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 40, 115, 112, 108, 105, 116, 116, 101, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 91, 93, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 108, 105, 109, 105, 116, 32, 61, 32, 40, 108, 105, 109, 105, 116, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 63, 32, 48, 120, 102, 102, 102, 102, 102, 102, 102, 102, 32, 58, 32, 108, 105, 109, 105, 116, 32, 62, 62, 62, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 105, 122, 101, 32, 61, 32, 115, 116, 114, 46, 108, 101, 110, 103, 116, 104, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 122, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 122, 32, 33, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 48, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 48, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 60, 32, 115, 105, 122, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 112, 108, 105, 116, 116, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 101, 115, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 115, 112, 108, 105, 116, 116, 101, 114, 44, 32, 115, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 101, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 116, 111, 76, 101, 110, 103, 116, 104, 40, 115, 112, 108, 105, 116, 116, 101, 114, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 40, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 60, 61, 32, 115, 105, 122, 101, 41, 32, 63, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 58, 32, 115, 105, 122, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 61, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 64, 97, 100, 118, 97, 110, 99, 101, 83, 116, 114, 105, 110, 103, 73, 110, 100, 101, 120, 40, 115, 116, 114, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 44, 32, 117, 110, 105, 99, 111, 100, 101, 77, 97, 116, 99, 104, 105, 110, 103, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 117, 98, 83, 116, 114, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 45, 32, 112, 111, 115, 105, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 44, 32, 115, 117, 98, 83, 116, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 112, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 101, 110, 100, 80, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 79, 102, 67, 97, 112, 116, 117, 114, 101, 115, 32, 61, 32, 109, 97, 116, 99, 104, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 62, 32, 49, 32, 63, 32, 109, 97, 116, 99, 104, 101, 115, 46, 108, 101, 110, 103, 116, 104, 32, 45, 32, 49, 32, 58, 32, 48, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 105, 32, 60, 61, 32, 110, 117, 109, 98, 101, 114, 79, 102, 67, 97, 112, 116, 117, 114, 101, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 67, 97, 112, 116, 117, 114, 101, 32, 61, 32, 109, 97, 116, 99, 104, 101, 115, 91, 105, 93, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 44, 32, 110, 101, 120, 116, 67, 97, 112, 116, 117, 114, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 108, 105, 109, 105, 116, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 105, 43, 43, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 109, 97, 116, 99, 104, 80, 111, 115, 105, 116, 105, 111, 110, 32, 61, 32, 112, 111, 115, 105, 116, 105, 111, 110, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 83, 116, 114, 32, 61, 32, 64, 115, 116, 114, 105, 110, 103, 83, 117, 98, 115, 116, 114, 73, 110, 116, 101, 114, 110, 97, 108, 46, 64, 99, 97, 108, 108, 40, 115, 116, 114, 44, 32, 112, 111, 115, 105, 116, 105, 111, 110, 44, 32, 115, 105, 122, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 64, 112, 117, 116, 66, 121, 86, 97, 108, 68, 105, 114, 101, 99, 116, 40, 114, 101, 115, 117, 108, 116, 44, 32, 114, 101, 115, 117, 108, 116, 46, 108, 101, 110, 103, 116, 104, 44, 32, 114, 101, 109, 97, 105, 110, 105, 110, 103, 83, 116, 114, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 108, 105, 109, 105, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 112, 108, 105, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 110, 111, 116, 32, 98, 101, 32, 110, 117, 108, 108, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 32, 33, 61, 32, 110, 117, 108, 108, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 115, 112, 108, 105, 116, 116, 101, 114, 32, 61, 32, 115, 101, 112, 97, 114, 97, 116, 111, 114, 46, 64, 115, 112, 108, 105, 116, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 112, 108, 105, 116, 116, 101, 114, 32, 33, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 112, 108, 105, 116, 116, 101, 114, 46, 64, 99, 97, 108, 108, 40, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 116, 104, 105, 115, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 115, 116, 114, 105, 110, 103, 83, 112, 108, 105, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 101, 112, 97, 114, 97, 116, 111, 114, 44, 32, 108, 105, 109, 105, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 116, 114, 105, 107, 101, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 116, 114, 105, 107, 101, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 115, 117, 108, 116, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 48, 44, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 97, 114, 103, 117, 109, 101, 110, 116, 115, 46, 108, 101, 110, 103, 116, 104, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 43, 43, 105, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 115, 117, 108, 116, 32, 43, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 97, 114, 103, 117, 109, 101, 110, 116, 115, 91, 105, 93, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 114, 101, 115, 117, 108, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 117, 98, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 117, 98, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 98, 101, 103, 105, 110, 44, 32, 101, 110, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 84, 121, 112, 101, 100, 65, 114, 114, 97, 121, 86, 105, 101, 119, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 116, 121, 112, 101, 100, 32, 97, 114, 114, 97, 121, 32, 118, 105, 101, 119, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 114, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 98, 101, 103, 105, 110, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 105, 110, 105, 115, 104, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 101, 110, 100, 32, 33, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 102, 105, 110, 105, 115, 104, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 101, 110, 100, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 83, 117, 98, 97, 114, 114, 97, 121, 67, 114, 101, 97, 116, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 114, 116, 44, 32, 102, 105, 110, 105, 115, 104, 44, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 99, 114, 101, 97, 116, 101, 72, 84, 77, 76, 40, 34, 83, 116, 114, 105, 110, 103, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 115, 117, 112, 34, 44, 32, 116, 104, 105, 115, 44, 32, 34, 115, 117, 112, 34, 44, 32, 34, 34, 44, 32, 34, 34, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 116, 104, 105, 115, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 104, 97, 115, 73, 110, 115, 116, 97, 110, 99, 101, 66, 111, 117, 110, 100, 70, 117, 110, 99, 116, 105, 111, 110, 40, 116, 104, 105, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 97, 114, 103, 101, 116, 32, 61, 32, 116, 104, 105, 115, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 105, 110, 115, 116, 97, 110, 99, 101, 79, 102, 40, 118, 97, 108, 117, 101, 44, 32, 116, 97, 114, 103, 101, 116, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 104, 105, 115, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 114, 65, 114, 103, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 103, 101, 120, 112, 32, 61, 32, 116, 104, 105, 115, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 82, 101, 103, 69, 120, 112, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 64, 116, 114, 121, 71, 101, 116, 66, 121, 73, 100, 40, 114, 101, 103, 101, 120, 112, 44, 32, 34, 101, 120, 101, 99, 34, 41, 32, 61, 61, 61, 32, 64, 114, 101, 103, 69, 120, 112, 66, 117, 105, 108, 116, 105, 110, 69, 120, 101, 99, 10, 32, 32, 32, 32, 32, 32, 32, 32, 38, 38, 32, 116, 121, 112, 101, 111, 102, 32, 114, 101, 103, 101, 120, 112, 46, 108, 97, 115, 116, 73, 110, 100, 101, 120, 32, 61, 61, 61, 32, 34, 110, 117, 109, 98, 101, 114, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 114, 101, 103, 69, 120, 112, 84, 101, 115, 116, 70, 97, 115, 116, 46, 64, 99, 97, 108, 108, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 114, 101, 103, 101, 120, 112, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 82, 101, 103, 69, 120, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 116, 101, 115, 116, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 32, 61, 32, 64, 116, 111, 83, 116, 114, 105, 110, 103, 40, 115, 116, 114, 65, 114, 103, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 109, 97, 116, 99, 104, 32, 61, 32, 64, 114, 101, 103, 69, 120, 112, 69, 120, 101, 99, 40, 114, 101, 103, 101, 120, 112, 44, 32, 115, 116, 114, 41, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 109, 97, 116, 99, 104, 32, 33, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 116, 114, 117, 101, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 102, 97, 108, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 105, 115, 32, 110, 111, 116, 32, 97, 32, 80, 114, 111, 109, 105, 115, 101, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 64, 115, 112, 101, 99, 105, 101, 115, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 80, 114, 111, 109, 105, 115, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 83, 108, 111, 119, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 46, 64, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 123, 32, 114, 101, 116, 117, 114, 110, 32, 97, 114, 103, 117, 109, 101, 110, 116, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 121, 112, 101, 111, 102, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 33, 61, 61, 32, 34, 102, 117, 110, 99, 116, 105, 111, 110, 34, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 32, 61, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 97, 114, 103, 117, 109, 101, 110, 116, 41, 32, 123, 32, 116, 104, 114, 111, 119, 32, 97, 114, 103, 117, 109, 101, 110, 116, 59, 32, 125, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 114, 101, 97, 99, 116, 105, 111, 110, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 40, 112, 114, 111, 109, 105, 115, 101, 79, 114, 67, 97, 112, 97, 98, 105, 108, 105, 116, 121, 44, 32, 111, 110, 70, 117, 108, 102, 105, 108, 108, 101, 100, 44, 32, 111, 110, 82, 101, 106, 101, 99, 116, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 102, 108, 97, 103, 115, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 77, 97, 115, 107, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 80, 101, 110, 100, 105, 110, 103, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 97, 99, 116, 105, 111, 110, 46, 64, 110, 101, 120, 116, 32, 61, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 125, 32, 101, 108, 115, 101, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 112, 114, 111, 109, 105, 115, 101, 83, 116, 97, 116, 101, 82, 101, 106, 101, 99, 116, 101, 100, 32, 38, 38, 32, 33, 40, 102, 108, 97, 103, 115, 32, 38, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 104, 111, 115, 116, 80, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 84, 114, 97, 99, 107, 101, 114, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 106, 101, 99, 116, 105, 111, 110, 72, 97, 110, 100, 108, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 82, 101, 97, 99, 116, 105, 111, 110, 115, 79, 114, 82, 101, 115, 117, 108, 116, 41, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 64, 112, 117, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 44, 32, 64, 103, 101, 116, 80, 114, 111, 109, 105, 115, 101, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 105, 101, 108, 100, 70, 108, 97, 103, 115, 41, 32, 124, 32, 64, 112, 114, 111, 109, 105, 115, 101, 70, 108, 97, 103, 115, 73, 115, 72, 97, 110, 100, 108, 101, 100, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 111, 109, 105, 115, 101, 32, 61, 32, 64, 110, 101, 119, 80, 114, 111, 109, 105, 115, 101, 40, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 105, 115, 41, 32, 124, 124, 32, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 32, 61, 32, 64, 103, 101, 116, 66, 121, 73, 100, 68, 105, 114, 101, 99, 116, 80, 114, 105, 118, 97, 116, 101, 40, 116, 104, 105, 115, 44, 32, 34, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 59, 10, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 32, 61, 32, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 46, 116, 104, 114, 111, 119, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 116, 114, 121, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 32, 61, 32, 116, 104, 114, 111, 119, 77, 101, 116, 104, 111, 100, 46, 64, 99, 97, 108, 108, 40, 115, 121, 110, 99, 73, 116, 101, 114, 97, 116, 111, 114, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 41, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 64, 109, 97, 107, 101, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 39, 73, 116, 101, 114, 97, 116, 111, 114, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 46, 39, 41, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 32, 32, 32, 32, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 68, 111, 110, 101, 32, 61, 32, 33, 33, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 46, 100, 111, 110, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 116, 104, 114, 111, 119, 86, 97, 108, 117, 101, 32, 61, 32, 116, 104, 114, 111, 119, 82, 101, 115, 117, 108, 116, 46, 118, 97, 108, 117, 101, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 115, 111, 108, 118, 101, 87, 105, 116, 104, 111, 117, 116, 80, 114, 111, 109, 105, 115, 101, 40, 116, 104, 114, 111, 119, 86, 97, 108, 117, 101, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 114, 101, 115, 117, 108, 116, 41, 32, 123, 32, 64, 114, 101, 115, 111, 108, 118, 101, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 123, 32, 118, 97, 108, 117, 101, 58, 32, 114, 101, 115, 117, 108, 116, 44, 32, 100, 111, 110, 101, 58, 32, 116, 104, 114, 111, 119, 68, 111, 110, 101, 32, 125, 41, 59, 32, 125, 44, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 114, 114, 111, 114, 41, 32, 123, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 114, 114, 111, 114, 41, 59, 32, 125, 41, 59, 10, 32, 32, 32, 32, 125, 32, 99, 97, 116, 99, 104, 32, 40, 101, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 114, 101, 106, 101, 99, 116, 80, 114, 111, 109, 105, 115, 101, 87, 105, 116, 104, 70, 105, 114, 115, 116, 82, 101, 115, 111, 108, 118, 105, 110, 103, 70, 117, 110, 99, 116, 105, 111, 110, 67, 97, 108, 108, 67, 104, 101, 99, 107, 40, 112, 114, 111, 109, 105, 115, 101, 44, 32, 101, 41, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 112, 114, 111, 109, 105, 115, 101, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 97, 115, 121, 110, 99, 71, 101, 110, 101, 114, 97, 116, 111, 114, 69, 110, 113, 117, 101, 117, 101, 40, 116, 104, 105, 115, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 101, 120, 99, 101, 112, 116, 105, 111, 110, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 71, 101, 110, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 97, 32, 103, 101, 110, 101, 114, 97, 116, 111, 114, 34, 41, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 97, 116, 101, 32, 61, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 83, 116, 97, 116, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 69, 120, 101, 99, 117, 116, 105, 110, 103, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 71, 101, 110, 101, 114, 97, 116, 111, 114, 32, 105, 115, 32, 101, 120, 101, 99, 117, 116, 105, 110, 103, 34, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 115, 116, 97, 116, 101, 32, 61, 61, 61, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 83, 116, 97, 116, 101, 67, 111, 109, 112, 108, 101, 116, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 116, 104, 114, 111, 119, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 40, 116, 104, 105, 115, 44, 32, 115, 116, 97, 116, 101, 44, 32, 64, 103, 101, 116, 71, 101, 110, 101, 114, 97, 116, 111, 114, 73, 110, 116, 101, 114, 110, 97, 108, 70, 105, 101, 108, 100, 40, 116, 104, 105, 115, 44, 32, 64, 103, 101, 110, 101, 114, 97, 116, 111, 114, 70, 105, 101, 108, 100, 84, 104, 105, 115, 41, 44, 32, 101, 120, 99, 101, 112, 116, 105, 111, 110, 44, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 44, 32, 64, 71, 101, 110, 101, 114, 97, 116, 111, 114, 82, 101, 115, 117, 109, 101, 77, 111, 100, 101, 84, 104, 114, 111, 119, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 61, 32, 43, 116, 97, 114, 103, 101, 116, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 105, 102, 32, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 32, 33, 61, 61, 32, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 48, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 114, 117, 110, 99, 40, 110, 117, 109, 98, 101, 114, 86, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 116, 97, 114, 103, 101, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 116, 97, 114, 103, 101, 116, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 43, 40, 108, 101, 110, 103, 116, 104, 32, 62, 32, 48, 32, 63, 32, 40, 108, 101, 110, 103, 116, 104, 32, 60, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 32, 63, 32, 108, 101, 110, 103, 116, 104, 32, 58, 32, 64, 77, 65, 88, 95, 83, 65, 70, 69, 95, 73, 78, 84, 69, 71, 69, 82, 41, 32, 58, 32, 48, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 68, 97, 116, 101, 68, 97, 116, 101, 40, 111, 112, 116, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 110, 117, 108, 108, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 112, 116, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 33, 111, 112, 116, 105, 111, 110, 115, 32, 124, 124, 32, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 119, 101, 101, 107, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 111, 112, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 116, 104, 105, 115, 84, 105, 109, 101, 86, 97, 108, 117, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 78, 97, 78, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 73, 110, 118, 97, 108, 105, 100, 32, 68, 97, 116, 101, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 68, 97, 116, 101, 68, 97, 116, 101, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 99, 97, 108, 101, 115, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 97, 116, 101, 84, 105, 109, 101, 70, 111, 114, 109, 97, 116, 40, 108, 111, 99, 97, 108, 101, 115, 44, 32, 111, 112, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 65, 110, 121, 65, 108, 108, 40, 111, 112, 116, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 110, 117, 108, 108, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 112, 116, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 33, 111, 112, 116, 105, 111, 110, 115, 32, 124, 124, 32, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 119, 101, 101, 107, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 111, 112, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 121, 101, 97, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 111, 110, 116, 104, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 100, 97, 121, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 116, 104, 105, 115, 84, 105, 109, 101, 86, 97, 108, 117, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 78, 97, 78, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 73, 110, 118, 97, 108, 105, 100, 32, 68, 97, 116, 101, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 65, 110, 121, 65, 108, 108, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 99, 97, 108, 101, 115, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 97, 116, 101, 84, 105, 109, 101, 70, 111, 114, 109, 97, 116, 40, 108, 111, 99, 97, 108, 101, 115, 44, 32, 111, 112, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 101, 110, 103, 116, 104, 32, 61, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 76, 101, 110, 103, 116, 104, 40, 116, 104, 105, 115, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 108, 101, 110, 103, 116, 104, 32, 61, 61, 32, 48, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 115, 116, 114, 105, 110, 103, 32, 61, 32, 116, 104, 105, 115, 91, 48, 93, 46, 116, 111, 76, 111, 99, 97, 108, 101, 83, 116, 114, 105, 110, 103, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 44, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 102, 111, 114, 32, 40, 118, 97, 114, 32, 105, 32, 61, 32, 49, 59, 32, 105, 32, 60, 32, 108, 101, 110, 103, 116, 104, 59, 32, 105, 43, 43, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 115, 116, 114, 105, 110, 103, 32, 43, 61, 32, 34, 44, 34, 32, 43, 32, 116, 104, 105, 115, 91, 105, 93, 46, 116, 111, 76, 111, 99, 97, 108, 101, 83, 116, 114, 105, 110, 103, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 44, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 115, 116, 114, 105, 110, 103, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 84, 105, 109, 101, 84, 105, 109, 101, 40, 111, 112, 116, 115, 41, 10, 32, 32, 32, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 110, 117, 108, 108, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 32, 105, 102, 32, 40, 111, 112, 116, 115, 32, 61, 61, 61, 32, 110, 117, 108, 108, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 110, 117, 108, 108, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 111, 98, 106, 101, 99, 116, 34, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 101, 108, 115, 101, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 116, 111, 79, 98, 106, 101, 99, 116, 40, 111, 112, 116, 115, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 32, 61, 32, 33, 111, 112, 116, 105, 111, 110, 115, 32, 124, 124, 32, 40, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 38, 38, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 10, 32, 32, 32, 32, 32, 32, 32, 32, 41, 59, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 102, 32, 40, 110, 101, 101, 100, 115, 68, 101, 102, 97, 117, 108, 116, 115, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 64, 79, 98, 106, 101, 99, 116, 46, 64, 99, 114, 101, 97, 116, 101, 40, 111, 112, 116, 105, 111, 110, 115, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 104, 111, 117, 114, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 109, 105, 110, 117, 116, 101, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 111, 112, 116, 105, 111, 110, 115, 46, 115, 101, 99, 111, 110, 100, 32, 61, 32, 34, 110, 117, 109, 101, 114, 105, 99, 34, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 111, 112, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 125, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 118, 97, 108, 117, 101, 32, 61, 32, 64, 116, 104, 105, 115, 84, 105, 109, 101, 86, 97, 108, 117, 101, 46, 64, 99, 97, 108, 108, 40, 116, 104, 105, 115, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 78, 97, 78, 40, 118, 97, 108, 117, 101, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 34, 73, 110, 118, 97, 108, 105, 100, 32, 68, 97, 116, 101, 34, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 111, 112, 116, 105, 111, 110, 115, 32, 61, 32, 116, 111, 68, 97, 116, 101, 84, 105, 109, 101, 79, 112, 116, 105, 111, 110, 115, 84, 105, 109, 101, 84, 105, 109, 101, 40, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 49, 41, 41, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 108, 111, 99, 97, 108, 101, 115, 32, 61, 32, 64, 97, 114, 103, 117, 109, 101, 110, 116, 40, 48, 41, 59, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 100, 97, 116, 101, 84, 105, 109, 101, 70, 111, 114, 109, 97, 116, 40, 108, 111, 99, 97, 108, 101, 115, 44, 32, 111, 112, 116, 105, 111, 110, 115, 44, 32, 118, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 115, 116, 97, 116, 101, 44, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 118, 97, 114, 32, 112, 114, 101, 118, 105, 111, 117, 115, 32, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 99, 117, 114, 114, 101, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 118, 97, 114, 32, 110, 101, 120, 116, 32, 61, 32, 99, 117, 114, 114, 101, 110, 116, 46, 64, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 46, 64, 110, 101, 120, 116, 32, 61, 32, 112, 114, 101, 118, 105, 111, 117, 115, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 112, 114, 101, 118, 105, 111, 117, 115, 32, 61, 32, 99, 117, 114, 114, 101, 110, 116, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 32, 61, 32, 112, 114, 101, 118, 105, 111, 117, 115, 59, 10, 10, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 114, 101, 97, 99, 116, 105, 111, 110, 115, 59, 10, 32, 32, 32, 32, 119, 104, 105, 108, 101, 32, 40, 99, 117, 114, 114, 101, 110, 116, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 101, 110, 113, 117, 101, 117, 101, 74, 111, 98, 40, 64, 112, 114, 111, 109, 105, 115, 101, 82, 101, 97, 99, 116, 105, 111, 110, 74, 111, 98, 44, 32, 115, 116, 97, 116, 101, 44, 32, 99, 117, 114, 114, 101, 110, 116, 44, 32, 97, 114, 103, 117, 109, 101, 110, 116, 41, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 99, 117, 114, 114, 101, 110, 116, 32, 61, 32, 99, 117, 114, 114, 101, 110, 116, 46, 64, 110, 101, 120, 116, 59, 10, 32, 32, 32, 32, 125, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 44, 32, 108, 101, 110, 103, 116, 104, 44, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 86, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 118, 97, 108, 117, 101, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 86, 97, 108, 117, 101, 59, 10, 10, 32, 32, 32, 32, 118, 97, 114, 32, 105, 110, 116, 32, 61, 32, 64, 116, 111, 73, 110, 116, 101, 103, 101, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 105, 110, 116, 32, 60, 32, 48, 41, 32, 123, 10, 32, 32, 32, 32, 32, 32, 32, 32, 105, 110, 116, 32, 43, 61, 32, 108, 101, 110, 103, 116, 104, 59, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 116, 32, 60, 32, 48, 32, 63, 32, 48, 32, 58, 32, 105, 110, 116, 59, 10, 32, 32, 32, 32, 125, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 105, 110, 116, 32, 62, 32, 108, 101, 110, 103, 116, 104, 32, 63, 32, 108, 101, 110, 103, 116, 104, 32, 58, 32, 105, 110, 116, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 118, 97, 108, 117, 101, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 32, 32, 32, 32, 118, 97, 114, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 118, 97, 108, 117, 101, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 61, 61, 32, 64, 117, 110, 100, 101, 102, 105, 110, 101, 100, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 79, 98, 106, 101, 99, 116, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 124, 116, 104, 105, 115, 124, 46, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 105, 115, 32, 110, 111, 116, 32, 97, 110, 32, 79, 98, 106, 101, 99, 116, 32, 111, 114, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 34, 41, 59, 10, 10, 32, 32, 32, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 32, 61, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 46, 64, 115, 112, 101, 99, 105, 101, 115, 83, 121, 109, 98, 111, 108, 59, 10, 32, 32, 32, 32, 105, 102, 32, 40, 64, 105, 115, 85, 110, 100, 101, 102, 105, 110, 101, 100, 79, 114, 78, 117, 108, 108, 40, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 64, 116, 121, 112, 101, 100, 65, 114, 114, 97, 121, 71, 101, 116, 79, 114, 105, 103, 105, 110, 97, 108, 67, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 40, 118, 97, 108, 117, 101, 41, 59, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 47, 47, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 99, 111, 110, 115, 116, 114, 117, 99, 116, 111, 114, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 77, 97, 112, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 77, 97, 112, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 118, 97, 108, 117, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 77, 97, 112, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 77, 97, 112, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 86, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10, 40, 102, 117, 110, 99, 116, 105, 111, 110, 32, 40, 41, 10, 123, 10, 32, 32, 32, 32, 34, 117, 115, 101, 32, 115, 116, 114, 105, 99, 116, 34, 59, 10, 10, 32, 32, 32, 32, 105, 102, 32, 40, 33, 64, 105, 115, 83, 101, 116, 40, 116, 104, 105, 115, 41, 41, 10, 32, 32, 32, 32, 32, 32, 32, 32, 64, 116, 104, 114, 111, 119, 84, 121, 112, 101, 69, 114, 114, 111, 114, 40, 34, 83, 101, 116, 46, 112, 114, 111, 116, 111, 116, 121, 112, 101, 46, 118, 97, 108, 117, 101, 115, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 97, 116, 32, 124, 116, 104, 105, 115, 124, 32, 98, 101, 32, 83, 101, 116, 34, 41, 59, 10, 10, 32, 32, 32, 32, 114, 101, 116, 117, 114, 110, 32, 110, 101, 119, 32, 64, 83, 101, 116, 73, 116, 101, 114, 97, 116, 111, 114, 40, 116, 104, 105, 115, 44, 32, 64, 105, 116, 101, 114, 97, 116, 105, 111, 110, 75, 105, 110, 100, 86, 97, 108, 117, 101, 41, 59, 10, 125, 41, 10 };

const unsigned s_JSCCombinedCodeLength = 127990;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeLength = 183;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeAsyncFromSyncIteratorConstructorCode =
s_JSCCombinedCode + 0
;

const JSC::ConstructAbility s_promiseConstructorInternalPromiseConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_promiseConstructorInternalPromiseConstructorCodeConstructorKind = JSC::ConstructorKind::Naked;
const int s_promiseConstructorInternalPromiseConstructorCodeLength = 705;
static const JSC::Intrinsic s_promiseConstructorInternalPromiseConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorInternalPromiseConstructorCode =
s_JSCCombinedCode + 183
;

const JSC::ConstructAbility s_mapPrototypeMapIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_mapPrototypeMapIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapPrototypeMapIteratorConstructorCodeLength = 297;
static const JSC::Intrinsic s_mapPrototypeMapIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeMapIteratorConstructorCode =
s_JSCCombinedCode + 888
;

const JSC::ConstructAbility s_promiseConstructorPromiseConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_promiseConstructorPromiseConstructorCodeConstructorKind = JSC::ConstructorKind::Naked;
const int s_promiseConstructorPromiseConstructorCodeLength = 698;
static const JSC::Intrinsic s_promiseConstructorPromiseConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorPromiseConstructorCode =
s_JSCCombinedCode + 1185
;

const JSC::ConstructAbility s_regExpPrototypeRegExpStringIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_regExpPrototypeRegExpStringIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeRegExpStringIteratorConstructorCodeLength = 430;
static const JSC::Intrinsic s_regExpPrototypeRegExpStringIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeRegExpStringIteratorConstructorCode =
s_JSCCombinedCode + 1883
;

const JSC::ConstructAbility s_setPrototypeSetIteratorConstructorCodeConstructAbility = JSC::ConstructAbility::CanConstruct;
const JSC::ConstructorKind s_setPrototypeSetIteratorConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_setPrototypeSetIteratorConstructorCodeLength = 297;
static const JSC::Intrinsic s_setPrototypeSetIteratorConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeSetIteratorConstructorCode =
s_JSCCombinedCode + 2313
;

const JSC::ConstructAbility s_regExpPrototypeAdvanceStringIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeAdvanceStringIndexCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeAdvanceStringIndexCodeLength = 427;
static const JSC::Intrinsic s_regExpPrototypeAdvanceStringIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeAdvanceStringIndexCode =
s_JSCCombinedCode + 2610
;

const JSC::ConstructAbility s_promiseConstructorAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAllCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseConstructorAllCodeLength = 1550;
static const JSC::Intrinsic s_promiseConstructorAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAllCode =
s_JSCCombinedCode + 3037
;

const JSC::ConstructAbility s_promiseConstructorAllSettledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorAllSettledCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseConstructorAllSettledCodeLength = 2269;
static const JSC::Intrinsic s_promiseConstructorAllSettledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorAllSettledCode =
s_JSCCombinedCode + 4587
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateFloat32ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateFloat32ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateFloat32ArrayCodeLength = 62;
static const JSC::Intrinsic s_typedArrayConstructorAllocateFloat32ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateFloat32ArrayCode =
s_JSCCombinedCode + 6856
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateFloat64ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateFloat64ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateFloat64ArrayCodeLength = 62;
static const JSC::Intrinsic s_typedArrayConstructorAllocateFloat64ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateFloat64ArrayCode =
s_JSCCombinedCode + 6918
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateInt16ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateInt16ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateInt16ArrayCodeLength = 64;
static const JSC::Intrinsic s_typedArrayConstructorAllocateInt16ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateInt16ArrayCode =
s_JSCCombinedCode + 6980
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateInt32ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateInt32ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateInt32ArrayCodeLength = 63;
static const JSC::Intrinsic s_typedArrayConstructorAllocateInt32ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateInt32ArrayCode =
s_JSCCombinedCode + 7044
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateInt8ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateInt8ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateInt8ArrayCodeLength = 59;
static const JSC::Intrinsic s_typedArrayConstructorAllocateInt8ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateInt8ArrayCode =
s_JSCCombinedCode + 7107
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateUint16ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateUint16ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateUint16ArrayCodeLength = 64;
static const JSC::Intrinsic s_typedArrayConstructorAllocateUint16ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateUint16ArrayCode =
s_JSCCombinedCode + 7166
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateUint32ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateUint32ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateUint32ArrayCodeLength = 61;
static const JSC::Intrinsic s_typedArrayConstructorAllocateUint32ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateUint32ArrayCode =
s_JSCCombinedCode + 7230
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateUint8ArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateUint8ArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateUint8ArrayCodeLength = 63;
static const JSC::Intrinsic s_typedArrayConstructorAllocateUint8ArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateUint8ArrayCode =
s_JSCCombinedCode + 7291
;

const JSC::ConstructAbility s_typedArrayConstructorAllocateUint8ClampedArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorAllocateUint8ClampedArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorAllocateUint8ClampedArrayCodeLength = 67;
static const JSC::Intrinsic s_typedArrayConstructorAllocateUint8ClampedArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorAllocateUint8ClampedArrayCode =
s_JSCCombinedCode + 7354
;

const JSC::ConstructAbility s_stringPrototypeAnchorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeAnchorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeAnchorCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeAnchorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeAnchorCode =
s_JSCCombinedCode + 7421
;

const JSC::ConstructAbility s_functionPrototypeApplyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeApplyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_functionPrototypeApplyCodeLength = 113;
static const JSC::Intrinsic s_functionPrototypeApplyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeApplyCode =
s_JSCCombinedCode + 7532
;

const JSC::ConstructAbility s_reflectObjectApplyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectApplyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_reflectObjectApplyCodeLength = 369;
static const JSC::Intrinsic s_reflectObjectApplyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectApplyCode =
s_JSCCombinedCode + 7645
;

const JSC::ConstructAbility s_arrayIteratorPrototypeArrayIteratorNextHelperCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayIteratorPrototypeArrayIteratorNextHelperCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayIteratorPrototypeArrayIteratorNextHelperCodeLength = 744;
static const JSC::Intrinsic s_arrayIteratorPrototypeArrayIteratorNextHelperCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayIteratorPrototypeArrayIteratorNextHelperCode =
s_JSCCombinedCode + 8014
;

const JSC::ConstructAbility s_asyncFunctionPrototypeAsyncFunctionResumeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFunctionPrototypeAsyncFunctionResumeCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncFunctionPrototypeAsyncFunctionResumeCodeLength = 1291;
static const JSC::Intrinsic s_asyncFunctionPrototypeAsyncFunctionResumeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFunctionPrototypeAsyncFunctionResumeCode =
s_JSCCombinedCode + 8758
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeLength = 510;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorEnqueueCode =
s_JSCCombinedCode + 10049
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeLength = 560;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueDequeueCode =
s_JSCCombinedCode + 10559
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeLength = 787;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueEnqueueCode =
s_JSCCombinedCode + 11119
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeLength = 142;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorQueueIsEmptyCode =
s_JSCCombinedCode + 11906
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeLength = 374;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorRejectCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorRejectCode =
s_JSCCombinedCode + 12048
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeLength = 383;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResolveCode =
s_JSCCombinedCode + 12422
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeLength = 2185;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorResumeNextCode =
s_JSCCombinedCode + 12805
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeLength = 488;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAsyncGeneratorYieldCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAsyncGeneratorYieldCode =
s_JSCCombinedCode + 14990
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeAwaitValueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeAwaitValueCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeAwaitValueCodeLength = 243;
static const JSC::Intrinsic s_asyncGeneratorPrototypeAwaitValueCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeAwaitValueCode =
s_JSCCombinedCode + 15478
;

const JSC::ConstructAbility s_stringPrototypeBigCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBigCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeBigCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeBigCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBigCode =
s_JSCCombinedCode + 15721
;

const JSC::ConstructAbility s_functionPrototypeBindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeBindCodeConstructorKind = JSC::ConstructorKind::None;
const int s_functionPrototypeBindCodeLength = 906;
static const JSC::Intrinsic s_functionPrototypeBindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeBindCode =
s_JSCCombinedCode + 15826
;

const JSC::ConstructAbility s_stringPrototypeBlinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBlinkCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeBlinkCodeLength = 109;
static const JSC::Intrinsic s_stringPrototypeBlinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBlinkCode =
s_JSCCombinedCode + 16732
;

const JSC::ConstructAbility s_stringPrototypeBoldCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeBoldCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeBoldCodeLength = 104;
static const JSC::Intrinsic s_stringPrototypeBoldCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeBoldCode =
s_JSCCombinedCode + 16841
;

const JSC::ConstructAbility s_functionPrototypeCallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeCallCodeConstructorKind = JSC::ConstructorKind::None;
const int s_functionPrototypeCallCodeLength = 247;
static const JSC::Intrinsic s_functionPrototypeCallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeCallCode =
s_JSCCombinedCode + 16945
;

const JSC::ConstructAbility s_promisePrototypeCatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeCatchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promisePrototypeCatchCodeLength = 93;
static const JSC::Intrinsic s_promisePrototypeCatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeCatchCode =
s_JSCCombinedCode + 17192
;

const JSC::ConstructAbility s_webAssemblyCompileStreamingCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_webAssemblyCompileStreamingCodeConstructorKind = JSC::ConstructorKind::None;
const int s_webAssemblyCompileStreamingCodeLength = 129;
static const JSC::Intrinsic s_webAssemblyCompileStreamingCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_webAssemblyCompileStreamingCode =
s_JSCCombinedCode + 17285
;

const JSC::ConstructAbility s_arrayPrototypeConcatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeConcatCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeConcatCodeLength = 444;
static const JSC::Intrinsic s_arrayPrototypeConcatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeConcatCode =
s_JSCCombinedCode + 17414
;

const JSC::ConstructAbility s_stringPrototypeConcatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeConcatCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeConcatCodeLength = 322;
static const JSC::Intrinsic s_stringPrototypeConcatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeConcatCode =
s_JSCCombinedCode + 17858
;

const JSC::ConstructAbility s_arrayPrototypeConcatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeConcatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeConcatSlowPathCodeLength = 1516;
static const JSC::Intrinsic s_arrayPrototypeConcatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeConcatSlowPathCode =
s_JSCCombinedCode + 18180
;

const JSC::ConstructAbility s_globalOperationsCopyDataPropertiesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsCopyDataPropertiesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsCopyDataPropertiesCodeLength = 673;
static const JSC::Intrinsic s_globalOperationsCopyDataPropertiesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsCopyDataPropertiesCode =
s_JSCCombinedCode + 19696
;

const JSC::ConstructAbility s_globalOperationsCopyDataPropertiesNoExclusionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsCopyDataPropertiesNoExclusionsCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsCopyDataPropertiesNoExclusionsCodeLength = 592;
static const JSC::Intrinsic s_globalOperationsCopyDataPropertiesNoExclusionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsCopyDataPropertiesNoExclusionsCode =
s_JSCCombinedCode + 20369
;

const JSC::ConstructAbility s_arrayPrototypeCopyWithinCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeCopyWithinCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeCopyWithinCodeLength = 1580;
static const JSC::Intrinsic s_arrayPrototypeCopyWithinCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeCopyWithinCode =
s_JSCCombinedCode + 20961
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeLength = 244;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeCreateAsyncFromSyncIteratorCode =
s_JSCCombinedCode + 22541
;

const JSC::ConstructAbility s_stringPrototypeCreateHTMLCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeCreateHTMLCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeCreateHTMLCodeLength = 530;
static const JSC::Intrinsic s_stringPrototypeCreateHTMLCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeCreateHTMLCode =
s_JSCCombinedCode + 22785
;

const JSC::ConstructAbility s_promiseOperationsCreateResolvingFunctionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsCreateResolvingFunctionsCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsCreateResolvingFunctionsCodeLength = 515;
static const JSC::Intrinsic s_promiseOperationsCreateResolvingFunctionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsCreateResolvingFunctionsCode =
s_JSCCombinedCode + 23315
;

const JSC::ConstructAbility s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeLength = 528;
static const JSC::Intrinsic s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsCreateResolvingFunctionsWithoutPromiseCode =
s_JSCCombinedCode + 23830
;

const JSC::ConstructAbility s_reflectObjectDeletePropertyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectDeletePropertyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_reflectObjectDeletePropertyCodeLength = 212;
static const JSC::Intrinsic s_reflectObjectDeletePropertyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectDeletePropertyCode =
s_JSCCombinedCode + 24358
;

const JSC::ConstructAbility s_moduleLoaderDependencyKeysIfEvaluatedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderDependencyKeysIfEvaluatedCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderDependencyKeysIfEvaluatedCodeLength = 355;
static const JSC::Intrinsic s_moduleLoaderDependencyKeysIfEvaluatedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderDependencyKeysIfEvaluatedCode =
s_JSCCombinedCode + 24570
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeLength = 2120;
static const JSC::Intrinsic s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeDoAsyncGeneratorBodyCallCode =
s_JSCCombinedCode + 24925
;

const JSC::ConstructAbility s_moduleLoaderEnsureRegisteredCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderEnsureRegisteredCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderEnsureRegisteredCodeLength = 218;
static const JSC::Intrinsic s_moduleLoaderEnsureRegisteredCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderEnsureRegisteredCode =
s_JSCCombinedCode + 27045
;

const JSC::ConstructAbility s_mapPrototypeEntriesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapPrototypeEntriesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapPrototypeEntriesCodeLength = 197;
static const JSC::Intrinsic s_mapPrototypeEntriesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeEntriesCode =
s_JSCCombinedCode + 27263
;

const JSC::ConstructAbility s_objectConstructorEntriesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_objectConstructorEntriesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_objectConstructorEntriesCodeLength = 441;
static const JSC::Intrinsic s_objectConstructorEntriesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_objectConstructorEntriesCode =
s_JSCCombinedCode + 27460
;

const JSC::ConstructAbility s_setPrototypeEntriesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeEntriesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_setPrototypeEntriesCodeLength = 197;
static const JSC::Intrinsic s_setPrototypeEntriesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeEntriesCode =
s_JSCCombinedCode + 27901
;

const JSC::ConstructAbility s_arrayPrototypeEveryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeEveryCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeEveryCodeLength = 553;
static const JSC::Intrinsic s_arrayPrototypeEveryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeEveryCode =
s_JSCCombinedCode + 28098
;

const JSC::ConstructAbility s_typedArrayPrototypeEveryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeEveryCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeEveryCodeLength = 389;
static const JSC::Intrinsic s_typedArrayPrototypeEveryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeEveryCode =
s_JSCCombinedCode + 28651
;

const JSC::ConstructAbility s_arrayPrototypeFillCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFillCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFillCodeLength = 881;
static const JSC::Intrinsic s_arrayPrototypeFillCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFillCode =
s_JSCCombinedCode + 29040
;

const JSC::ConstructAbility s_typedArrayPrototypeFillCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFillCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeFillCodeLength = 363;
static const JSC::Intrinsic s_typedArrayPrototypeFillCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFillCode =
s_JSCCombinedCode + 29921
;

const JSC::ConstructAbility s_arrayPrototypeFilterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFilterCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFilterCodeLength = 716;
static const JSC::Intrinsic s_arrayPrototypeFilterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFilterCode =
s_JSCCombinedCode + 30284
;

const JSC::ConstructAbility s_typedArrayPrototypeFilterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFilterCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeFilterCodeLength = 1073;
static const JSC::Intrinsic s_typedArrayPrototypeFilterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFilterCode =
s_JSCCombinedCode + 31000
;

const JSC::ConstructAbility s_promisePrototypeFinallyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeFinallyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promisePrototypeFinallyCodeLength = 579;
static const JSC::Intrinsic s_promisePrototypeFinallyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeFinallyCode =
s_JSCCombinedCode + 32073
;

const JSC::ConstructAbility s_arrayPrototypeFindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFindCodeLength = 527;
static const JSC::Intrinsic s_arrayPrototypeFindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindCode =
s_JSCCombinedCode + 32652
;

const JSC::ConstructAbility s_typedArrayPrototypeFindCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeFindCodeLength = 416;
static const JSC::Intrinsic s_typedArrayPrototypeFindCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindCode =
s_JSCCombinedCode + 33179
;

const JSC::ConstructAbility s_arrayPrototypeFindIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFindIndexCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFindIndexCodeLength = 495;
static const JSC::Intrinsic s_arrayPrototypeFindIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFindIndexCode =
s_JSCCombinedCode + 33595
;

const JSC::ConstructAbility s_typedArrayPrototypeFindIndexCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeFindIndexCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeFindIndexCodeLength = 385;
static const JSC::Intrinsic s_typedArrayPrototypeFindIndexCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeFindIndexCode =
s_JSCCombinedCode + 34090
;

const JSC::ConstructAbility s_stringPrototypeFixedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFixedCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeFixedCodeLength = 106;
static const JSC::Intrinsic s_stringPrototypeFixedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFixedCode =
s_JSCCombinedCode + 34475
;

const JSC::ConstructAbility s_arrayPrototypeFlatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFlatCodeLength = 428;
static const JSC::Intrinsic s_arrayPrototypeFlatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatCode =
s_JSCCombinedCode + 34581
;

const JSC::ConstructAbility s_arrayPrototypeFlatIntoArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatIntoArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFlatIntoArrayCodeLength = 699;
static const JSC::Intrinsic s_arrayPrototypeFlatIntoArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatIntoArrayCode =
s_JSCCombinedCode + 35009
;

const JSC::ConstructAbility s_arrayPrototypeFlatIntoArrayWithCallbackCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatIntoArrayWithCallbackCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFlatIntoArrayWithCallbackCodeLength = 731;
static const JSC::Intrinsic s_arrayPrototypeFlatIntoArrayWithCallbackCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatIntoArrayWithCallbackCode =
s_JSCCombinedCode + 35708
;

const JSC::ConstructAbility s_arrayPrototypeFlatMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeFlatMapCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeFlatMapCodeLength = 481;
static const JSC::Intrinsic s_arrayPrototypeFlatMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeFlatMapCode =
s_JSCCombinedCode + 36439
;

const JSC::ConstructAbility s_stringPrototypeFontcolorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFontcolorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeFontcolorCodeLength = 125;
static const JSC::Intrinsic s_stringPrototypeFontcolorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFontcolorCode =
s_JSCCombinedCode + 36920
;

const JSC::ConstructAbility s_stringPrototypeFontsizeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeFontsizeCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeFontsizeCodeLength = 121;
static const JSC::Intrinsic s_stringPrototypeFontsizeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeFontsizeCode =
s_JSCCombinedCode + 37045
;

const JSC::ConstructAbility s_arrayPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeForEachCodeLength = 483;
static const JSC::Intrinsic s_arrayPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeForEachCode =
s_JSCCombinedCode + 37166
;

const JSC::ConstructAbility s_mapPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapPrototypeForEachCodeLength = 547;
static const JSC::Intrinsic s_mapPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeForEachCode =
s_JSCCombinedCode + 37649
;

const JSC::ConstructAbility s_setPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const int s_setPrototypeForEachCodeLength = 550;
static const JSC::Intrinsic s_setPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeForEachCode =
s_JSCCombinedCode + 38196
;

const JSC::ConstructAbility s_typedArrayPrototypeForEachCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeForEachCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeForEachCodeLength = 334;
static const JSC::Intrinsic s_typedArrayPrototypeForEachCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeForEachCode =
s_JSCCombinedCode + 38746
;

const JSC::ConstructAbility s_moduleLoaderForceFulfillPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderForceFulfillPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderForceFulfillPromiseCodeLength = 237;
static const JSC::Intrinsic s_moduleLoaderForceFulfillPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderForceFulfillPromiseCode =
s_JSCCombinedCode + 39080
;

const JSC::ConstructAbility s_arrayConstructorFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorFromCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayConstructorFromCodeLength = 1845;
static const JSC::Intrinsic s_arrayConstructorFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorFromCode =
s_JSCCombinedCode + 39317
;

const JSC::ConstructAbility s_typedArrayConstructorFromCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorFromCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorFromCodeLength = 2209;
static const JSC::Intrinsic s_typedArrayConstructorFromCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorFromCode =
s_JSCCombinedCode + 41162
;

const JSC::ConstructAbility s_objectConstructorFromEntriesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_objectConstructorFromEntriesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_objectConstructorFromEntriesCodeLength = 365;
static const JSC::Intrinsic s_objectConstructorFromEntriesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_objectConstructorFromEntriesCode =
s_JSCCombinedCode + 43371
;

const JSC::ConstructAbility s_moduleLoaderFulfillFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderFulfillFetchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderFulfillFetchCodeLength = 250;
static const JSC::Intrinsic s_moduleLoaderFulfillFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderFulfillFetchCode =
s_JSCCombinedCode + 43736
;

const JSC::ConstructAbility s_promiseOperationsFulfillPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsFulfillPromiseCodeLength = 676;
static const JSC::Intrinsic s_promiseOperationsFulfillPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillPromiseCode =
s_JSCCombinedCode + 43986
;

const JSC::ConstructAbility s_promiseOperationsFulfillWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsFulfillWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsFulfillWithoutPromiseCodeLength = 139;
static const JSC::Intrinsic s_promiseOperationsFulfillWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsFulfillWithoutPromiseCode =
s_JSCCombinedCode + 44662
;

const JSC::ConstructAbility s_generatorPrototypeGeneratorResumeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeGeneratorResumeCodeConstructorKind = JSC::ConstructorKind::None;
const int s_generatorPrototypeGeneratorResumeCodeLength = 930;
static const JSC::Intrinsic s_generatorPrototypeGeneratorResumeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeGeneratorResumeCode =
s_JSCCombinedCode + 44801
;

const JSC::ConstructAbility s_promisePrototypeGetCatchFinallyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeGetCatchFinallyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promisePrototypeGetCatchFinallyCodeLength = 501;
static const JSC::Intrinsic s_promisePrototypeGetCatchFinallyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeGetCatchFinallyCode =
s_JSCCombinedCode + 45731
;

const JSC::ConstructAbility s_promisePrototypeGetThenFinallyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeGetThenFinallyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promisePrototypeGetThenFinallyCodeLength = 506;
static const JSC::Intrinsic s_promisePrototypeGetThenFinallyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeGetThenFinallyCode =
s_JSCCombinedCode + 46232
;

const JSC::ConstructAbility s_reflectObjectHasCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_reflectObjectHasCodeConstructorKind = JSC::ConstructorKind::None;
const int s_reflectObjectHasCodeLength = 200;
static const JSC::Intrinsic s_reflectObjectHasCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_reflectObjectHasCode =
s_JSCCombinedCode + 46738
;

const JSC::ConstructAbility s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeLength = 527;
static const JSC::Intrinsic s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeHasObservableSideEffectsForRegExpMatchCode =
s_JSCCombinedCode + 46938
;

const JSC::ConstructAbility s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeLength = 1216;
static const JSC::Intrinsic s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeHasObservableSideEffectsForRegExpSplitCode =
s_JSCCombinedCode + 47465
;

const JSC::ConstructAbility s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeLength = 609;
static const JSC::Intrinsic s_stringPrototypeHasObservableSideEffectsForStringReplaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeHasObservableSideEffectsForStringReplaceCode =
s_JSCCombinedCode + 48681
;

const JSC::ConstructAbility s_arrayPrototypeIncludesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeIncludesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeIncludesCodeLength = 798;
static const JSC::Intrinsic s_arrayPrototypeIncludesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeIncludesCode =
s_JSCCombinedCode + 49290
;

const JSC::ConstructAbility s_webAssemblyInstantiateStreamingCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_webAssemblyInstantiateStreamingCodeConstructorKind = JSC::ConstructorKind::None;
const int s_webAssemblyInstantiateStreamingCodeLength = 133;
static const JSC::Intrinsic s_webAssemblyInstantiateStreamingCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_webAssemblyInstantiateStreamingCode =
s_JSCCombinedCode + 50088
;

const JSC::ConstructAbility s_internalPromiseConstructorInternalAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_internalPromiseConstructorInternalAllCodeConstructorKind = JSC::ConstructorKind::None;
const int s_internalPromiseConstructorInternalAllCodeLength = 1603;
static const JSC::Intrinsic s_internalPromiseConstructorInternalAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_internalPromiseConstructorInternalAllCode =
s_JSCCombinedCode + 50221
;

const JSC::ConstructAbility s_arrayConstructorIsArrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorIsArrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayConstructorIsArrayCodeLength = 202;
static const JSC::Intrinsic s_arrayConstructorIsArrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorIsArrayCode =
s_JSCCombinedCode + 51824
;

const JSC::ConstructAbility s_globalOperationsIsDictionaryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsIsDictionaryCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsIsDictionaryCodeLength = 100;
static const JSC::Intrinsic s_globalOperationsIsDictionaryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsIsDictionaryCode =
s_JSCCombinedCode + 52026
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeIsExecutionStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeIsExecutionStateCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeIsExecutionStateCodeLength = 402;
static const JSC::Intrinsic s_asyncGeneratorPrototypeIsExecutionStateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeIsExecutionStateCode =
s_JSCCombinedCode + 52126
;

const JSC::ConstructAbility s_globalObjectIsFiniteCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalObjectIsFiniteCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalObjectIsFiniteCodeLength = 216;
static const JSC::Intrinsic s_globalObjectIsFiniteCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalObjectIsFiniteCode =
s_JSCCombinedCode + 52528
;

const JSC::ConstructAbility s_numberConstructorIsFiniteCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_numberConstructorIsFiniteCodeConstructorKind = JSC::ConstructorKind::None;
const int s_numberConstructorIsFiniteCodeLength = 211;
static const JSC::Intrinsic s_numberConstructorIsFiniteCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_numberConstructorIsFiniteCode =
s_JSCCombinedCode + 52744
;

const JSC::ConstructAbility s_globalObjectIsNaNCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalObjectIsNaNCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalObjectIsNaNCodeLength = 122;
static const JSC::Intrinsic s_globalObjectIsNaNCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalObjectIsNaNCode =
s_JSCCombinedCode + 52955
;

const JSC::ConstructAbility s_numberConstructorIsNaNCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_numberConstructorIsNaNCodeConstructorKind = JSC::ConstructorKind::None;
const int s_numberConstructorIsNaNCodeLength = 70;
static const JSC::Intrinsic s_numberConstructorIsNaNCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_numberConstructorIsNaNCode =
s_JSCCombinedCode + 53077
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeIsSuspendYieldStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeIsSuspendYieldStateCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeIsSuspendYieldStateCodeLength = 327;
static const JSC::Intrinsic s_asyncGeneratorPrototypeIsSuspendYieldStateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeIsSuspendYieldStateCode =
s_JSCCombinedCode + 53147
;

const JSC::ConstructAbility s_stringPrototypeItalicsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeItalicsCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeItalicsCodeLength = 107;
static const JSC::Intrinsic s_stringPrototypeItalicsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeItalicsCode =
s_JSCCombinedCode + 53474
;

const JSC::ConstructAbility s_mapPrototypeKeysCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapPrototypeKeysCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapPrototypeKeysCodeLength = 190;
static const JSC::Intrinsic s_mapPrototypeKeysCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeKeysCode =
s_JSCCombinedCode + 53581
;

const JSC::ConstructAbility s_moduleLoaderLinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLinkCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderLinkCodeLength = 614;
static const JSC::Intrinsic s_moduleLoaderLinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLinkCode =
s_JSCCombinedCode + 53771
;

const JSC::ConstructAbility s_stringPrototypeLinkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeLinkCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeLinkCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeLinkCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeLinkCode =
s_JSCCombinedCode + 54385
;

const JSC::ConstructAbility s_moduleLoaderLinkAndEvaluateModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLinkAndEvaluateModuleCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderLinkAndEvaluateModuleCodeLength = 280;
static const JSC::Intrinsic s_moduleLoaderLinkAndEvaluateModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLinkAndEvaluateModuleCode =
s_JSCCombinedCode + 54496
;

const JSC::ConstructAbility s_moduleLoaderLoadAndEvaluateModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLoadAndEvaluateModuleCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderLoadAndEvaluateModuleCodeLength = 203;
static const JSC::Intrinsic s_moduleLoaderLoadAndEvaluateModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLoadAndEvaluateModuleCode =
s_JSCCombinedCode + 54776
;

const JSC::ConstructAbility s_moduleLoaderLoadModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderLoadModuleCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderLoadModuleCodeLength = 293;
static const JSC::Intrinsic s_moduleLoaderLoadModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderLoadModuleCode =
s_JSCCombinedCode + 54979
;

const JSC::ConstructAbility s_arrayPrototypeMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeMapCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeMapCodeLength = 631;
static const JSC::Intrinsic s_arrayPrototypeMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeMapCode =
s_JSCCombinedCode + 55272
;

const JSC::ConstructAbility s_typedArrayPrototypeMapCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeMapCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeMapCodeLength = 927;
static const JSC::Intrinsic s_typedArrayPrototypeMapCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeMapCode =
s_JSCCombinedCode + 55903
;

const JSC::ConstructAbility s_mapIteratorPrototypeMapIteratorNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapIteratorPrototypeMapIteratorNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapIteratorPrototypeMapIteratorNextCodeLength = 483;
static const JSC::Intrinsic s_mapIteratorPrototypeMapIteratorNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapIteratorPrototypeMapIteratorNextCode =
s_JSCCombinedCode + 56830
;

const JSC::ConstructAbility s_regExpPrototypeMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeMatchCodeLength = 338;
static const JSC::Intrinsic s_regExpPrototypeMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchCode =
s_JSCCombinedCode + 57313
;

const JSC::ConstructAbility s_stringPrototypeMatchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeMatchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeMatchCodeLength = 482;
static const JSC::Intrinsic s_stringPrototypeMatchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeMatchCode =
s_JSCCombinedCode + 57651
;

const JSC::ConstructAbility s_regExpPrototypeMatchAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchAllCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeMatchAllCodeLength = 619;
static const JSC::Intrinsic s_regExpPrototypeMatchAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchAllCode =
s_JSCCombinedCode + 58133
;

const JSC::ConstructAbility s_stringPrototypeMatchAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeMatchAllCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeMatchAllCodeLength = 667;
static const JSC::Intrinsic s_stringPrototypeMatchAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeMatchAllCode =
s_JSCCombinedCode + 58752
;

const JSC::ConstructAbility s_regExpPrototypeMatchSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeMatchSlowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeMatchSlowCodeLength = 806;
static const JSC::Intrinsic s_regExpPrototypeMatchSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeMatchSlowCode =
s_JSCCombinedCode + 59419
;

const JSC::ConstructAbility s_moduleLoaderModuleEvaluationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderModuleEvaluationCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderModuleEvaluationCodeLength = 357;
static const JSC::Intrinsic s_moduleLoaderModuleEvaluationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderModuleEvaluationCode =
s_JSCCombinedCode + 60225
;

const JSC::ConstructAbility s_promiseOperationsNewHandledRejectedPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewHandledRejectedPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsNewHandledRejectedPromiseCodeLength = 304;
static const JSC::Intrinsic s_promiseOperationsNewHandledRejectedPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewHandledRejectedPromiseCode =
s_JSCCombinedCode + 60582
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseCapabilityCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseCapabilityCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsNewPromiseCapabilityCodeLength = 565;
static const JSC::Intrinsic s_promiseOperationsNewPromiseCapabilityCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseCapabilityCode =
s_JSCCombinedCode + 60886
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseCapabilitySlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseCapabilitySlowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsNewPromiseCapabilitySlowCodeLength = 1000;
static const JSC::Intrinsic s_promiseOperationsNewPromiseCapabilitySlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseCapabilitySlowCode =
s_JSCCombinedCode + 61451
;

const JSC::ConstructAbility s_promiseOperationsNewPromiseReactionCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsNewPromiseReactionCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsNewPromiseReactionCodeLength = 247;
static const JSC::Intrinsic s_promiseOperationsNewPromiseReactionCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsNewPromiseReactionCode =
s_JSCCombinedCode + 62451
;

const JSC::ConstructAbility s_moduleLoaderNewRegistryEntryCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderNewRegistryEntryCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderNewRegistryEntryCodeLength = 623;
static const JSC::Intrinsic s_moduleLoaderNewRegistryEntryCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderNewRegistryEntryCode =
s_JSCCombinedCode + 62698
;

const JSC::ConstructAbility s_arrayIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayIteratorPrototypeNextCodeLength = 409;
static const JSC::Intrinsic s_arrayIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayIteratorPrototypeNextCode =
s_JSCCombinedCode + 63321
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncFromSyncIteratorPrototypeNextCodeLength = 957;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeNextCode =
s_JSCCombinedCode + 63730
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeNextCodeLength = 118;
static const JSC::Intrinsic s_asyncGeneratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeNextCode =
s_JSCCombinedCode + 64687
;

const JSC::ConstructAbility s_generatorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_generatorPrototypeNextCodeLength = 441;
static const JSC::Intrinsic s_generatorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeNextCode =
s_JSCCombinedCode + 64805
;

const JSC::ConstructAbility s_mapIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapIteratorPrototypeNextCodeLength = 465;
static const JSC::Intrinsic s_mapIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapIteratorPrototypeNextCode =
s_JSCCombinedCode + 65246
;

const JSC::ConstructAbility s_regExpStringIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpStringIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpStringIteratorPrototypeNextCodeLength = 1328;
static const JSC::Intrinsic s_regExpStringIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpStringIteratorPrototypeNextCode =
s_JSCCombinedCode + 65711
;

const JSC::ConstructAbility s_setIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_setIteratorPrototypeNextCodeLength = 465;
static const JSC::Intrinsic s_setIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setIteratorPrototypeNextCode =
s_JSCCombinedCode + 67039
;

const JSC::ConstructAbility s_stringIteratorPrototypeNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringIteratorPrototypeNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringIteratorPrototypeNextCodeLength = 1247;
static const JSC::Intrinsic s_stringIteratorPrototypeNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringIteratorPrototypeNextCode =
s_JSCCombinedCode + 67504
;

const JSC::ConstructAbility s_arrayConstructorOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayConstructorOfCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayConstructorOfCodeLength = 288;
static const JSC::Intrinsic s_arrayConstructorOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayConstructorOfCode =
s_JSCCombinedCode + 68751
;

const JSC::ConstructAbility s_typedArrayConstructorOfCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayConstructorOfCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayConstructorOfCodeLength = 426;
static const JSC::Intrinsic s_typedArrayConstructorOfCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayConstructorOfCode =
s_JSCCombinedCode + 69039
;

const JSC::ConstructAbility s_stringPrototypePadEndCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypePadEndCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypePadEndCodeLength = 953;
static const JSC::Intrinsic s_stringPrototypePadEndCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypePadEndCode =
s_JSCCombinedCode + 69465
;

const JSC::ConstructAbility s_stringPrototypePadStartCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypePadStartCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypePadStartCodeLength = 955;
static const JSC::Intrinsic s_stringPrototypePadStartCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypePadStartCode =
s_JSCCombinedCode + 70418
;

const JSC::ConstructAbility s_iteratorHelpersPerformIterationCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorHelpersPerformIterationCodeConstructorKind = JSC::ConstructorKind::None;
const int s_iteratorHelpersPerformIterationCodeLength = 469;
static const JSC::Intrinsic s_iteratorHelpersPerformIterationCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorHelpersPerformIterationCode =
s_JSCCombinedCode + 71373
;

const JSC::ConstructAbility s_inspectorInstrumentationObjectPromiseFulfilledCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_inspectorInstrumentationObjectPromiseFulfilledCodeConstructorKind = JSC::ConstructorKind::None;
const int s_inspectorInstrumentationObjectPromiseFulfilledCodeLength = 103;
static const JSC::Intrinsic s_inspectorInstrumentationObjectPromiseFulfilledCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_inspectorInstrumentationObjectPromiseFulfilledCode =
s_JSCCombinedCode + 71842
;

const JSC::ConstructAbility s_promiseOperationsPromiseReactionJobCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseReactionJobCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseReactionJobCodeLength = 1309;
static const JSC::Intrinsic s_promiseOperationsPromiseReactionJobCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseReactionJobCode =
s_JSCCombinedCode + 71945
;

const JSC::ConstructAbility s_promiseOperationsPromiseReactionJobWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseReactionJobWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseReactionJobWithoutPromiseCodeLength = 122;
static const JSC::Intrinsic s_promiseOperationsPromiseReactionJobWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseReactionJobWithoutPromiseCode =
s_JSCCombinedCode + 73254
;

const JSC::ConstructAbility s_promiseOperationsPromiseRejectSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseRejectSlowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseRejectSlowCodeLength = 240;
static const JSC::Intrinsic s_promiseOperationsPromiseRejectSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseRejectSlowCode =
s_JSCCombinedCode + 73376
;

const JSC::ConstructAbility s_inspectorInstrumentationObjectPromiseRejectedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_inspectorInstrumentationObjectPromiseRejectedCodeConstructorKind = JSC::ConstructorKind::None;
const int s_inspectorInstrumentationObjectPromiseRejectedCodeLength = 104;
static const JSC::Intrinsic s_inspectorInstrumentationObjectPromiseRejectedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_inspectorInstrumentationObjectPromiseRejectedCode =
s_JSCCombinedCode + 73616
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveSlowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveSlowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseResolveSlowCodeLength = 239;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveSlowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveSlowCode =
s_JSCCombinedCode + 73720
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseResolveThenableJobCodeLength = 271;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobCode =
s_JSCCombinedCode + 73959
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobFastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobFastCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseResolveThenableJobFastCodeLength = 1006;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobFastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobFastCode =
s_JSCCombinedCode + 74230
;

const JSC::ConstructAbility s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeLength = 1103;
static const JSC::Intrinsic s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsPromiseResolveThenableJobWithoutPromiseFastCode =
s_JSCCombinedCode + 75236
;

const JSC::ConstructAbility s_moduleLoaderProvideFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderProvideFetchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderProvideFetchCodeLength = 230;
static const JSC::Intrinsic s_moduleLoaderProvideFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderProvideFetchCode =
s_JSCCombinedCode + 76339
;

const JSC::ConstructAbility s_promiseConstructorRaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorRaceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseConstructorRaceCodeLength = 678;
static const JSC::Intrinsic s_promiseConstructorRaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorRaceCode =
s_JSCCombinedCode + 76569
;

const JSC::ConstructAbility s_stringConstructorRawCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringConstructorRawCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringConstructorRawCodeLength = 860;
static const JSC::Intrinsic s_stringConstructorRawCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringConstructorRawCode =
s_JSCCombinedCode + 77247
;

const JSC::ConstructAbility s_arrayPrototypeReduceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeReduceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeReduceCodeLength = 962;
static const JSC::Intrinsic s_arrayPrototypeReduceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeReduceCode =
s_JSCCombinedCode + 78107
;

const JSC::ConstructAbility s_typedArrayPrototypeReduceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeReduceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeReduceCodeLength = 668;
static const JSC::Intrinsic s_typedArrayPrototypeReduceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeReduceCode =
s_JSCCombinedCode + 79069
;

const JSC::ConstructAbility s_arrayPrototypeReduceRightCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeReduceRightCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeReduceRightCodeLength = 977;
static const JSC::Intrinsic s_arrayPrototypeReduceRightCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeReduceRightCode =
s_JSCCombinedCode + 79737
;

const JSC::ConstructAbility s_typedArrayPrototypeReduceRightCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeReduceRightCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeReduceRightCodeLength = 683;
static const JSC::Intrinsic s_typedArrayPrototypeReduceRightCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeReduceRightCode =
s_JSCCombinedCode + 80714
;

const JSC::ConstructAbility s_regExpPrototypeRegExpExecCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeRegExpExecCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeRegExpExecCodeLength = 435;
static const JSC::Intrinsic s_regExpPrototypeRegExpExecCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeRegExpExecCode =
s_JSCCombinedCode + 81397
;

const JSC::ConstructAbility s_promiseConstructorRejectCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorRejectCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseConstructorRejectCodeLength = 340;
static const JSC::Intrinsic s_promiseConstructorRejectCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorRejectCode =
s_JSCCombinedCode + 81832
;

const JSC::ConstructAbility s_promiseOperationsRejectPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsRejectPromiseCodeLength = 793;
static const JSC::Intrinsic s_promiseOperationsRejectPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectPromiseCode =
s_JSCCombinedCode + 82172
;

const JSC::ConstructAbility s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeLength = 371;
static const JSC::Intrinsic s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectPromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 82965
;

const JSC::ConstructAbility s_promiseOperationsRejectWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsRejectWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsRejectWithoutPromiseCodeLength = 140;
static const JSC::Intrinsic s_promiseOperationsRejectWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsRejectWithoutPromiseCode =
s_JSCCombinedCode + 83336
;

const JSC::ConstructAbility s_stringPrototypeRepeatCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeRepeatCodeLength = 522;
static const JSC::Intrinsic s_stringPrototypeRepeatCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatCode =
s_JSCCombinedCode + 83476
;

const JSC::ConstructAbility s_stringPrototypeRepeatCharactersSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatCharactersSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeRepeatCharactersSlowPathCodeLength = 540;
static const JSC::Intrinsic s_stringPrototypeRepeatCharactersSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatCharactersSlowPathCode =
s_JSCCombinedCode + 83998
;

const JSC::ConstructAbility s_stringPrototypeRepeatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeRepeatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeRepeatSlowPathCodeLength = 496;
static const JSC::Intrinsic s_stringPrototypeRepeatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeRepeatSlowPathCode =
s_JSCCombinedCode + 84538
;

const JSC::ConstructAbility s_regExpPrototypeReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeReplaceCodeLength = 6879;
static const JSC::Intrinsic s_regExpPrototypeReplaceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeReplaceCode =
s_JSCCombinedCode + 85034
;

const JSC::ConstructAbility s_stringPrototypeReplaceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeReplaceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeReplaceCodeLength = 679;
static const JSC::Intrinsic s_stringPrototypeReplaceCodeIntrinsic = JSC::StringPrototypeReplaceIntrinsic;
const char* const s_stringPrototypeReplaceCode =
s_JSCCombinedCode + 91913
;

const JSC::ConstructAbility s_stringPrototypeReplaceAllCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeReplaceAllCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeReplaceAllCodeLength = 893;
static const JSC::Intrinsic s_stringPrototypeReplaceAllCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeReplaceAllCode =
s_JSCCombinedCode + 92592
;

const JSC::ConstructAbility s_moduleLoaderRequestFetchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestFetchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderRequestFetchCodeLength = 779;
static const JSC::Intrinsic s_moduleLoaderRequestFetchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestFetchCode =
s_JSCCombinedCode + 93485
;

const JSC::ConstructAbility s_moduleLoaderRequestImportModuleCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestImportModuleCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderRequestImportModuleCodeLength = 277;
static const JSC::Intrinsic s_moduleLoaderRequestImportModuleCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestImportModuleCode =
s_JSCCombinedCode + 94264
;

const JSC::ConstructAbility s_moduleLoaderRequestInstantiateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestInstantiateCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderRequestInstantiateCodeLength = 1264;
static const JSC::Intrinsic s_moduleLoaderRequestInstantiateCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestInstantiateCode =
s_JSCCombinedCode + 94541
;

const JSC::ConstructAbility s_moduleLoaderRequestSatisfyCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderRequestSatisfyCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderRequestSatisfyCodeLength = 1299;
static const JSC::Intrinsic s_moduleLoaderRequestSatisfyCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderRequestSatisfyCode =
s_JSCCombinedCode + 95805
;

const JSC::ConstructAbility s_promiseConstructorResolveCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseConstructorResolveCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseConstructorResolveCodeLength = 490;
static const JSC::Intrinsic s_promiseConstructorResolveCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseConstructorResolveCode =
s_JSCCombinedCode + 97104
;

const JSC::ConstructAbility s_promiseOperationsResolvePromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolvePromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsResolvePromiseCodeLength = 790;
static const JSC::Intrinsic s_promiseOperationsResolvePromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolvePromiseCode =
s_JSCCombinedCode + 97594
;

const JSC::ConstructAbility s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeLength = 370;
static const JSC::Intrinsic s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolvePromiseWithFirstResolvingFunctionCallCheckCode =
s_JSCCombinedCode + 98384
;

const JSC::ConstructAbility s_promiseOperationsResolveWithoutPromiseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsResolveWithoutPromiseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsResolveWithoutPromiseCodeLength = 821;
static const JSC::Intrinsic s_promiseOperationsResolveWithoutPromiseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsResolveWithoutPromiseCode =
s_JSCCombinedCode + 98754
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncFromSyncIteratorPrototypeReturnCodeLength = 1520;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeReturnCode =
s_JSCCombinedCode + 99575
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeReturnCodeLength = 118;
static const JSC::Intrinsic s_asyncGeneratorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeReturnCode =
s_JSCCombinedCode + 101095
;

const JSC::ConstructAbility s_generatorPrototypeReturnCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeReturnCodeConstructorKind = JSC::ConstructorKind::None;
const int s_generatorPrototypeReturnCodeLength = 436;
static const JSC::Intrinsic s_generatorPrototypeReturnCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeReturnCode =
s_JSCCombinedCode + 101213
;

const JSC::ConstructAbility s_regExpPrototypeSearchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeSearchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeSearchCodeLength = 840;
static const JSC::Intrinsic s_regExpPrototypeSearchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeSearchCode =
s_JSCCombinedCode + 101649
;

const JSC::ConstructAbility s_stringPrototypeSearchCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSearchCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeSearchCodeLength = 488;
static const JSC::Intrinsic s_stringPrototypeSearchCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSearchCode =
s_JSCCombinedCode + 102489
;

const JSC::ConstructAbility s_setIteratorPrototypeSetIteratorNextCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setIteratorPrototypeSetIteratorNextCodeConstructorKind = JSC::ConstructorKind::None;
const int s_setIteratorPrototypeSetIteratorNextCodeLength = 372;
static const JSC::Intrinsic s_setIteratorPrototypeSetIteratorNextCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setIteratorPrototypeSetIteratorNextCode =
s_JSCCombinedCode + 102977
;

const JSC::ConstructAbility s_moduleLoaderSetStateToMaxCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_moduleLoaderSetStateToMaxCodeConstructorKind = JSC::ConstructorKind::None;
const int s_moduleLoaderSetStateToMaxCodeLength = 124;
static const JSC::Intrinsic s_moduleLoaderSetStateToMaxCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_moduleLoaderSetStateToMaxCode =
s_JSCCombinedCode + 103349
;

const JSC::ConstructAbility s_stringPrototypeSmallCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSmallCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeSmallCodeLength = 109;
static const JSC::Intrinsic s_stringPrototypeSmallCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSmallCode =
s_JSCCombinedCode + 103473
;

const JSC::ConstructAbility s_arrayPrototypeSomeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSomeCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeSomeCodeLength = 540;
static const JSC::Intrinsic s_arrayPrototypeSomeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSomeCode =
s_JSCCombinedCode + 103582
;

const JSC::ConstructAbility s_typedArrayPrototypeSomeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeSomeCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeSomeCodeLength = 394;
static const JSC::Intrinsic s_typedArrayPrototypeSomeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeSomeCode =
s_JSCCombinedCode + 104122
;

const JSC::ConstructAbility s_arrayPrototypeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_arrayPrototypeSortCodeConstructorKind = JSC::ConstructorKind::None;
const int s_arrayPrototypeSortCodeLength = 6304;
static const JSC::Intrinsic s_arrayPrototypeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_arrayPrototypeSortCode =
s_JSCCombinedCode + 104516
;

const JSC::ConstructAbility s_typedArrayPrototypeSortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeSortCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeSortCodeLength = 1540;
static const JSC::Intrinsic s_typedArrayPrototypeSortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeSortCode =
s_JSCCombinedCode + 110820
;

const JSC::ConstructAbility s_globalOperationsSpeciesConstructorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsSpeciesConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsSpeciesConstructorCodeLength = 547;
static const JSC::Intrinsic s_globalOperationsSpeciesConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsSpeciesConstructorCode =
s_JSCCombinedCode + 112360
;

const JSC::ConstructAbility s_globalOperationsSpeciesGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsSpeciesGetterCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsSpeciesGetterCodeLength = 53;
static const JSC::Intrinsic s_globalOperationsSpeciesGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsSpeciesGetterCode =
s_JSCCombinedCode + 112907
;

const JSC::ConstructAbility s_regExpPrototypeSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeSplitCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeSplitCodeLength = 3288;
static const JSC::Intrinsic s_regExpPrototypeSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_regExpPrototypeSplitCode =
s_JSCCombinedCode + 112960
;

const JSC::ConstructAbility s_stringPrototypeSplitCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSplitCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeSplitCodeLength = 434;
static const JSC::Intrinsic s_stringPrototypeSplitCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSplitCode =
s_JSCCombinedCode + 116248
;

const JSC::ConstructAbility s_stringPrototypeStrikeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeStrikeCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeStrikeCodeLength = 111;
static const JSC::Intrinsic s_stringPrototypeStrikeCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeStrikeCode =
s_JSCCombinedCode + 116682
;

const JSC::ConstructAbility s_stringPrototypeStringConcatSlowPathCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeStringConcatSlowPathCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeStringConcatSlowPathCodeLength = 197;
static const JSC::Intrinsic s_stringPrototypeStringConcatSlowPathCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeStringConcatSlowPathCode =
s_JSCCombinedCode + 116793
;

const JSC::ConstructAbility s_stringPrototypeSubCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSubCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeSubCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeSubCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSubCode =
s_JSCCombinedCode + 116990
;

const JSC::ConstructAbility s_typedArrayPrototypeSubarrayCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeSubarrayCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeSubarrayCodeLength = 398;
static const JSC::Intrinsic s_typedArrayPrototypeSubarrayCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeSubarrayCode =
s_JSCCombinedCode + 117095
;

const JSC::ConstructAbility s_stringPrototypeSupCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_stringPrototypeSupCodeConstructorKind = JSC::ConstructorKind::None;
const int s_stringPrototypeSupCodeLength = 105;
static const JSC::Intrinsic s_stringPrototypeSupCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_stringPrototypeSupCode =
s_JSCCombinedCode + 117493
;

const JSC::ConstructAbility s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeLength = 54;
static const JSC::Intrinsic s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncIteratorPrototypeSymbolAsyncIteratorGetterCode =
s_JSCCombinedCode + 117598
;

const JSC::ConstructAbility s_functionPrototypeSymbolHasInstanceCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_functionPrototypeSymbolHasInstanceCodeConstructorKind = JSC::ConstructorKind::None;
const int s_functionPrototypeSymbolHasInstanceCodeLength = 261;
static const JSC::Intrinsic s_functionPrototypeSymbolHasInstanceCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_functionPrototypeSymbolHasInstanceCode =
s_JSCCombinedCode + 117652
;

const JSC::ConstructAbility s_iteratorPrototypeSymbolIteratorGetterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_iteratorPrototypeSymbolIteratorGetterCodeConstructorKind = JSC::ConstructorKind::None;
const int s_iteratorPrototypeSymbolIteratorGetterCodeLength = 54;
static const JSC::Intrinsic s_iteratorPrototypeSymbolIteratorGetterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_iteratorPrototypeSymbolIteratorGetterCode =
s_JSCCombinedCode + 117913
;

const JSC::ConstructAbility s_regExpPrototypeTestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_regExpPrototypeTestCodeConstructorKind = JSC::ConstructorKind::None;
const int s_regExpPrototypeTestCodeLength = 560;
static const JSC::Intrinsic s_regExpPrototypeTestCodeIntrinsic = JSC::RegExpTestIntrinsic;
const char* const s_regExpPrototypeTestCode =
s_JSCCombinedCode + 117967
;

const JSC::ConstructAbility s_promisePrototypeThenCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promisePrototypeThenCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promisePrototypeThenCodeLength = 1579;
static const JSC::Intrinsic s_promisePrototypeThenCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promisePrototypeThenCode =
s_JSCCombinedCode + 118527
;

const JSC::ConstructAbility s_asyncFromSyncIteratorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncFromSyncIteratorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncFromSyncIteratorPrototypeThrowCodeLength = 1522;
static const JSC::Intrinsic s_asyncFromSyncIteratorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncFromSyncIteratorPrototypeThrowCode =
s_JSCCombinedCode + 120106
;

const JSC::ConstructAbility s_asyncGeneratorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_asyncGeneratorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_asyncGeneratorPrototypeThrowCodeLength = 129;
static const JSC::Intrinsic s_asyncGeneratorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_asyncGeneratorPrototypeThrowCode =
s_JSCCombinedCode + 121628
;

const JSC::ConstructAbility s_generatorPrototypeThrowCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_generatorPrototypeThrowCodeConstructorKind = JSC::ConstructorKind::None;
const int s_generatorPrototypeThrowCodeLength = 518;
static const JSC::Intrinsic s_generatorPrototypeThrowCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_generatorPrototypeThrowCode =
s_JSCCombinedCode + 121757
;

const JSC::ConstructAbility s_globalOperationsToIntegerCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsToIntegerCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsToIntegerCodeLength = 169;
static const JSC::Intrinsic s_globalOperationsToIntegerCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsToIntegerCode =
s_JSCCombinedCode + 122275
;

const JSC::ConstructAbility s_globalOperationsToLengthCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_globalOperationsToLengthCodeConstructorKind = JSC::ConstructorKind::None;
const int s_globalOperationsToLengthCodeLength = 177;
static const JSC::Intrinsic s_globalOperationsToLengthCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_globalOperationsToLengthCode =
s_JSCCombinedCode + 122444
;

const JSC::ConstructAbility s_datePrototypeToLocaleDateStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToLocaleDateStringCodeConstructorKind = JSC::ConstructorKind::None;
const int s_datePrototypeToLocaleDateStringCodeLength = 1071;
static const JSC::Intrinsic s_datePrototypeToLocaleDateStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToLocaleDateStringCode =
s_JSCCombinedCode + 122621
;

const JSC::ConstructAbility s_datePrototypeToLocaleStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToLocaleStringCodeConstructorKind = JSC::ConstructorKind::None;
const int s_datePrototypeToLocaleStringCodeLength = 1329;
static const JSC::Intrinsic s_datePrototypeToLocaleStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToLocaleStringCode =
s_JSCCombinedCode + 123692
;

const JSC::ConstructAbility s_typedArrayPrototypeToLocaleStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeToLocaleStringCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeToLocaleStringCodeLength = 323;
static const JSC::Intrinsic s_typedArrayPrototypeToLocaleStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeToLocaleStringCode =
s_JSCCombinedCode + 125021
;

const JSC::ConstructAbility s_datePrototypeToLocaleTimeStringCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_datePrototypeToLocaleTimeStringCodeConstructorKind = JSC::ConstructorKind::None;
const int s_datePrototypeToLocaleTimeStringCodeLength = 1033;
static const JSC::Intrinsic s_datePrototypeToLocaleTimeStringCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_datePrototypeToLocaleTimeStringCode =
s_JSCCombinedCode + 125344
;

const JSC::ConstructAbility s_promiseOperationsTriggerPromiseReactionsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_promiseOperationsTriggerPromiseReactionsCodeConstructorKind = JSC::ConstructorKind::None;
const int s_promiseOperationsTriggerPromiseReactionsCodeLength = 459;
static const JSC::Intrinsic s_promiseOperationsTriggerPromiseReactionsCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_promiseOperationsTriggerPromiseReactionsCode =
s_JSCCombinedCode + 126377
;

const JSC::ConstructAbility s_typedArrayPrototypeTypedArrayClampArgumentToStartOrEndCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeTypedArrayClampArgumentToStartOrEndCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeTypedArrayClampArgumentToStartOrEndCodeLength = 283;
static const JSC::Intrinsic s_typedArrayPrototypeTypedArrayClampArgumentToStartOrEndCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeTypedArrayClampArgumentToStartOrEndCode =
s_JSCCombinedCode + 126836
;

const JSC::ConstructAbility s_typedArrayPrototypeTypedArraySpeciesConstructorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_typedArrayPrototypeTypedArraySpeciesConstructorCodeConstructorKind = JSC::ConstructorKind::None;
const int s_typedArrayPrototypeTypedArraySpeciesConstructorCodeLength = 483;
static const JSC::Intrinsic s_typedArrayPrototypeTypedArraySpeciesConstructorCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_typedArrayPrototypeTypedArraySpeciesConstructorCode =
s_JSCCombinedCode + 127119
;

const JSC::ConstructAbility s_mapPrototypeValuesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_mapPrototypeValuesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_mapPrototypeValuesCodeLength = 194;
static const JSC::Intrinsic s_mapPrototypeValuesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_mapPrototypeValuesCode =
s_JSCCombinedCode + 127602
;

const JSC::ConstructAbility s_setPrototypeValuesCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_setPrototypeValuesCodeConstructorKind = JSC::ConstructorKind::None;
const int s_setPrototypeValuesCodeLength = 194;
static const JSC::Intrinsic s_setPrototypeValuesCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_setPrototypeValuesCode =
s_JSCCombinedCode + 127796
;


#define DEFINE_BUILTIN_GENERATOR(codeName, functionName, overriddenName, argumentCount) \
JSC::FunctionExecutable* codeName##Generator(JSC::VM& vm) \
{\
    return vm.builtinExecutables()->codeName##Executable()->link(vm, nullptr, vm.builtinExecutables()->codeName##Source(), WTF::nullopt, s_##codeName##Intrinsic); }
JSC_FOREACH_BUILTIN_CODE(DEFINE_BUILTIN_GENERATOR)
#undef DEFINE_BUILTIN_GENERATOR


} // namespace JSC
